// $Id: JABngAway_Form.java,v 1.1.1.1 1998/07/29 12:38:16 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/clients/Jabngaway/JABngAway_Form.java,v $
//
// $Log: JABngAway_Form.java,v $
// Revision 1.1.1.1  1998/07/29 12:38:16  mencnar
// initial revision
//
//
// Author: Daniel Mencnarowski (mencnar@ics.agh.edu.pl)
//

package pl.edu.agh.ics.abngcore;

import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;

class JABngAway_Form extends JPanel 
                     implements ActionListener,
                                Runnable
{
  private JPanel away_panel;
  private JPanel user_info_panel;
  private JLabel user_id_label;
  private JLabel forename_label, surname_label;
  private JLabel phone_label, email_label;
  private JLabel position_label;
  private JTextField user_id_field;
  private JTextField forename_field, surname_field;
  private JTextField phone_field, email_field;
  private JTextField position_field;
  private GridBagLayout gridbag;
    
  private JPanel away_info_panel;
  private JCheckBox active_check;
  private JLabel start_time_label, stop_time_label, cancel_time_label;
  private JABng_Calendar start_time_cal, stop_time_cal, cancel_time_cal;
  private JCheckBox badge_cancels_check;
  private GridBagLayout awaybag;

  private JLabel message_label, contact_label;
  private JTextField message_field, contact_field;
  private JPanel message_info_panel;
  private GridBagLayout messagebag;

  private JPanel button_panel;
  private JButton add_button, update_button, remove_button, 
                  commit_button, cancel_button;
  private JABng_Locatable_User user_combo;
  private JButton user_button;
  private Domain_Repository.UserPackage.Description current_user= null;
  private MyAway tmpaway= null;
  private MyAway currentaway= null;
  private JABngAway_Main mp;

  private static final int ST_NONE= -1;
  private static final int ST_VIEW= 0;
  private static final int ST_ADD= 1;
  private static final int ST_UPDATE= 2;
  
  private int state = ST_NONE;
  
  public JABngAway_Form( JABngAway_Main mp) {
    this.mp= mp;
    setLayout( new FlowLayout());

    button_panel= new JPanel();
    button_panel.setLayout( new BoxLayout( button_panel, BoxLayout.Y_AXIS));
    button_panel.add( add_button= new JButton( "Add"));
    add_button.addActionListener( this);
    add_button.setActionCommand( "Add");
    button_panel.add( update_button= new JButton( "Update"));
    update_button.addActionListener( this);
    update_button.setActionCommand( "Update");
    button_panel.add( remove_button= new JButton( "Remove"));
    remove_button.addActionListener( this);
    remove_button.setActionCommand( "Remove");
    button_panel.add( Box.createVerticalStrut( 30));
    button_panel.add( commit_button= new JButton( "Commit"));
    commit_button.addActionListener( this);
    commit_button.setActionCommand( "Commit");
    commit_button.setEnabled( false);
    button_panel.add( cancel_button= new JButton( "Cancel"));
    cancel_button.addActionListener( this);
    cancel_button.setActionCommand( "Cancel");
    cancel_button.setEnabled( false);
    add( button_panel);

    away_panel= new JPanel();
    away_panel.setLayout( new BoxLayout( away_panel, BoxLayout.Y_AXIS));
    user_info_panel= new JPanel();
    user_info_panel.setLayout( gridbag= new GridBagLayout());

    GridBagConstraints c = new GridBagConstraints();

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 0;
    gridbag.setConstraints( user_id_label= new JLabel("User id") , c);
    user_info_panel.add( user_id_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    gridbag.setConstraints( user_id_field= new JTextField( 8), c);
    user_id_field.setEditable(false);
    user_info_panel.add( user_id_field);
    c.anchor= GridBagConstraints.EAST;
    c.gridx= 2;
    gridbag.setConstraints( user_button= new JButton("Accept user"), c);
    user_button.addActionListener( this);
    user_button.setActionCommand( "Accept user");
    user_info_panel.add( user_button);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 3;
    gridbag.setConstraints( user_combo= new JABng_Locatable_User(), c);
    user_info_panel.add( user_combo);

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 1;
    gridbag.setConstraints( forename_label= new JLabel("Forename(s)"), c);
    user_info_panel.add( forename_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    gridbag.setConstraints( forename_field= new JTextField( 12), c);
    forename_field.setEditable(false);
    user_info_panel.add( forename_field);
    c.anchor= GridBagConstraints.EAST;
    c.gridx= 2;
    gridbag.setConstraints( surname_label= new JLabel("Surname"), c);
    user_info_panel.add( surname_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 3;
    gridbag.setConstraints( surname_field= new JTextField( 18), c);
    surname_field.setEditable(false);
    user_info_panel.add( surname_field);

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 2;
    gridbag.setConstraints( phone_label= new JLabel("Phone"), c);
    user_info_panel.add( phone_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    gridbag.setConstraints( phone_field= new JTextField( 12), c);
    phone_field.setEditable(false);
    user_info_panel.add( phone_field);
    c.anchor= GridBagConstraints.EAST;
    c.gridx= 2;
    gridbag.setConstraints( email_label= new JLabel("E-mail"), c);
    user_info_panel.add( email_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 3;
    gridbag.setConstraints( email_field= new JTextField( 18), c);
    email_field.setEditable(false);
    user_info_panel.add( email_field);

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 3;
    gridbag.setConstraints( position_label= new JLabel("Position"), c);
    user_info_panel.add( position_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    gridbag.setConstraints( position_field= new JTextField( 12), c);
    position_field.setEditable(false);
    user_info_panel.add( position_field);

    away_panel.add( user_info_panel);

    //---------------------

    away_info_panel= new JPanel();
    away_info_panel.setLayout( awaybag= new GridBagLayout());

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 0;
    awaybag.setConstraints( active_check= new JCheckBox("Active") , c);
    active_check.setEnabled( false);
    away_info_panel.add( active_check);

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 1;
    awaybag.setConstraints( start_time_label= new JLabel("Start time") , c);
    away_info_panel.add( start_time_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    awaybag.setConstraints( start_time_cal= new JABng_Calendar(), c);
    away_info_panel.add( start_time_cal);
    
    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 2;
    awaybag.setConstraints( stop_time_label= new JLabel("Stop time") , c);
    away_info_panel.add( stop_time_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    awaybag.setConstraints( stop_time_cal= new JABng_Calendar(), c);
    away_info_panel.add( stop_time_cal);
    
    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 3;
    awaybag.setConstraints( cancel_time_label= new JLabel("Cancel from ") , c);
    away_info_panel.add( cancel_time_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    awaybag.setConstraints( cancel_time_cal= new JABng_Calendar(), c);
    away_info_panel.add( cancel_time_cal);

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 2;
    awaybag.setConstraints( badge_cancels_check= new JCheckBox( "cancel by badge", true), c);
    badge_cancels_check.setActionCommand( "cancel by badge");
    badge_cancels_check.addActionListener( this);
    away_info_panel.add( badge_cancels_check );
    away_panel.add( away_info_panel);

    message_info_panel= new JPanel();
    message_info_panel.setLayout( messagebag= new GridBagLayout());
    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 0;
    messagebag.setConstraints( message_label= new JLabel("Message:"), c);
    message_info_panel.add( message_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    messagebag.setConstraints( message_field= new JTextField( 40), c);
    message_info_panel.add( message_field);

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 1;
    messagebag.setConstraints( contact_label= new JLabel("Contact:"), c);
    message_info_panel.add( contact_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    messagebag.setConstraints( contact_field= new JTextField( 40), c);
    message_info_panel.add( contact_field);

    away_panel.add( message_info_panel);
    cancel_time_cal.setEnabled( badge_cancels_check.isSelected());
    add( away_panel);
    setState( ST_NONE);

    (new Thread( this)).start();
  }

  public synchronized void actionPerformed( ActionEvent e) {
    Object source= e.getSource();
    String cmd= e.getActionCommand();
    
    if ( source == badge_cancels_check) {
      cancel_time_cal.setEnabled( badge_cancels_check.isSelected());
    }
    else if ( source == add_button) {
      if (state != ST_VIEW && state != ST_NONE) return;
      setState( ST_ADD);
    }
    else if ( source == update_button) {
      if (state != ST_VIEW) return;
      setState( ST_UPDATE);
    }
    else if ( source == remove_button) {
      if (state != ST_VIEW) return;
      actionRemove();
    }
    else if ( source == commit_button) {
      if (state != ST_ADD && state != ST_UPDATE) return;
      if (state == ST_ADD) {
	if (!actionAdd()) return;
      }
      if (state == ST_UPDATE) {
	if (!actionUpdate()) return;
      }
      state= ST_NONE;
      privateSetData( currentaway);
    }
    else if ( source == cancel_button) {
      if (state != ST_ADD && state != ST_UPDATE) return;
      setState( ST_NONE);
      privateSetData( currentaway);
    }
    else if ( source == user_button) {
      if (state != ST_ADD && state != ST_UPDATE) return;
      Domain_Repository.UserPackage.Description user_descr=
	user_combo.getUserDescription();
      current_user= user_descr;
      if (user_descr == null) return;
      
      fillUserFields( user_descr);
    }
  }

  public void setUserSortOrder( int i) {
    user_combo.setSortOrder( i);
  }

  private void setState( int new_state) {
    switch (new_state) {
    case ST_NONE:
      add_button.setEnabled( true);
      update_button.setEnabled( false);
      remove_button.setEnabled( false);
      commit_button.setEnabled( false);
      cancel_button.setEnabled( false);
      fieldsSetEnabled( false);
      break;
    case ST_VIEW:
      add_button.setEnabled( true);
      update_button.setEnabled( true);
      remove_button.setEnabled( true);
      commit_button.setEnabled( false);
      cancel_button.setEnabled( false);
      fieldsSetEnabled( false);
      break;
    case ST_ADD:
      active_check.setSelected( false);
      start_time_cal.change_date( new java.util.Date());
      stop_time_cal.change_date( new java.util.Date());
      cancel_time_cal.change_date( new java.util.Date());
      badge_cancels_check.setSelected( true);
      message_field.setText( "");
      contact_field.setText( "");
    case ST_UPDATE:
      add_button.setEnabled( false);
      update_button.setEnabled( false);
      remove_button.setEnabled( false);
      commit_button.setEnabled( true);
      cancel_button.setEnabled( true);
      fieldsSetEnabled( true);
      break;
    }
    state= new_state;
  }

  private void fieldsSetEnabled( boolean enabled) {
    start_time_cal.setEnabled( enabled);
    stop_time_cal.setEnabled( enabled);
    cancel_time_cal.setEnabled( enabled);
    badge_cancels_check.setEnabled( enabled);
    message_field.setEditable( enabled);
    contact_field.setEditable( enabled);
    user_button.setEnabled( enabled);
    user_combo.setEnabled( enabled);
  }
  
  public synchronized void run() {
    while (true) {
      try {
	wait();
	wait(200);
      }
      catch (InterruptedException ex) {}
      privateSetData( tmpaway);
    }
  }

  public void setData( MyAway away) {
    synchronized (this) {
      tmpaway= away;
      notify();
    }
  }

  private synchronized void fillUserFields(
	Domain_Repository.UserPackage.Description user_descr ) {

    user_id_field.setText( user_descr.uid);
    forename_field.setText( user_descr.forename);
    surname_field.setText( user_descr.surname);
    phone_field.setText( user_descr.phone);
    email_field.setText( user_descr.email);
    position_field.setText( user_descr.position);    
  }

  private synchronized void privateSetData( MyAway away) {
    currentaway= away;

    if (away != null) {
      switch (state) {
      case ST_NONE:
	setState( ST_VIEW);
	break;
      case ST_VIEW:
	break;
      case ST_ADD:
      case ST_UPDATE:
	return;
      }

      Domain_Repository.UserPackage.Description user_descr=
	away.away_descr.type_specific_object_value.user_description();

      user_id_field.setText( user_descr.uid);
      forename_field.setText( user_descr.forename);
      surname_field.setText( user_descr.surname);
      phone_field.setText( user_descr.phone);
      email_field.setText( user_descr.email);
      position_field.setText( user_descr.position);
      
      active_check.setSelected( away.away_descr.active);
      start_time_cal.change_date( 
        new java.util.Date( away.away_descr.start_time.seconds*(long)1000));
      stop_time_cal.change_date( 
	new java.util.Date( away.away_descr.stop_time.seconds*(long)1000));
      cancel_time_cal.change_date(
    	new java.util.Date( away.away_descr.cancel_from_time.seconds*(long)1000));
      badge_cancels_check.setSelected( away.away_descr.cancel_by_badge);
      message_field.setText( away.away_descr.message);
      contact_field.setText( away.away_descr.contact);
    }
    else {
      switch (state) {
      case ST_NONE:
	break;
      case ST_VIEW:
	setState( ST_NONE);
	break;
      case ST_ADD:
      case ST_UPDATE:
	return;
      }

      user_id_field.setText("");
      forename_field.setText("");
      surname_field.setText("");
      phone_field.setText("");
      email_field.setText("");
      position_field.setText("");
      active_check.setSelected(false);
      start_time_cal.change_date( new java.util.Date());
      stop_time_cal.change_date( new java.util.Date());
      cancel_time_cal.change_date( new java.util.Date());
      badge_cancels_check.setSelected(true);
      message_field.setText("");
      contact_field.setText("");
    }
  }

  private ABng_Core_System._Badge_Holder find_holder() {
    int item_id= user_combo.getUserItemId();
    
    ABng_Core_System._Badge_HolderPackage.Pattern bh_patt=
      RepTools.get_bhrep_pattern();
    bh_patt.is_any= false;
    bh_patt.type_specific_object_pattern.is_any= false;
    
    Domain_Repository.UserPackage.Pattern user_patt=
      bh_patt.type_specific_object_pattern.object_pattern.user_obj_pattern();
    user_patt.is_any= false;
    user_patt.item_id_pattern.is_any= false;
    user_patt.item_id_pattern.value= item_id;
    ABng_Core_Management.Badge_Holder_Rep bhrep= null;
    try {
      bhrep= ABng_Core_Management.Badge_Holder_RepHelper.narrow(
             Bootstrap_n.resolve( Bootstrap_n.SRV_Badge_Holder_Repository()));
    }
    catch ( Exception ex) {
      JOptionPane.showMessageDialog( null,
				     "Could not find badge holder repository"+ex,
				     "Error",
				     JOptionPane.ERROR_MESSAGE);      
      return null;
    }

    try {
      ABng_Core_System._Badge_Holder []res=
	bhrep.find( bh_patt);
      if (res.length==1) return res[0];
    }
    catch (Exception ex) {
      ex.printStackTrace();
      JOptionPane.showMessageDialog( null,
				     "Could not find badge holder "+ex,
				     "Error",
				     JOptionPane.ERROR_MESSAGE);      
      return null;
    }
    JOptionPane.showMessageDialog( null,
				   "Badge holder not found",
				   "Error",
				   JOptionPane.ERROR_MESSAGE);
    return null;
  }

  private boolean actionAdd() {
    if (current_user == null) {
      JOptionPane.showMessageDialog( null,
				     "User not selected",
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    ABng_Core_Management.Away_Rep_ManagerPackage.Change_Description cd=
      new ABng_Core_Management.Away_Rep_ManagerPackage.Change_Description();
    if ((cd.away_holder= find_holder()) == null) return false;
    cd.start_time= start_time_cal.getTimeObject();
    cd.stop_time= stop_time_cal.getTimeObject();
    cd.cancel_from_time= cancel_time_cal.getTimeObject();
    cd.message= message_field.getText();
    cd.contact= contact_field.getText();
    cd.cancel_by_badge= badge_cancels_check.isSelected();
    
    try {
      mp.away_manager.add( cd);
    }
    catch (Domain_Repository.Duplicate_Data_Record ex) {
      JOptionPane.showMessageDialog( null,
				     "Duplicate data record",
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    catch (Domain_Repository.Invalid_Description ex) {
      JOptionPane.showMessageDialog( null,
				     "Invalid description",
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    catch (Domain_Repository.Destination_Unreachable ex) {
      JOptionPane.showMessageDialog( null,
				     "Destination unreachble "+ex.server_name,
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    catch (Exception ex) {
      JOptionPane.showMessageDialog( null,
				     "General error : "+ex,
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    return true;
  }

  private boolean actionRemove() {
    if ( currentaway == null) return false;
    if ( JOptionPane.showConfirmDialog( null,
					"Remove current away message",
					"Confirm",
					JOptionPane.YES_NO_OPTION) !=
	 JOptionPane.YES_OPTION) 
      return false;
    try {
      mp.away_manager.remove( currentaway.away_ref);
    }
    catch (Domain_Repository.Unknown_Object_Ref ex) {
      JOptionPane.showMessageDialog( null,
				     "Message not in the repository",
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    catch (Exception ex) {
      JOptionPane.showMessageDialog( null,
				     "General error : "+ex,
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    return true;
  }

  private boolean actionUpdate() {
    if (current_user == null) {
      JOptionPane.showMessageDialog( null,
				     "User not selected",
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    ABng_Core_Management.Away_Rep_ManagerPackage.Change_Description cd=
      new ABng_Core_Management.Away_Rep_ManagerPackage.Change_Description();
    if ((cd.away_holder= find_holder()) == null) return false;
    cd.start_time= start_time_cal.getTimeObject();
    cd.stop_time= stop_time_cal.getTimeObject();
    cd.cancel_from_time= cancel_time_cal.getTimeObject();
    cd.message= message_field.getText();
    cd.contact= contact_field.getText();
    cd.cancel_by_badge= badge_cancels_check.isSelected();
    
    try {
      mp.away_manager.update( currentaway.away_ref, cd);
    }
    catch (Domain_Repository.Duplicate_Data_Record ex) {
      JOptionPane.showMessageDialog( null,
				     "Duplicate data record",
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    catch (Domain_Repository.Invalid_Description ex) {
      JOptionPane.showMessageDialog( null,
				     "Invalid description",
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    catch (Domain_Repository.Destination_Unreachable ex) {
      JOptionPane.showMessageDialog( null,
				     "Destination unreachble "+ex.server_name,
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    catch (Exception ex) {
      JOptionPane.showMessageDialog( null,
				     "General error : "+ex,
				     "Error",
				     JOptionPane.ERROR_MESSAGE);
      return false;
    }
    return true;
  }
};


