// $Id: JABng_Locatable_User.java,v 1.1.1.1 1998/07/29 12:38:16 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/clients/Jabngaway/JABng_Locatable_User.java,v $
//
// $Log: JABng_Locatable_User.java,v $
// Revision 1.1.1.1  1998/07/29 12:38:16  mencnar
// initial revision
//
//
// Author: Daniel Mencnarowski (mencnar@ics.agh.edu.pl)
//

package pl.edu.agh.ics.abngcore;

import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;


class JABng_Combo_Chooser implements KeyListener
{
  private JComboBox box;
  private JTextField edit_field;
  private String tx= null;

  public JABng_Combo_Chooser (JComboBox box) {
    this.box= box;
    edit_field= (JTextField) box.getEditor().getEditorComponent();
    edit_field.addKeyListener( this);
  }

  public void keyTyped(KeyEvent e) {}
  public void keyPressed(KeyEvent e) {}

  public void keyReleased( KeyEvent evt) {
    String tx= edit_field.getText();
    int len= (tx == null) ? 0 : tx.length();
    if ((evt.getKeyCode() == KeyEvent.VK_UP) ||
	(evt.getKeyCode() == KeyEvent.VK_DOWN) ||
	(evt.getKeyCode() == KeyEvent.VK_LEFT) ||
	(evt.getKeyCode() == KeyEvent.VK_RIGHT) ||
	(evt.getKeyCode() == KeyEvent.VK_SHIFT) ||
	(evt.getKeyCode() == KeyEvent.VK_DELETE) ||
	(evt.getKeyCode() == KeyEvent.VK_BACK_SPACE))
      return;
      
    if (len>0) {
      int clen= box.getItemCount();
      
      for (int i=0; i<clen; i++) {
	String item= box.getItemAt(i).toString();
	
	if (item.startsWith(tx)) {
	  box.setSelectedIndex(i);
	  box.getEditor().setItem( box.getSelectedItem());
	  
	  edit_field.select( len, item.length());
	  break;
	}
      }
    }
  }
}


public class JABng_Locatable_User extends JComboBox
                                  implements Bootstrap_listener_interface_n,
                                             Domain_Repository._Static_Data_ObserverOperations

{
  public static final int JLU_SORT_FIRST   = 0;
  public static final int JLU_SORT_UID      = 0;
  public static final int JLU_SORT_FORENAME  = 1;
  public static final int JLU_SORT_SURNAME  = 2;
  public static final int JLU_SORT_LAST    = 2;
  private int sort_order= JLU_SORT_UID;

  private Bootstrap_listener_n bootstrap_listener= null;
  private Domain_Repository.User_Rep user_rep= null;
  private Domain_Repository.UserPackage.Description descrs[]= null;
  private static Domain_Repository.Static_Data_Observer static_data_observer= null;

  public JABng_Locatable_User() {
    if (static_data_observer == null) {
      static_data_observer= 
	new Domain_Repository._tie_Static_Data_Observer( this);
      JABngAway_Main.my_orb_wrapper.connect_object( static_data_observer);
    }
    setEditable( true);
    new JABng_Combo_Chooser(this);

    try {
      user_rep= Domain_Repository.User_RepHelper.narrow
	(Bootstrap_n.resolve( Bootstrap_n.SRV_User_Repository()));

      bootstrap_listener= new Bootstrap_listener_n( this);
      bootstrap_listener.register_callback(
	     Bootstrap_n.SRV_User_Repository());
      loadData();
    }
    catch (Exception ex) {
      System.err.println("Error contacting Server Manager / User Repository");
      System.err.println(ex);
      System.exit(1);
    }    
  }

  public synchronized void setSortOrder( int so) {
    if (so<JLU_SORT_FIRST || so>JLU_SORT_LAST) return;
    sort_order= so;
    sortDescrs();
    fillCombo();
  }

  public synchronized void reference_resolved( String[] name,
					       org.omg.CORBA.Object server_ref,
					       int callback_identifier) {

    //    System.err.println("reference_resolved");
    if ( Bootstrap_n.equal_names
	 ( name, Bootstrap_n.SRV_User_Repository())) {

      Domain_Repository.User_Rep tmp= 
	Domain_Repository.User_RepHelper.narrow( server_ref);
      if (tmp != user_rep) {
	user_rep= tmp;
	loadData();
      }
    }
  }

  public void server_shutdown( String[] name,
			     int callback_identifier) {}

  public void _notify( int item_id, 
		       Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object sdo,
		      Domain_Repository.Change_Type ct) {
    notify( item_id, sdo, ct);
  }

  public void notify( int item_id, 
		      Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object sdo,
		      Domain_Repository.Change_Type ct) {

    System.err.println("User repository notify");
    loadData();
  }

  public void abort() {}

  private void sortDescrs() {
    // O(n^2 ) !!!
    for (int i=0; i<descrs.length; i++)
      for (int j=i+1; j<descrs.length; j++)
	if (stringifyItem( descrs[i]).compareTo(
		   stringifyItem( descrs[j])) >0) {
	  Domain_Repository.UserPackage.Description tmp=
	    descrs[i];
	  descrs[i]= descrs[j];
	  descrs[j]= tmp;
	}
  }

  private String stringifyItem(  Domain_Repository.UserPackage.Description d) {
    switch (sort_order) {
    case JLU_SORT_UID:
      return d.uid+" "+d.forename+" "+d.surname;
    case JLU_SORT_FORENAME:
      return d.forename+" "+d.surname+" "+d.uid;
    case JLU_SORT_SURNAME:
      return d.surname+" "+d.forename+" "+d.uid;
    }
    return "";
  }

  public synchronized void fillCombo() {
    removeAllItems();
    if (descrs!= null)
      for (int i=0; i<descrs.length; i++) {
	addItem( stringifyItem(descrs[i]));
      }
  }

  public synchronized void loadData() {
    //    System.err.println( "loadData (user)");
    try {
      Domain_Repository.UserPackage.Pattern user_patt=
	RepTools.get_urep_pattern();

      Domain_Repository.UserPackage.Entity_Set es=
	new Domain_Repository.UserPackage.Entity_Set();
      es.s_pattern( user_patt);

      Domain_Repository.Query_Options qo=
	new Domain_Repository.Query_Options();
      qo.return_references= false;
      qo.return_descriptions= false;
      qo.return_value_descriptions= true;
      qo.do_attach= true;
      qo.do_detach= false;

      Domain_Repository.UserPackage.Query_Results qr=
	user_rep.complex_query( es, qo, static_data_observer);
      user_rep.attach_add_static_data_observer( static_data_observer);
      int len= qr.r_value_descriptions.length;
      descrs= qr.r_value_descriptions;
      //      System.err.println( len);
      sortDescrs();
      fillCombo();
    }
    catch (Exception ex) {}
  }

  public int getUserItemId() {
    Object obj= getSelectedItem();
    if (obj == null) return 0;
    String s= obj.toString();

    for (int i=0; i<descrs.length; i++)
      if (stringifyItem( descrs[i]).equals( s)) return descrs[i].item_id;
    return 0;
  }

  public Domain_Repository.UserPackage.Description getUserDescription() {
    Object obj= getSelectedItem();
    if (obj == null) return null;
    String s= obj.toString();

    for (int i=0; i<descrs.length; i++)
      if (stringifyItem( descrs[i]).equals( s)) return descrs[i];
    return null;
  }
}


