package ABngSystem;
  
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;


import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

/////////////////////////////////
/* Main window of the application
   that manage hte repositorys list
   and user input  */
////////////////////////////////


class ABngMainWnd extends JFrame{

   String[] repositorylist;
   JList datalist;
   JButton exit;
   int replist[];
   RepGet rep;
   Window wnd;

  public static pl.edu.agh.ics.abngcore.ORB_wrapper my_orb_wrapper;

   public ABngMainWnd(){
      super("Repository Menager");
      setBackground(Color.lightGray);
      setFont(new Font("Dialog", Font.PLAIN, 14));
      setSize(250,318);
      setResizable(false);
      addWindowListener(new AppClose());
      this.wnd = this;
      rep = new RepGet();
      JPanel pane = new JPanel();
      pane.setLayout(null);
// Layout = null to lay down the componetns manualy

      JLabel lab = new JLabel("Repositories", JLabel.CENTER);
      lab.setSize(210,20);
      lab.setLocation(15, 10);
      lab.setFont(new Font("Dialog", Font.PLAIN, 16));
      pane.add(lab);
      lab = new JLabel("currently available:", JLabel.CENTER);
      lab.setSize(210,20);
      lab.setLocation(15, 30);
      lab.setFont(new Font("Dialog", Font.PLAIN, 16));
      pane.add(lab);


      repositorylist = rep.listRepositories();
      datalist = new JList(repositorylist);
      datalist.setFont(new Font("Dialog", Font.PLAIN, 16));
      datalist.setLocation(0,0);
      datalist.setToolTipText("DubleClick to activate");
      datalist.addMouseListener(new ItemClicked());
      JScrollPane scrollist = new JScrollPane(datalist);
      scrollist.setSize(210,170);
      scrollist.setLocation(15,60);
      pane.add(scrollist);
      exit = new JButton("Exit ABng System");
      exit.setSize(210,40);
      exit.setLocation(15,240);
      exit.addActionListener(new ExitClicked());
      pane.add(exit);

      setContentPane(pane);
      setVisible(true);
   }

////////////////////////////////////////////////
/* Class that's responsible for closing the main 
   window and exiting application */
///////////////////////////////////////////

   protected static final class AppClose extends WindowAdapter {
      public void windowClosing(WindowEvent e) {
         System.exit(0);
         super.windowClosing(e);
     	}
   }


///////////////////////////////////////////////
/* Class that's responsible for running new 
   repository window after dubleclick on an item */
/////////////////////////////////////////////////

   protected final class ItemClicked extends MouseAdapter{
      public void mouseClicked(MouseEvent e){
         if (e.getClickCount() == 2){
            int index = datalist.locationToIndex(e.getPoint());
            if (index != -1){
               wnd.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               new RepositoryDialog(repositorylist[index]);
            }
         }
         super.mouseClicked(e);
      }
   }

///////////////////////////////////
/* Class for click "Exit" button */
///////////////////////////////////

   protected final class ExitClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         System.exit(0);
      }
   }

////////////////////////////////////////
/* main() method that just creating new 
   ABngMainWnd object */
//////////////////////////////////////

   public static void main(String args[]){
    my_orb_wrapper= new pl.edu.agh.ics.abngcore.ORB_wrapper();

    my_orb_wrapper.init_application( args);

      ABngMainWnd mwnd = new ABngMainWnd();
/*      try {
//"com.sun.java.swing.plaf.motif.MotifLookAndFeel"
//"com.sun.java.swing.plaf.metal.MetalLookAndFeel"
//"com.sun.java.swing.plaf.windows.WindowsLookAndFeel"
	 	   UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel" );
   		SwingUtilities.updateComponentTreeUI(mwnd);
         }
      catch (Exception exc) {
   		System.err.println("Could not load LookAndFeel: ");
      }*/
   }
}

//////////////////////////////////////////////////////
/* Supporting class for other windows that are visible
   on the screen. It just closing the window */
////////////////////////////////////////////////////

final class WndClose extends WindowAdapter{
   public void windowClosing(WindowEvent e) {
      ((Window) e.getSource()).dispose();
      super.windowClosing(e);
  	}
}

