package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

//////////////////////////////////////
/* Class that's a part of four windows in
   the repository window. With this panel user
   can view the repository and its items.
   User can update item with "Updata" button
   remove item with "Remove" button and 
   close the window with "Close" button */
//////////////////////////////////////////

class BrowsePanel extends JPanel{

   JList itemlist;
   String[] items;
   JButton update;
   JButton remove;
   ItemPanel sensorpanel;

   Window parent;
   int lastindex;
   JPanel wnd;
   String repname;
   RepGet repository;
   org.omg.CORBA.Object[] sarray;
   org.omg.CORBA.Object object;

   public BrowsePanel(Window parent, String repname, RepGet rep){

// CHECK THE BACKGROUND COLOR
//      setBackground(Color.lightGray);
      setSize(595,370);
      setLayout(null);
      this.parent = parent;
      lastindex = -1;
      wnd = this;
      this.repname = repname;
      this.repository = rep;
      object = null;

      RGContainer rg = repository.listRG();
      if (rg.IsError()) 
         JOptionPane.showMessageDialog(parent, rg.GetErrorText(), "List Repository Error", JOptionPane.ERROR_MESSAGE);
      sarray = rg.GetObjects();
      items = rg.GetStrings();
      itemlist = new JList(items);
      itemlist.setLocation(0,0);
      itemlist.setToolTipText("Click to view item");
      itemlist.addMouseListener(new ItemClicked());
      itemlist.addListSelectionListener(new ItemChanged());
      JScrollPane scrollpane = new JScrollPane(itemlist);
      scrollpane.setSize(200,350);
      scrollpane.setLocation(10,10);
      add(scrollpane);

      ButtonClicked bc = new ButtonClicked();
      update = new JButton("Update");
      update.setSize(125,25);
      update.setLocation(260,335);
      update.addActionListener(bc);
      update.setToolTipText("Update selected item");
      update.setEnabled(false);
      add(update);
      remove = new JButton("Remove");
      remove.setSize(125,25);
      remove.setLocation(420,335);
      remove.addActionListener(bc);
      remove.setToolTipText("Remove selected item");
      remove.setEnabled(false);
      add(remove);

      if (repname.equals(RepName.userRep)) 
         sensorpanel = new UserPanel(false, 0, parent);
      else if (repname.equals(RepName.sensorRep)) 
         sensorpanel = new SensorPanel(false, 0, parent);
      else if (repname.equals(RepName.badgeRep))
         sensorpanel = new BadgePanel(false, 0, parent);
      else if (repname.equals(RepName.holderRep))
         sensorpanel = new HolderPanel(false, 0, parent);
      else if (repname.equals(RepName.locationTypeRep))
         sensorpanel = new LocationTypePanel(false, 0, parent);
      else if (repname.equals(RepName.locationDescRep))
         sensorpanel = new LocationDescPanel(false, 0, parent);
      else if (repname.equals(RepName.abngldRep))
         sensorpanel = new AbngldPanel(false, 0, parent);
      else if (repname.equals(RepName.viewRep))
         sensorpanel = new ViewPanel(false, 0, parent);
      sensorpanel.setLocation(220,10);
      add(sensorpanel);
   }
   
   public void updateList(){
      RGContainer rg = repository.listRG();
      if (rg.IsError())
         JOptionPane.showMessageDialog(parent, rg.GetErrorText(), "List Repository Error", JOptionPane.ERROR_MESSAGE);
      sarray = rg.GetObjects();
      items = rg.GetStrings();
      itemlist.setListData(items);
      itemlist.repaint();
      itemlist.revalidate();
      lastindex = -1;
      sensorpanel.clear();
   }
   
   public void selectItem(int itemid){
      
      int i;

      parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
      if (repname.equals(RepName.sensorRep)){
         Sensor temp;
         for ( i=0; i<sarray.length; i++){
            temp = SensorHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.badgeRep)){
         Badge temp;
         for ( i=0; i<sarray.length; i++){
            temp = BadgeHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.holderRep)){
         _Badge_Holder temp;
         for ( i=0; i<sarray.length; i++){
            temp = _Badge_HolderHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.userRep)){
         Domain_Repository.User temp;
         for ( i=0; i<sarray.length; i++){
            temp = Domain_Repository.UserHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.locationTypeRep)){
         Domain_Repository.Location_Type temp;
         for ( i=0; i<sarray.length; i++){
            temp = Domain_Repository.Location_TypeHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.locationDescRep)){
         Domain_Repository.Location_Description temp;
         for ( i=0; i<sarray.length; i++){
            temp = Domain_Repository.Location_DescriptionHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.abngldRep)){
         ABng_Core_System.ABng_Location_Description temp;
         for ( i=0; i<sarray.length; i++){
            temp = ABng_Core_System.ABng_Location_DescriptionHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.viewRep)){
      }
      itemlist.repaint();
      object = null;
      parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
   }
   
   public org.omg.CORBA.Object getObject() { return object; }

// Hmmm... Is it really necessary?

   protected final class ItemClicked extends MouseAdapter{
      public void mouseClicked(MouseEvent e){
         if (e.getClickCount() == 2){
            int index = itemlist.locationToIndex(e.getPoint());
            if (index!=-1) {
//               System.out.println(items.elementAt(index));
            }
         }
         super.mouseClicked(e);
      }
   }

//////////////////////////////////////
/* This class response when the user 
   click on an item */
//////////////////////////////////////

   protected final class ItemChanged implements ListSelectionListener{
      public void valueChanged(ListSelectionEvent e){
         int index = itemlist.getSelectedIndex();
         if ((lastindex!=index) && (index!=-1)){
            lastindex = index;
            sensorpanel.setData(sarray[lastindex]);
            object = sarray[lastindex];
            update.setEnabled(true);
            remove.setEnabled(true);
         }
      }
   }

////////////////////////////////
/* Class for buttons actions. */
////////////////////////////////

   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == update){
// Clicked "Update" so show another window and allow
// user to make changes
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            UpdateDialog dlg = new UpdateDialog(parent, repname, repository, sarray[lastindex]);
            if (dlg.getAnswer()) {
               if (parent.getClass().getName().equals("RepositoryDialog")) 
                  ((RepositoryDialog)parent).updateList();
               else ((RepositoryReferenceDialog)parent).updateList();
               remove.setEnabled(false);
               update.setEnabled(false);
            } 
            dlg.dispose();
            SwingUtilities.updateComponentTreeUI(parent);
         } else if (((JButton) e.getSource()) == remove){
// Let's make sure that you really want to remove this item
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (JOptionPane.showConfirmDialog(parent, 
                  "Are You sure You want to remove this item", 
                  "Remove Confirmation",
                  JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
               org.omg.CORBA.Object otemp = sarray[lastindex];
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               String mesg = repository.remove(otemp);
               if (mesg.compareTo("OK") != 0){
                  JOptionPane.showMessageDialog(parent, mesg, "Can't remove item", JOptionPane.ERROR_MESSAGE);
               } else JOptionPane.showMessageDialog(parent, "Operation successfully", "Remove OK", JOptionPane.INFORMATION_MESSAGE);
               if (parent.getClass().getName().equals("RepositoryDialog")) 
                  ((RepositoryDialog)parent).updateList();
               else ((RepositoryReferenceDialog)parent).updateList();
               sensorpanel.clear();
               remove.setEnabled(false);
               update.setEnabled(false);
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
            SwingUtilities.updateComponentTreeUI(parent);
         }
      }
   }
}


