package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

///////////////////////////////////////
/* Class that's a part of four panels in the
   repository window. FindPanel for finding
   items that match the quarry. Item form and
   Find, Clear and Close buttons */
////////////////////////////////////////

class FindPanel extends JPanel{

   JList itemlist;
   String[] items;
   JButton find;
   JButton clear;
   ItemPanel sensorpanel;

   Window parent;
   String repname;
   RepGet repository;
   org.omg.CORBA.Object[] sarray;
   org.omg.CORBA.Object object;
   int lastindex;

   public FindPanel(Window parent, String repname, RepGet rep){

// CHECK THE BACKGROUND COLOR
//      setBackground(Color.lightGray);
      setSize(595,370);
      setLayout(null);
      this.parent = parent;
      this.repname = repname;
      this.repository = rep;
      object = null;
      lastindex = -1;

      items = new String[0];
      itemlist = new JList(items);
      itemlist.setLocation(0,0);
      itemlist.setToolTipText("DoubleClick to view item");
      itemlist.addMouseListener(new ItemClicked());
      itemlist.addListSelectionListener(new ItemChanged());
      JScrollPane scrollpane = new JScrollPane(itemlist);
      scrollpane.setSize(200,350);
      scrollpane.setLocation(385,10);
      add(scrollpane);

      ButtonClicked bc = new ButtonClicked();
      find = new JButton("Find");
      find.setSize(125,25);
      find.setLocation(50,335);
      find.addActionListener(bc);
      find.setToolTipText("Find items that match the quarry");
      find.setEnabled(true);
      add(find);
      clear = new JButton("Clear");
      clear.setSize(125,25);
      clear.setLocation(210,335);
      clear.addActionListener(bc);
      clear.setToolTipText("Clear form");
      clear.setEnabled(true);
      add(clear);

      if (repname.equals(RepName.userRep))
         sensorpanel = new UserPanel(true, 2, parent);
      else if (repname.equals(RepName.sensorRep))
         sensorpanel = new SensorPanel(true, 2, parent);
      else if (repname.equals(RepName.badgeRep))
         sensorpanel = new BadgePanel(true, 2, parent);
      else if (repname.equals(RepName.holderRep))
         sensorpanel = new HolderPanel(true, 2, parent);
      else if (repname.equals(RepName.locationTypeRep))
         sensorpanel = new LocationTypePanel(true, 2, parent);
      else if (repname.equals(RepName.locationDescRep))
         sensorpanel = new LocationDescPanel(true, 2, parent);
      else if (repname.equals(RepName.abngldRep))
         sensorpanel = new AbngldPanel(true, 2, parent);
      else if (repname.equals(RepName.viewRep))
         sensorpanel = new ViewPanel(true, 2, parent);
      sensorpanel.setLocation(10,10);
      add(sensorpanel);
   }
   
   public org.omg.CORBA.Object getObject() { return object; }

////////////////////////////////////////////
/* When the user clicked on an item that was
   find last */
/////////////////////////////////////////////

   protected final class ItemClicked extends MouseAdapter{
      public void mouseClicked(MouseEvent e){
         if (e.getClickCount() == 2){
            int index = itemlist.locationToIndex(e.getPoint());
            if (index!=-1) {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               ViewDialog dlg = new ViewDialog(parent, repname, sarray[index]);
               if (dlg.getAnswer()){ 
                  find.doClick();
               }
               dlg.dispose();
            }
         }
         super.mouseClicked(e);
      }
   }


// Hmmm.... Let me think about it...
   protected final class ItemChanged implements ListSelectionListener{
      public void valueChanged(ListSelectionEvent e){
         int index = itemlist.getSelectedIndex();
         if ((lastindex!=index) && (index!=-1)){
            lastindex = index;
            object = sarray[lastindex];
         }
      }
   }
 
/////////////////////////////////
/* Reaction for button clicked */
/////////////////////////////////
 
   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == clear){
            sensorpanel.clear();
         }
         else if (((JButton) e.getSource()) == find){
 
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            RGContainer rg = null;
            if (repname.equals(RepName.sensorRep)){
               rg = repository.find(((SensorPanel) sensorpanel).buildPattern());
            } else if (repname.equals(RepName.badgeRep)){
               try {
                  rg = repository.find(((BadgePanel) sensorpanel).buildPattern());
               } catch (NumberFormatException ex){
                  rg = new RGContainer();
                  rg.SetErrorText("Please enter a valid number as badgeID");
               }
            } else if (repname.equals(RepName.holderRep)){
               rg = repository.find(((HolderPanel) sensorpanel).buildPattern());
            } else if (repname.equals(RepName.userRep)){
               rg = repository.find(((UserPanel) sensorpanel).buildPattern());
            } else if (repname.equals(RepName.locationTypeRep)){
               rg = repository.find(((LocationTypePanel) sensorpanel).buildPattern());
            } else if (repname.equals(RepName.locationDescRep)){
               rg = new RGContainer();
               rg.SetErrorText("Not supported");
            } else if (repname.equals(RepName.abngldRep)){
               rg = new RGContainer();
               rg.SetErrorText("Not supported");
//               rg = repository.find(((AbngldPanel) sensorpanel).buildPattern());
            } else if (repname.equals(RepName.viewRep)){
               rg = new RGContainer();
               rg.SetErrorText("Not supported");
            }
            if (rg.IsError())
               JOptionPane.showMessageDialog(parent, rg.GetErrorText(), "List Repository Error", JOptionPane.ERROR_MESSAGE);
            sarray = rg.GetObjects();
            items = rg.GetStrings();
            itemlist.setListData(items);
            lastindex = -1;
            itemlist.repaint();
            itemlist.revalidate();
            parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
         }
      }
   }
}

