package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
 
import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

//////////////////////////////////////////////////
/* This class represents a graphic "part" of itch badge holder
   It just shows holder's fields to user. 
   Few methods to manage this fields */
///////////////////////////////////////

class HolderPanel extends ItemPanel{
   
   JButton mybutton;
   JButton currentbutton;
   JButton sensorbutton;
   JButton ltsobutton;

   Badge mybadge;
   Badge currentbadge;
   Sensor homesensor;
   ABng_Core.Locatable_Type_Specific_Object ltso;
   org.omg.CORBA.Object object;

   ABng_Core_System.BadgePackage.Pattern mypattern;
   ABng_Core_System.BadgePackage.Pattern currentpattern;
   ABng_Core_System.SensorPackage.Pattern sensorpattern;
   ABng_Core.Locatable_Type_Specific_Object_Pattern ltsopattern;
  Domain_Repository.Boolean_Pattern boolpattern=
   new Domain_Repository.Boolean_Pattern( true, false);

   boolean state;
   int type;
   Window parent;
   ButtonGroup bg;
   JRadioButton userrb;
   JRadioButton equipmentrb;
  JCheckBox visitor_check, valid_visitor_check;

   public HolderPanel(boolean state, int type, Window parent){

      JPanel pane = new JPanel();
      pane.setLayout(null);
      this.state = state;
      this.type = type;
      this.parent = parent;
      object = null;

      JLabel label;
      label = new JLabel("My Badge Reference:");
      label.setSize(330,15);
      label.setLocation(10,10);
      pane.add(label);
      label = new JLabel("Current Badge Reference:");
      label.setSize(330,15);
      label.setLocation(10,60);
      pane.add(label);
      label = new JLabel("Home Sensor Reference:");
      label.setSize(330,15);
      label.setLocation(10,110);
      pane.add(label);
      label = new JLabel("Special Reference:");
      label.setSize(330,15);
      label.setLocation(10,160);
      pane.add(label);

      HolderClicked hc = new HolderClicked();
      mybutton = new JButton("< EMPTY >");
      mybutton.setSize(315,20);
      mybutton.setLocation(25,30);
      mybutton.setEnabled(state);
      mybutton.addActionListener(hc);
      pane.add(mybutton);
      mybadge = null;
      mybutton.setText(RepGet.DescriptBadge(mybadge));
      currentbutton = new JButton("< EMPTY >");
      currentbutton.setSize(315,20);
      currentbutton.setLocation(25,80);
      currentbutton.setEnabled(state);
      currentbutton.addActionListener(hc);
      pane.add(currentbutton);
      currentbadge = null;
      currentbutton.setText(RepGet.DescriptBadge(currentbadge));
      sensorbutton = new JButton("< EMPTY >");
      sensorbutton.setSize(315,20);
      sensorbutton.setLocation(25,130);
      sensorbutton.setEnabled(state);
      sensorbutton.addActionListener(hc);
      pane.add(sensorbutton);
      homesensor = null;
      sensorbutton.setText(RepGet.DescriptSensor(homesensor));

      userrb = new JRadioButton(" User");
      userrb.setSize(315,20);
      userrb.setLocation(25,180);
      userrb.setEnabled(state);
      userrb.setSelected(true);
      pane.add(userrb);
      equipmentrb = new JRadioButton(" Equipment");
      equipmentrb.setSize(315,20);
      equipmentrb.setLocation(25,200);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// if you ever make equipment repository please change this for setEnabled(state) and make listener for this buttons
      equipmentrb.setEnabled(false);
      pane.add(equipmentrb);
      bg = new ButtonGroup();
      bg.add(userrb);
      bg.add(equipmentrb);
      ltsobutton = new JButton("< EMPTY >");
      ltsobutton.setSize(315,20);
      ltsobutton.setLocation(25,220);
      ltsobutton.setEnabled(state);
      ltsobutton.addActionListener(hc);
      pane.add(ltsobutton);

      visitor_check = new JCheckBox("Assigned");
      visitor_check.setSize(150,20);
      visitor_check.setLocation(25,250);
      pane.add(visitor_check);
      valid_visitor_check = new JCheckBox("Visitor");
      valid_visitor_check.setSize(150,20);
      valid_visitor_check.setLocation(200,250);
      pane.add(valid_visitor_check);

      ltso = null;
      ltsobutton.setText(RepGet.DescriptLTSO(ltso));

      mypattern = RepGet.BuildBadgePattern("", new byte[0]);
      currentpattern = RepGet.BuildBadgePattern("", new byte[0]);
      sensorpattern = RepGet.BuildSensorPattern("", "", "", "");
      ltsopattern = RepGet.BuildLTSOPattern(ABng_Core.Locatable_Type.LOCATABLE_USER, RepGet.BuildUserPattern("", "", "", "", "", "", ""));

      if (type == 2) {
         mybutton.setText("Badge Pattern");
         currentbutton.setText("BadgePattern");
         sensorbutton.setText("Sensor Pattern");
         ltsobutton.setText("LacationTypeSpecificObject Pattern");
      }
      pane.setPreferredSize(new Dimension(360,250));
      add(pane);
      this.setViewportView(pane);
   }

// Get each of the fields
   public Badge getMyBadge() { return mybadge; }
   public Badge getCurrentBadge() { return currentbadge; }
   public Sensor getHomeSensor() { return homesensor; }
   public ABng_Core.Locatable_Type_Specific_Object getLTSO() { return ltso; }
   public ABng_Core.Locatable_Type getType() { 
      if (userrb.isSelected()) return ABng_Core.Locatable_Type.LOCATABLE_USER;
      else return ABng_Core.Locatable_Type.LOCATABLE_EQUIPMENT;
   }
  public boolean getVisitor() { return visitor_check.isSelected(); }
  public boolean getValidVisitor() { return valid_visitor_check.isSelected();}

//Set each of the fields
   public void setMyBadge(Badge badge) { mybadge = badge; }
   public void setCurrentBadge(Badge badge) { currentbadge = badge; }
   public void setHomeSensor(Sensor sensor) { homesensor = sensor; }

//Clear all fields
   public void clear(){
      mybadge = null;
      mybutton.setText(RepGet.DescriptBadge(mybadge));
      currentbadge = null;
      currentbutton.setText(RepGet.DescriptBadge(currentbadge));
      homesensor = null;
      sensorbutton.setText(RepGet.DescriptSensor(homesensor));
      ltso = null;
      ltsobutton.setText(RepGet.DescriptLTSO(ltso));
      visitor_check.setSelected(false);
      valid_visitor_check.setSelected(false);
      if (type == 2) {
         mybutton.setText("Badge Pattern");
         currentbutton.setText("BadgePattern");
         sensorbutton.setText("Sensor Pattern");
         ltsobutton.setText("LacationTypeSpecificObject Pattern");
      }

   }

//Check if all fields are filled
   public boolean check(){
//      if (mybadge == null) return false;
//      if (currentbadge == null) return false;
//      if (homesensor == null) return false;
      return true;
   }

// Just copy the content of source badge
   public void copy(ItemPanel source){
      
   }

// Set data in form
   public void setData(org.omg.CORBA.Object source){

      _Badge_Holder holder = _Badge_HolderHelper.narrow(source);
      object = source;

      try {
         mybadge = holder.my_badge();
         if (mybadge == null) {
            mybutton.setEnabled(state);
         } else {
            mybutton.setEnabled(true);
         }
      } catch(Exception e) { 
         mybadge = null;
         mybutton.setEnabled(state); 
      }
      mybutton.setText(RepGet.DescriptBadge(mybadge));
      try {
         currentbadge = holder.current_badge();
         if (currentbadge == null) {
            currentbutton.setEnabled(state);
         } else {
            currentbutton.setEnabled(true);
         }
      } catch(Exception e) { 
         currentbadge = null;
         currentbutton.setEnabled(state); 
      }
      currentbutton.setText(RepGet.DescriptBadge(currentbadge));
      try {
         homesensor = holder.home_sensor();
         if (homesensor == null) {
            sensorbutton.setEnabled(state);
         } else {
            sensorbutton.setEnabled(true);
         }
      } catch(Exception e) { 
         homesensor = null;
         sensorbutton.setEnabled(state); 
      }
      sensorbutton.setText(RepGet.DescriptSensor(homesensor));
      try {
         ltso = holder.type_specific_object();
         if (ltso == null) {
            ltsobutton.setEnabled(state);
         } else {
            ltsobutton.setEnabled(true);
	    boolean is_user_obj= false;
	    try {
	      ltso.user_obj();
	      is_user_obj= true;
	    }
	    catch (Exception ex) {}
            if (is_user_obj) {
               userrb.setSelected(true);
            } else {
               equipmentrb.setSelected(true);
            }
         }
      } catch(Exception e) {
         ltso = null;
         ltsobutton.setEnabled(state);
      }
      ltsobutton.setText(RepGet.DescriptLTSO(ltso));
      try {
	visitor_check.setSelected( holder.assigned());
	valid_visitor_check.setSelected( holder.visitor());
      }
      catch (Exception ex) {}
   }

// Build pattern for find function
   public ABng_Core_System._Badge_HolderPackage.Pattern buildPattern(){
      return RepGet.BuildBadgeHolderPattern("", mypattern, currentpattern, sensorpattern, ltsopattern, boolpattern, boolpattern);
   }

/////////////////////////////////
/* Reaction for button clicked */
/////////////////////////////////

   protected final class HolderClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == mybutton){
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (type == 0) {
               ViewDialog dlg = new ViewDialog(parent, RepName.badgeRep, mybadge);
               if (dlg.getAnswer()){
                  RepGet repository = new RepGet();
                  repository.init(RepName.holderRep);
                  repository.update(object, dlg.getObject(), currentbadge, homesensor, ltso, getVisitor(), getValidVisitor());
                  setData(object);
               }
               dlg.dispose();
            } else if (type == 1) {
               RepositoryReferenceDialog dlg = null;
               if (mybadge == null)
                  dlg = new RepositoryReferenceDialog(parent, RepName.badgeRep);
               else dlg = new RepositoryReferenceDialog(parent, RepName.badgeRep, mybadge.item_id());
               if (dlg.getAnswer()){
                  mybadge = BadgeHelper.narrow(dlg.getObject());
                  if (mybadge == null) {
                     mybutton.setEnabled(false);
                  } else {
                     mybutton.setEnabled(true);
                  }
                  mybutton.setText(RepGet.DescriptBadge(mybadge));
               }
               dlg.dispose();
            } else if (type == 2) {
               FindDialog dlg = new FindDialog(parent, RepName.badgeRep);
               if (dlg.getAnswer()){ 
                  mypattern = ((BadgePanel) dlg.getPanel()).buildPattern();
               }
               dlg.dispose();
            }
            parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
         } else if (((JButton) e.getSource()) == currentbutton){
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (type == 0) {
               ViewDialog dlg = new ViewDialog(parent, RepName.badgeRep, currentbadge);
               if (dlg.getAnswer()){
                  RepGet repository = new RepGet();
                  repository.init(RepName.holderRep);
                  repository.update(object, mybadge, dlg.getObject(), homesensor, ltso, getVisitor(), getValidVisitor()); 
                  setData(object);
               }
               dlg.dispose();
            } else if (type == 1) {
               RepositoryReferenceDialog dlg = null;
               if (currentbadge == null)
                  dlg = new RepositoryReferenceDialog(parent, RepName.badgeRep);
               else dlg = new RepositoryReferenceDialog(parent, RepName.badgeRep, currentbadge.item_id());
               if (dlg.getAnswer()){
                  currentbadge = BadgeHelper.narrow(dlg.getObject());
                  if (currentbadge == null) {
                     currentbutton.setEnabled(false);
                  } else {
                     currentbutton.setEnabled(true);
                  }
                  currentbutton.setText(RepGet.DescriptBadge(currentbadge));
               }
               dlg.dispose();
            } else if (type == 2) {
               FindDialog dlg = new FindDialog(parent, RepName.badgeRep);
               if (dlg.getAnswer()){
                  currentpattern = ((BadgePanel) dlg.getPanel()).buildPattern();
               }
               dlg.dispose();
            }
            parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
         } else if (((JButton) e.getSource()) == sensorbutton){
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (type == 0) {
               ViewDialog dlg = new ViewDialog(parent, RepName.sensorRep, homesensor);
               if (dlg.getAnswer()){
                  RepGet repository = new RepGet();
                  repository.init(RepName.holderRep);
                  repository.update(object, mybadge, currentbadge, dlg.getObject(), ltso, getVisitor(), getValidVisitor()); 
                  setData(object);
               }
               dlg.dispose();
            } else if (type == 1) {
               RepositoryReferenceDialog dlg = null;
               if (homesensor == null)
                  dlg = new RepositoryReferenceDialog(parent, RepName.sensorRep);
               else dlg = new RepositoryReferenceDialog(parent, RepName.sensorRep, homesensor.item_id());
               if (dlg.getAnswer()){
                  homesensor = SensorHelper.narrow(dlg.getObject());
                  if (homesensor == null) {
                     sensorbutton.setEnabled(false);
                  } else {
                     sensorbutton.setEnabled(true);
                  }
                  sensorbutton.setText(RepGet.DescriptSensor(homesensor));
               }
               dlg.dispose();
            } else if (type == 2) {
               FindDialog dlg = new FindDialog(parent, RepName.sensorRep);
               if (dlg.getAnswer()){
                  sensorpattern = ((SensorPanel) dlg.getPanel()).buildPattern();
               }
               dlg.dispose();
            }
            parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
         } else if (((JButton) e.getSource()) == ltsobutton) {
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (type == 0) {
               ViewDialog dlg = null;
               if (userrb.isSelected()){
                  dlg = new ViewDialog(parent, RepName.userRep, ltso.user_obj());
                  if (dlg.getAnswer()){
                     RepGet repository = new RepGet();
                     repository.init(RepName.holderRep);
                     ltso.user_obj((Domain_Repository.User) dlg.getObject());
                     repository.update(object, mybadge, currentbadge, homesensor, ltso, getVisitor(), getValidVisitor()); 
                     setData(object);
                  }
               }
               dlg.dispose();
            } else if (type == 1) {
               RepositoryReferenceDialog dlg = null;
               if (userrb.isSelected()){
                  if (ltso == null)
                     dlg = new RepositoryReferenceDialog(parent, RepName.userRep);
                  else dlg = new RepositoryReferenceDialog(parent, RepName.userRep, ltso.user_obj().item_id());
                  if (dlg.getAnswer()) {
                     Domain_Repository.User user = Domain_Repository.UserHelper.narrow(dlg.getObject());
                     if (user == null) {
                        ltso = null;
                        ltsobutton.setEnabled(state);
                     } else {
                        ltso = new ABng_Core.Locatable_Type_Specific_Object();
                        ltso.user_obj(user);
                        ltsobutton.setEnabled(true);
                     }
                     ltsobutton.setText(RepGet.DescriptLTSO(ltso));
                  }
               }
               dlg.dispose();
            } else if (type == 2) {
               FindDialog dlg = null;
               if (userrb.isSelected()){
                  dlg = new FindDialog(parent, RepName.userRep);
                  if (dlg.getAnswer()){
                     ltsopattern = RepGet.BuildLTSOPattern(ABng_Core.Locatable_Type.LOCATABLE_USER, ((UserPanel) dlg.getPanel()).buildPattern());
                  }
               }
               dlg.dispose();
            }
            parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
         }
      }
   }

}
