package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;
 
class RepositoryReferenceDialog extends JDialog{

   JTabbedPane tabbedpane;
   BrowsePanel bpanel; 
   AddPanel apanel;
   UpdatePanel upanel;
   FindPanel fpanel;
   RepGet repository;
   JDialog wnd;
   JButton accept;
   JButton cancel;
   boolean answer;
   org.omg.CORBA.Object object;

   public RepositoryReferenceDialog(Window parent, String repname, int itemid){
      super((JFrame)parent, repname+" - Choose Repsitory Reference", true);
      setSize(610,472);
      setResizable(false);
      addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent e) {setVisible(false); }
        });
      JPanel pane = new JPanel();
      pane.setLayout(null);
      repository = new RepGet();
      repository.init(repname);
      this.wnd = this;
      answer = false;
 
      Init(parent, repname, pane);
      if (itemid != -1) selectItem(itemid);
      setContentPane(pane);
      setVisible(true);
   }

   public RepositoryReferenceDialog(Window parent, String repname){
      super((JFrame)parent, repname+" - Choose Repsitory Reference", true);
      setSize(610,472);
      setResizable(false);
      addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent e) {setVisible(false); }
        });
      JPanel pane = new JPanel();
      pane.setLayout(null);
      repository = new RepGet();
      repository.init(repname);
      this.wnd = this;
      answer = false;
 
      Init(parent, repname, pane);
      setContentPane(pane);
      setVisible(true);
   }

   private void Init(Window parent, String repname, JPanel pane){
      bpanel = new BrowsePanel(parent, repname, repository);
      bpanel.remove(bpanel.remove);
      apanel = new AddPanel(parent, repname, repository);
      upanel = new UpdatePanel(parent, repname, repository);
      fpanel = new FindPanel(parent, repname, repository);
      bpanel.setLocation(0,0);
      tabbedpane = new JTabbedPane();
      tabbedpane.setSize(600, 400);
      tabbedpane.setLocation(0,0);
      tabbedpane.addTab("Browse", bpanel);
      tabbedpane.setSelectedIndex(0);
      tabbedpane.addTab("Add", apanel);
      tabbedpane.addTab("Update", upanel);
      tabbedpane.addTab("Find", fpanel);
      pane.add(tabbedpane);
 
      ButtonClicked bc = new ButtonClicked();
      accept= new JButton("Accept");
      accept.setSize(125,25);
      accept.setLocation(250,410);
      accept.addActionListener(bc);
      accept.setToolTipText("Accept selection and close");
      pane.add(accept);
      cancel = new JButton("Cancel");
      cancel.setSize(125,25);
      cancel.setLocation(425,410);
      cancel.addActionListener(bc);
      cancel.setToolTipText("Cancel selection and close");
      pane.add(cancel);
   }

   public void updateList(){
      bpanel.updateList();
      upanel.updateList();
//      fpanel.updateList();
   }
 
   public void selectItem(int itemid){
      bpanel.selectItem(itemid);
   }
 
   public boolean getAnswer() { return answer; }

   public org.omg.CORBA.Object getObject() { return object; } 

   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == accept){
            answer = true;
            switch(tabbedpane.getSelectedIndex()){
               case 0: object = bpanel.getObject(); break;
               case 1: object = apanel.getObject(); break;
               case 2: object = upanel.getObject(); break;
               case 3: object = fpanel.getObject(); break;
            }
            if (object == null){
               JOptionPane.showMessageDialog(wnd, "Make selection first", "Accept canceled", JOptionPane.ERROR_MESSAGE);
            } else wnd.setVisible(false);
         } else if (((JButton) e.getSource()) == cancel){
            answer = false;
            wnd.setVisible(false);
         }
      }
   }
}
