package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

//////////////////////////////////////////////////
/* This class represents a graphic "part" of itch sensor
   It just shows sensor's fields to user. 
   Few methods to manage this fields */
///////////////////////////////////////

class SensorPanel extends ItemPanel{

   JTextField sensornumber;
   JTextField networknumber;
   JTextField networkgroupname;

   public SensorPanel(boolean state, int type, Window parent){

      JPanel pane = new JPanel();
      pane.setLayout(null);

      JLabel label;
      label = new JLabel("Sensor number:");
      label.setSize(330,15);
      label.setLocation(10,10);
      pane.add(label);
      label = new JLabel("Network number:");
      label.setSize(330,15);
      label.setLocation(10,60);
      pane.add(label);
      label = new JLabel("Network group name:");
      label.setSize(330,15);
      label.setLocation(10,110);
      pane.add(label);

      sensornumber = new JTextField();
      sensornumber.setSize(315,20);
      sensornumber.setLocation(25,30);
      sensornumber.setEnabled(state);
      pane.add(sensornumber);
      networknumber = new JTextField();
      networknumber.setSize(315,20);
      networknumber.setLocation(25,80);
      networknumber.setEnabled(state);
      pane.add(networknumber);
      networkgroupname = new JTextField();
      networkgroupname.setSize(315,20);
      networkgroupname.setLocation(25,130);
      networkgroupname.setEnabled(state);
      pane.add(networkgroupname);

      pane.setPreferredSize(new Dimension(360,210));
      add(pane);
      this.setViewportView(pane);
   }

// Get itch of the fields
   public String getSensorNumber() { return sensornumber.getText(); }
   public String getNetworkNumber() { return networknumber.getText(); }
   public String getNetworkGroupName() { return networkgroupname.getText(); }

// Set itch of the fields
   public void setSensorNumber(String value) {sensornumber.setText(value); }
   public void setNetworkNumber(String value) { networknumber.setText(value); }
   public void setNetworkGroupName (String value) { networkgroupname.setText(value); }

// Clear all fields
   public void clear(){
      sensornumber.setText("");
      networknumber.setText("");
      networkgroupname.setText("");
   }

// Chack if all filds are filled
   public boolean check(){
      if (sensornumber.getText().compareTo("") == 0) return false;
      if (networknumber.getText().compareTo("") == 0) return false;
      if (networkgroupname.getText().compareTo("") == 0) return false;
      return true;
   }

// Just copy the content of source sensor
   public void copy(ItemPanel source){
      sensornumber.setText(((SensorPanel)source).getSensorNumber());
      networknumber.setText(((SensorPanel)source).getNetworkNumber());
      networkgroupname.setText(((SensorPanel)source).getNetworkGroupName());
   }
   
// sets data of this object
   public void setData(org.omg.CORBA.Object source){
      
      Sensor senstemp = SensorHelper.narrow(source);
      
      sensornumber.setText((new Short(senstemp.id().sensor_num)).toString());
      networknumber.setText((new Short(senstemp.id().network_num)).toString());
      networkgroupname.setText(senstemp.id().group_name);
      repaint();
   }

// Build Pattern for find function
   public  ABng_Core_System.SensorPackage.Pattern buildPattern(){
      return RepGet.BuildSensorPattern("", sensornumber.getText(), networknumber.getText(), networkgroupname.getText());
   }
   
}
