package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

/////////////////////////////////////////////
/* Class that's a part of four items in 
   the repository window. With this panel user
   can make changes in the current item and
   accept them with Accept button or close 
   the repository window with Close button */
/////////////////////////////////////////////

class UpdatePanel extends JPanel{

   JList itemlist;
   String[] items;
   JButton accept;
   ItemPanel sensorpanel;

   Window parent;
   int lastindex;
   RepGet repository;
   String repname;
   org.omg.CORBA.Object[] sarray;
   org.omg.CORBA.Object object;

   public UpdatePanel(Window parent, String repname, RepGet rep){

// CHECK THE BACKGROUND COLOR
//      setBackground(Color.lightGray);
      setSize(595,370);
      setLayout(null);
      this.parent = parent;
      this.repository = rep;
      this.repname = repname;
      lastindex = -1;
      object = null;

      RGContainer rg = repository.listRG();
      if (rg.IsError())
         JOptionPane.showMessageDialog(parent, rg.GetErrorText(), "List Repository Error", JOptionPane.ERROR_MESSAGE);
      sarray = rg.GetObjects();
      items = rg.GetStrings();
      itemlist = new JList(items);
      itemlist.setLocation(0,0);
      itemlist.setToolTipText("Click to view item");
      itemlist.addMouseListener(new ItemClicked());
      itemlist.addListSelectionListener(new ItemChanged());
      JScrollPane scrollpane = new JScrollPane(itemlist);
      scrollpane.setSize(200,350);
      scrollpane.setLocation(10,10);
      add(scrollpane);

      ButtonClicked bc = new ButtonClicked();
      accept = new JButton("Accept");
      accept.setSize(125,25);
      accept.setLocation(340,335);
      accept.addActionListener(bc);
      accept.setToolTipText("Update selected item");
      accept.setEnabled(false);
      add(accept);

      if (repname.equals(RepName.userRep))
         sensorpanel = new UserPanel(true, 1, parent);
      else if (repname.equals(RepName.sensorRep))
         sensorpanel = new SensorPanel(true, 1, parent);
      else if (repname.equals(RepName.badgeRep))
         sensorpanel = new BadgePanel(true, 1, parent);
      else if (repname.equals(RepName.holderRep))
         sensorpanel = new HolderPanel(true, 1, parent);
      else if (repname.equals(RepName.locationTypeRep))
         sensorpanel = new LocationTypePanel(true, 1, parent);
      else if (repname.equals(RepName.locationDescRep))
         sensorpanel = new LocationDescPanel(true, 1, parent);
      else if (repname.equals(RepName.abngldRep))
         sensorpanel = new AbngldPanel(true, 1, parent);
      else if (repname.equals(RepName.viewRep))
         sensorpanel = new ViewPanel(true, 1, parent);
      sensorpanel.setLocation(220,10);
      add(sensorpanel);
   }
   
   public void updateList(){
      RGContainer rg = repository.listRG();
      if (rg.IsError())
         JOptionPane.showMessageDialog(parent, rg.GetErrorText(), "List Repository Error", JOptionPane.ERROR_MESSAGE);
      sarray = rg.GetObjects();
      items = rg.GetStrings();
      itemlist.setListData(items);
      itemlist.repaint();
      itemlist.revalidate();
      lastindex = -1;
      object = null;
      sensorpanel.clear();
   }
   
   public void selectItem(int itemid){
 
      int i;
 
      parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
      if (repname.equals(RepName.sensorRep)){
         Sensor temp;
         for ( i=0; i<sarray.length; i++){
            temp = SensorHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.badgeRep)){
         Badge temp;
         for ( i=0; i<sarray.length; i++){
            temp = BadgeHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.holderRep)){
         _Badge_Holder temp;
         for ( i=0; i<sarray.length; i++){
            temp = _Badge_HolderHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.userRep)){
         Domain_Repository.User temp;
         for ( i=0; i<sarray.length; i++){
            temp = Domain_Repository.UserHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.locationTypeRep)){
         Domain_Repository.Location_Type temp;
         for ( i=0; i<sarray.length; i++){
            temp = Domain_Repository.Location_TypeHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.locationDescRep)){
         Domain_Repository.Location_Description temp;
         for ( i=0; i<sarray.length; i++){
            temp = Domain_Repository.Location_DescriptionHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.abngldRep)){
         ABng_Core_System.ABng_Location_Description temp;
         for ( i=0; i<sarray.length; i++){
            temp =  ABng_Core_System.ABng_Location_DescriptionHelper.narrow(sarray[i]);
            if (temp.item_id() == itemid)
               itemlist.setSelectedIndex(i);
         }
      } else if (repname.equals(RepName.viewRep)){
      }
      itemlist.repaint();
      parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
   }

   public org.omg.CORBA.Object getObject() { return object; }

// Do I really need this one...?
   protected final class ItemClicked extends MouseAdapter{
      public void mouseClicked(MouseEvent e){
         if (e.getClickCount() == 2){
            int index = itemlist.locationToIndex(e.getPoint());
            if (index!=-1) {
//               System.out.println(items.elementAt(index));
            }
         }
         super.mouseClicked(e);
      }
   }

///////////////////////////////////////////////////
/* What to do when the user clicked on an item
   or change the selsction */
//////////////////////////////////////////////////

   protected final class ItemChanged implements ListSelectionListener{
      public void valueChanged(ListSelectionEvent e){
         int index = itemlist.getSelectedIndex();
         if ((lastindex!=index) && (index!=-1)){
            lastindex = index;
            sensorpanel.setData(sarray[lastindex]);
            object = sarray[lastindex];
            accept.setEnabled(true);
         }
      }
   }

//////////////////////////////////////////////
/* This class response for clicking buttons */
//////////////////////////////////////////////

   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == accept){
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
// Do you really want to change this item
            if (JOptionPane.showConfirmDialog(parent, "Are You Accept this settings", "Update Confirmation",
                     JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               String mesg = null;
               if (repname.equals(RepName.sensorRep)){
                  String sensid = ((SensorPanel) sensorpanel).getSensorNumber();
                  String netnb = ((SensorPanel) sensorpanel).getNetworkNumber();
                  String netname = ((SensorPanel) sensorpanel).getNetworkGroupName();
                  mesg = repository.update(sarray[lastindex], "0", sensid, netnb, netname);
               } else if (repname.equals(RepName.userRep)){
                  String uid = ((UserPanel) sensorpanel).getUID();
                  String forename = ((UserPanel) sensorpanel).getForename();
                  String surname = ((UserPanel) sensorpanel).getSurname();
                  String position = ((UserPanel) sensorpanel).getPosition();
                  String email = ((UserPanel) sensorpanel).getEmail();
                  String phone = ((UserPanel) sensorpanel).getPhone();
                  mesg = repository.update(sarray[lastindex], "0", uid, forename, surname, position, email, phone);
               } else if (repname.equals(RepName.badgeRep)){
                  try{
                     byte[] abyte = ((BadgePanel) sensorpanel).getID();
                     org.omg.CORBA.Object holder = ((BadgePanel) sensorpanel).getBadgeHolder();
                     mesg = repository.update(sarray[lastindex], abyte, holder);
                  } catch (Exception ex) {
                     mesg = "Please enter a valid number as badgeID";
                  }
               } else if (repname.equals(RepName.holderRep)){
                  org.omg.CORBA.Object mybadge = ((HolderPanel) sensorpanel).getMyBadge();
                  org.omg.CORBA.Object currentbadge = ((HolderPanel) sensorpanel).getCurrentBadge();
                  org.omg.CORBA.Object homesensor = ((HolderPanel) sensorpanel).getHomeSensor();
                  ABng_Core.Locatable_Type_Specific_Object ltso = ((HolderPanel) sensorpanel).getLTSO();
                  ABng_Core.Locatable_Type type = ((HolderPanel) sensorpanel).getType();
		  boolean visitor= ((HolderPanel) sensorpanel).getVisitor();
		  boolean valid_visitor= ((HolderPanel) sensorpanel).getValidVisitor();
                  mesg = repository.update(sarray[lastindex], mybadge, currentbadge, homesensor, ltso, visitor, valid_visitor);
               } else if (repname.equals(RepName.locationTypeRep)){
                  String name = ((LocationTypePanel) sensorpanel).getName();
                  Domain_Repository.Property_Description[] tab = ((LocationTypePanel) sensorpanel).getDescriptions();
                  mesg = repository.update(sarray[lastindex], "0", name, tab);
               } else if (repname.equals(RepName.locationDescRep)){
                  String name = ((LocationDescPanel) sensorpanel).getName();
                  Domain_Repository.Property[] tab = ((LocationDescPanel) sensorpanel).getProperties();
                  mesg = repository.update(sarray[lastindex], "0", name, tab);
               } else if (repname.equals(RepName.abngldRep)){
                  Domain_Repository.Location_Description ld = ((AbngldPanel) sensorpanel).getLocationDescription();
                  Sensor[] sensors = ((AbngldPanel) sensorpanel).getSensors();
                  mesg = repository.update(sarray[lastindex], ld, sensors);
               } else if (repname.equals(RepName.viewRep)){
               }
               if (mesg.compareTo("OK") != 0){
                  JOptionPane.showMessageDialog(parent, mesg, "Can't update item", JOptionPane.ERROR_MESSAGE);
                  sensorpanel.setData(sarray[lastindex]);
               } else {
                  JOptionPane.showMessageDialog(parent, "Operation successfully", "Update OK", JOptionPane.INFORMATION_MESSAGE);
                  if (parent.getClass().getName().equals("RepositoryDialog")) 
                     ((RepositoryDialog)parent).updateList();
                  else ((RepositoryReferenceDialog)parent).updateList();
               }
            }
            parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            SwingUtilities.updateComponentTreeUI(parent);
         }
      }
   }
}
