package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

//////////////////////////////////////////////////
/* This class represents a graphic "part" of itch user
   It just shows user's fields to operator. 
   Few methods to manage this fields */
///////////////////////////////////////

class UserPanel extends ItemPanel{

   JTextField uid;
   JTextField forename;
   JTextField surname;
   JTextField position;
   JTextField email;
   JTextField phone;

   public UserPanel(boolean state, int type, Window parent){

      JPanel pane = new JPanel();
      pane.setLayout(null);

      JLabel label;
      label = new JLabel("Identification string:");
      label.setSize(330,15);
      label.setLocation(10,10);
      pane.add(label);
      label = new JLabel("Forename:");
      label.setSize(330,15);
      label.setLocation(10,60);
      pane.add(label);
      label = new JLabel("Surname:");
      label.setSize(330,15);
      label.setLocation(10,110);
      pane.add(label);
      label = new JLabel("Position:");
      label.setSize(330,15);
      label.setLocation(10,160);
      pane.add(label);
      label = new JLabel("E-mail address:");
      label.setSize(330,15);
      label.setLocation(10,210);
      pane.add(label);
      label = new JLabel("Phone number:");
      label.setSize(330,15);
      label.setLocation(10,260);
      pane.add(label);

      uid = new JTextField();
      uid.setSize(315,20);
      uid.setLocation(25,30);
      uid.setEnabled(state);
      pane.add(uid);
      forename = new JTextField();
      forename.setSize(315,20);
      forename.setLocation(25,80);
      forename.setEnabled(state);
      pane.add(forename);
      surname = new JTextField();
      surname.setSize(315,20);
      surname.setLocation(25,130);
      surname.setEnabled(state);
      pane.add(surname);
      position = new JTextField();
      position.setSize(315,20);
      position.setLocation(25,180);
      position.setEnabled(state);
      pane.add(position);
      email = new JTextField();
      email.setSize(315,20);
      email.setLocation(25,230);
      email.setEnabled(state);
      pane.add(email);
      phone = new JTextField();
      phone.setSize(315,20);
      phone.setLocation(25,280);
      phone.setEnabled(state);
      pane.add(phone);

      pane.setPreferredSize(new Dimension(360,310));
      add(pane);
      this.setViewportView(pane);
      pane.repaint();
   }

// Get itch of the filds
   public String getUID() { return uid.getText(); }
   public String getForename() { return forename.getText(); }
   public String getSurname() { return surname.getText(); }
   public String getPosition() { return position.getText(); }
   public String getEmail() { return email.getText(); }
   public String getPhone() { return phone.getText(); }

// Set itch of the fields
   public void setUID(String value) { uid.setText(value); }
   public void setForename(String value) { forename.setText(value); }
   public void setSurname(String value) { surname.setText(value); }
   public void setPosition(String value) { position.setText(value); }
   public void setEmail(String value) { email.setText(value); }
   public void setPhone(String value) { phone.setText(value); }

// Clear all fields
   public void clear(){
      uid.setText("");
      forename.setText("");
      surname.setText("");
      position.setText("");
      email.setText("");
      phone.setText("");
   }

// Chack if all filds are filled
   public boolean check(){
      if (uid.getText().compareTo("") == 0) return false;
      if (forename.getText().compareTo("") == 0) return false;
      if (surname.getText().compareTo("") == 0) return false;
      if (position.getText().compareTo("") == 0) return false;
      if (email.getText().compareTo("") == 0) return false;
      if (phone.getText().compareTo("") == 0) return false;
      return true;
   }

// Just copy the content of source user
   public void copy(ItemPanel source){
      uid.setText(((UserPanel) source).getUID());
      forename.setText(((UserPanel) source).getForename());
      surname.setText(((UserPanel) source).getSurname());
      position.setText(((UserPanel) source).getPosition());
      email.setText(((UserPanel) source).getEmail());
      phone.setText(((UserPanel) source).getPhone());
   }

// Just set object data
   public void setData(org.omg.CORBA.Object source){
      
      Domain_Repository.User usertemp = Domain_Repository.UserHelper.narrow(source);

      uid.setText(usertemp.uid());
      forename.setText(usertemp.forename());
      surname.setText(usertemp.surname());
      position.setText(usertemp.position());
      email.setText(usertemp.email());
      phone.setText(usertemp.phone());
      
   }

// Build pattern for find function
   public Domain_Repository.UserPackage.Pattern buildPattern(){
      return RepGet.BuildUserPattern("", uid.getText(), forename.getText(), surname.getText(), position.getText(), email.getText(), phone.getText());
   }
}

