package ABngSystem;
 
import java.awt.*;
import java.awt.event.*;
import java.util.*;
 
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
 
/////////////////////////////////////////
/* This class shows a window when user wants to
   update the selected item. It's just item form
   and Accept and Cancel button */
/////////////////////////////////////////
 
class ViewDialog extends JDialog{
 
   JButton update;
   JButton remove;
   JButton close;
   JDialog wnd;
   boolean answer;
   public ItemPanel localitem;
   org.omg.CORBA.Object object;
   String repname;
   RepGet repository;
   Window parent;
 
   public ViewDialog(Window parent, String repname, org.omg.CORBA.Object object){
      super((JFrame)parent, repname+" - View Item", true);
      setFont(new Font("Dialog", Font.PLAIN, 14));
      setSize(383,417);
      setResizable(false);
      addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent e) {setVisible(false); }
        });
 
      JPanel pane = new JPanel();
      pane.setLayout(null);
      wnd = this;
      answer = false;
      this.object = object;
      this.repname = repname;
      this.parent = parent;
      repository = new RepGet();
      repository.init(repname);
 
      if (repname.equals(RepName.userRep))
         localitem = new UserPanel(false, 0, parent);
      else if (repname.equals(RepName.sensorRep))
         localitem = new SensorPanel(false, 0, parent);
      else if (repname.equals(RepName.badgeRep))
         localitem = new BadgePanel(false, 0, parent);
      else if (repname.equals(RepName.holderRep))
         localitem = new HolderPanel(false, 0, parent);
      else if (repname.equals(RepName.locationTypeRep))
         localitem = new LocationTypePanel(false, 0, parent);
      else if (repname.equals(RepName.locationDescRep))
         localitem = new LocationDescPanel(false, 0, parent);
      else if (repname.equals(RepName.abngldRep))
         localitem = new AbngldPanel(false, 0, parent);
      else if (repname.equals(RepName.viewRep))
         localitem = new ViewPanel(false, 0, parent);
      localitem.setLocation(5,5);
      localitem.setData(object);
      pane.add(localitem);
 
      ButtonClicked bc = new ButtonClicked();
      update = new JButton("Update");
      update.setSize(125,25);
      update.setLocation(45,325);
      update.addActionListener(bc);
      update.setToolTipText("Update this item");
      pane.add(update);
      close = new JButton("Close");
      close.setSize(125,25);
      close.setLocation(129,360);
      close.addActionListener(bc);
      close.setToolTipText("Close this window");
      pane.add(close);
      remove = new JButton("Remove");
      remove.setSize(125,25);
      remove.setLocation(205, 325);
      remove.addActionListener(bc);
      remove.setToolTipText("Remove this item");
      pane.add(remove);
 
      setContentPane(pane);
      setVisible(true);
   }
 
   public boolean getAnswer(){ return answer; }
   public ItemPanel getPanel() { return localitem; }
   public org.omg.CORBA.Object getObject() {return object; }
 
 
///////////////////////////////////////////
/* What to do when the user click button */
///////////////////////////////////////////
 
   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == update){
            UpdateDialog dlg = new UpdateDialog(parent, repname, repository, object);
            if (dlg.getAnswer()) {
//               answer = true;
//               localitem.copy(dlg.getPanel());
               answer = true;
               localitem.setData(object);
            }
            dlg.dispose();
         } else if (((JButton) e.getSource()) == close){
            wnd.setVisible(false);
         } else if (((JButton) e.getSource()) == remove){
            wnd.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (JOptionPane.showConfirmDialog(wnd,
                  "Are You sure You want to remove this item",
                  "Remove Confirmation",
                  JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
               String mesg = repository.remove(object);
               if (mesg.compareTo("OK") != 0){
                  JOptionPane.showMessageDialog(wnd, mesg, "Can't remove item", JOptionPane.ERROR_MESSAGE);
               } else {
                  JOptionPane.showMessageDialog(wnd, "Operation successfully", "Remove OK", JOptionPane.INFORMATION_MESSAGE);
                  object = null;
                  answer = true;
                  wnd.setVisible(false);
               }
            }
         }
      }
   }
}
