#include "my_utmp.h"

#ifdef USE_UTMPX

my_utmp *my_getutent(void)
{
  return (my_utmp *)getutxent();
}

my_utmp *my_getutid(const my_utmp *id)
{
  return (my_utmp *)getutxid((const struct utmpx *)id);
}

my_utmp *my_getutline(const my_utmp *line)
{
  return (my_utmp *)getutxline((const struct utmpx *)line);
}

my_utmp *my_pututline(const my_utmp *utmp)
{
  return (my_utmp *)pututxline((const struct utmpx *)utmp);
}

void my_setutent(void)
{
  setutxent();
}

void my_endutent(void)
{
  endutxent();
}

int my_utmpname(const char *file)
{
  return utmpxname(file);
}

#else

my_utmp *my_getutent(void)
{
  return (my_utmp *)getutent();
}

my_utmp *my_getutid(const my_utmp *id)
{
  return (my_utmp *)getutid((const struct utmp *)id);
}

my_utmp *my_getutline(const my_utmp *line)
{
  return (my_utmp *)getutline((const struct utmp *)line);
}

my_utmp *my_pututline(const my_utmp *utmp)
{
  return (my_utmp *)pututline((const struct utmp *)utmp);
}

void my_setutent(void)
{
  setutent();
}

void my_endutent(void)
{
  endutent();
}

int my_utmpname(const char *file)
{
  return utmpname(file);
}

#endif /* USE_UTMPX */
