/*
 * X_gui.cc
 * (c) 1998 Dariusz bik <zbik@dwd.interkom.pl>
 */

#include <stdlib.h>
#include "X_abng.hh"



/* 
 * 1st field - command line
 * 2nd filed - resource 
 * 3th filed - arg type (see Xresource.h)
 * 4th filed - default value
 */
XrmOptionDescRec X_abng::options[] = {
  { "-quiet", "quiet", XrmoptionNoArg, "True" },
  { "-command", "command", XrmoptionSepArg, NULL },
  { "-username", "username", XrmoptionSepArg, NULL },
  { "-viewname", "viewname", XrmoptionSepArg, NULL }
};

/* .Xdefaults or app-defaults resources.
 */
XtResource X_abng::resources[] = {
    { "quiet", "Quiet", XmRBoolean, sizeof (Boolean),
        XtOffsetOf (struct x_gui_resrcs, quiet), XmRImmediate, False },
    { "command", "Command", XmRString, sizeof (XmRString),
        XtOffsetOf (struct x_gui_resrcs, command), XmRString, NULL },
    { "username", "Username", XmRString, sizeof (XmRString),
        XtOffsetOf (struct x_gui_resrcs, username), XmRString, NULL },
    { "viewname", "Viewname", XmRString, sizeof (XmRString),
        XtOffsetOf (struct x_gui_resrcs, viewname), XmRString, "viewroom" }
};

X_abng::X_abng(int argc, char *argv[])
{
  XtSetLanguageProc (NULL, NULL, NULL);

  toplevel = XtAppInitialize (&app, "XShowbitmap",
			      options, XtNumber (options),
			      &argc, argv, NULL, NULL, 0);
  dpy = XtDisplay (toplevel);

  XtGetApplicationResources (toplevel, &Resrcs,
			     resources, XtNumber (resources),
			     NULL, 0);
  if ( !(Resrcs.username) )
  {
    Resrcs.username = new char [ strlen(getlogin())+1 ];
    strcpy(Resrcs.username, getlogin());
  }
}

X_abng::~X_abng()
{
}

/* from abng_lock_setup */
const char *X_abng::lock_args(void) const 
{
  return Resrcs.command;
}

const char *X_abng::viewname(void) const 
{
  return Resrcs.viewname;
}

const char *X_abng::username(void) const 
{
  return Resrcs.username;
}

int X_abng::quiet_mode(void) const
{
  return Resrcs.quiet;
}


/*END*/

