//
// $Id: away_cl.cc,v 1.1.1.1 1998/07/29 12:42:50 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/clients/abngaway/away_cl.cc,v $
//
// $Log: away_cl.cc,v $
// Revision 1.1.1.1  1998/07/29 12:42:50  mencnar
// initial revision
//
//


#include <rw/rwtime.h>
#include <rw/rwdate.h>
#include <iostream.h>
#include <iomanip.h>
#include <strstream.h>

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <pwd.h>
#include <sys/types.h>
#include <unistd.h>

#include "abng_core_management.hh"
#include "bootstrap_n.hh"
#include "compatibility.hh"

inline Domain_Repository::Time cp_time( const ABng_Server_Manager::Time &t) {
  Domain_Repository::Time ret;
  ret.seconds= t.seconds;
  ret.microseconds= t.microseconds;
  return ret;
}

char * console_read_string( const char *default_string) {
  int c;
  int str_beg= 1;
  ostrstream ostr;

  while ( (c= getchar()) != EOF) {
    if ( c == '\n') break;
    if ( str_beg && isspace(c)) continue;
    str_beg= 0;
    ostr << (char) c;
  }
  ostr << '\0';
  char *ret= ostr.str();
  if (strlen(ret)) return ret;
  free(ret);
  if (default_string) return strdup( default_string);
  return NULL;
}

const RWZone& console_read_time_zone() {
  const RWZone *my_zone= &(RWZone::local());
    
  cout << "\tTime zone: <[L]>ocal(" << my_zone->timeZoneName() << ")/<U>TC\t? ";
  cout << flush;
  char *resp= console_read_string( "L");
  if (toupper(*resp) == 'U') my_zone= &(RWZone::utc());
  free( resp);
  return *my_zone;
}

static RWTime offset_time( RWDate(1,1,1970),0,0,0,RWZone::utc());


ostream & operator << ( ostream &ostr, 
			const Domain_Repository::Time &time) {

  RWTime t( offset_time.seconds()+time.seconds);
  return ostr << t;
}

Domain_Repository::Time console_read_date( const Domain_Repository::Time &df) {
  const RWZone &my_zone= console_read_time_zone();
  
  RWTime t( offset_time.seconds()+df.seconds);
  RWDate cd(t);

  char buf[100];
  sprintf( buf, "%02d/%02d/%02d", 
	   cd.dayOfMonth(),
	   cd.month(),
	   cd.year());
  cout << "\tdate [" << buf << "]\t\t? " << flush;
  char *resp= console_read_string( buf);
  int y= cd.year(),
      m= cd.month(),
      d= cd.dayOfMonth();
  
  sscanf( resp, "%d/%d/%d", &d, &m, &y);
  free( resp);
  sprintf( buf, "%02d:%02d:%02d",
	   t.hour( my_zone),
	   t.minute( my_zone),
	   t.second());
  cout << "\ttime [" << buf << "]\t\t\t? " << flush;
  resp= console_read_string( buf);
  int hr= t.hour( my_zone),
      mn= t.minute( my_zone),
      sc= t.second();
  sscanf( resp, "%d:%d:%d", &hr, &mn, &sc);
  free(resp);
  t= RWTime( RWDate( d, m, y),
  	     hr, mn, sc, my_zone);

  Domain_Repository::Time ret;
  ret.seconds= t.seconds()-offset_time.seconds();
  ret.microseconds= 0;
  return ret;
}

ABng_Core_Management::Away_Rep_Manager_var get_away_rep_manager() {
  static ABng_Core_Management::Away_Rep_Manager_var ar_var;

  if (CORBA::is_nil( (ABng_Core_Management::Away_Rep_Manager_ptr) ar_var)) {
    try {
      CORBA::Object_var tmp_obj=
	Bootstrap::resolve( Bootstrap::SRV_Away_Repository_Manager());
      ar_var= ABng_Core_Management::Away_Rep_Manager::_narrow( tmp_obj);
    }
    catch (CORBA::Exception &ex) {
      cerr << "Error resolving Away Repository Manager" << endl;
      cerr << ex << endl;
      exit(1);
    }
  }
  return ar_var;
}

ABng_Core::Away_Rep_var get_away_rep() {
  static ABng_Core::Away_Rep_var ar_var;

  if (CORBA::is_nil( (ABng_Core::Away_Rep_ptr) ar_var)) {
    try {
      CORBA::Object_var tmp_obj=
	Bootstrap::resolve( Bootstrap::SRV_Away_Repository());
      ar_var= ABng_Core::Away_Rep::_narrow( tmp_obj);
    }
    catch (CORBA::Exception &ex) {
      cerr << "Error resolving Away Repository" << endl;
      cerr << ex << endl;
      exit(1);
    }
  }
  return ar_var;
}

void add_away_message( const char *user_id) {

  ABng_Core_Management::Away_Rep_Manager::Change_Description away_desc;
  ABng_Core_Management::Away_Rep_Manager_var away_rep_man= 
    get_away_rep_manager();

  ABng_Core_System::Badge_Holder_var holder;
  {
    ABng_Core_System::Badge_Holder::Pattern pattern;
    Domain_Repository::User::Pattern user_pattern;
    user_pattern.is_any = 0;
    user_pattern.item_id_pattern.is_any = 1;
    user_pattern.uid_pattern.is_any = 0;
    user_pattern.uid_pattern.value= CORBA::string_dup( user_id);
    user_pattern.forename_pattern.is_any = 1;
    user_pattern.surname_pattern.is_any = 1;
    user_pattern.position_pattern.is_any = 1;
    user_pattern.email_pattern.is_any = 1;
    user_pattern.phone_pattern.is_any = 1;

    pattern.is_any= 0;
    pattern.item_id_pattern.is_any= 1;
    pattern.my_badge_pattern.is_any= 1;
    pattern.current_badge_pattern.is_any= 1;
    pattern.home_sensor_pattern.is_any= 1;
    pattern.type_specific_object_pattern.is_any= 0;
    pattern.type_specific_object_pattern.object_pattern.user_obj_pattern(user_pattern);
    pattern.assigned_pattern.is_any= 1;
    pattern.visitor_pattern.is_any= 1;

    ABng_Core_Management::Badge_Holder_Rep_var bh_rep;
    try {
      CORBA::Object_var tmp_obj=
	Bootstrap::resolve( Bootstrap::SRV_Badge_Holder_Repository());
      bh_rep= ABng_Core_Management::Badge_Holder_Rep::_narrow( tmp_obj);
    }
    catch (CORBA::Exception &ex) {
      cerr << "Error resolving Badge Holder Repository" << endl;
      cerr << ex << endl;
      exit(1);
    }
    try {
      ABng_Core_System::Badge_Holders_var bh_seq;
      bh_seq= bh_rep->find( pattern);
      if (bh_seq->length() == 1) holder= bh_seq[0];
      else {
	cerr << (bh_seq->length() ? 
		 "Badge Holder database corrupted: more than one holder with this user id" : 
		 "No holder of this user id found") << endl;
	exit(1);
      }
    }
    catch (CORBA::Exception &ex) {
      cerr << "Error searching for a badge holder" << endl;
      cerr << ex << endl;
      exit(1);
    }    
  }

  away_desc.away_holder= holder;
  cout << "Start time" << endl;
  Domain_Repository::Time ct= cp_time(Bootstrap::gettimeofday());
  away_desc.start_time= console_read_date( ct);
  cout << "Stop time" << endl;
  away_desc.stop_time= console_read_date( ct);
  cout << "Message\t\t\t\t\t? " << flush;
  char *message= console_read_string( "-");
  away_desc.message= CORBA::string_dup( message);
  free(message);
  cout << "Contact\t\t\t\t\t? " << flush;
  char *contact= console_read_string( "-");
  away_desc.contact= CORBA::string_dup( contact);
  free(contact);
  cout << "Cancel by badge [Y]/N\t\t\t? " << flush;
  char *cbb= console_read_string( "Y");
  if (toupper(*cbb) == 'Y') {
    away_desc.cancel_by_badge= (CORBA::Boolean) 1;
    cout << "Cancel from time " << endl;
    ct= cp_time(Bootstrap::gettimeofday());
    ct.seconds+= 5*60; 
    away_desc.cancel_from_time= console_read_date( ct);
  }
  else away_desc.cancel_by_badge= (CORBA::Boolean) 0;
  
  try {
    away_rep_man->add( away_desc);
  }
  catch (Domain_Repository::Invalid_Description &ex_id) {
    cerr << "Invalid description" << endl;
    exit(1);
  }
  catch (CORBA::Exception &ex) {
    cerr << ex << endl;
    exit(1);
  }
}

Domain_Repository::Repository_Item_Id get_active_message( const char *user_id) {
  ABng_Core::Away::Value_Descriptions_var away_list;
  ABng_Core::Away::Pattern patt;
  Domain_Repository::User::Pattern user_pattern;
  if (user_id) {
    patt.is_any= 0;
    patt.item_id_pattern.is_any= 1;

    user_pattern.is_any = 0;
    user_pattern.item_id_pattern.is_any = 1;
    user_pattern.uid_pattern.is_any = 0;
    user_pattern.uid_pattern.value= CORBA::string_dup( user_id);
    user_pattern.forename_pattern.is_any = 1;
    user_pattern.surname_pattern.is_any = 1;
    user_pattern.position_pattern.is_any = 1;
    user_pattern.email_pattern.is_any = 1;
    user_pattern.phone_pattern.is_any = 1;

    patt.type_specific_object_pattern.is_any= 0;
    patt.start_time_pattern.is_any= 1;
    patt.stop_time_pattern.is_any= 1;
    patt.cancel_from_time_pattern.is_any= 1;
    patt.message_pattern.is_any= 1;
    patt.contact_pattern.is_any= 1;
    patt.cancel_by_badge_pattern.is_any= 1;
    patt.active_pattern.is_any= 0;
    patt.active_pattern.value= 1; // only active messages are in interest
  }
  else patt.is_any= 1;

  patt.type_specific_object_pattern.object_pattern.user_obj_pattern(user_pattern);
  ABng_Core::Away_Rep_var away_rep= get_away_rep();
  try {
    away_list= away_rep->find_values( patt);
  }
  catch (Domain_Repository::Destination_Unreachable &ex) {
    cerr << "Repository unreachable " << ex.server_name << endl;
    exit(1);
  }
  catch (CORBA::Exception &ex) {
    cerr << ex << endl;
    exit(1);
  }
  if (away_list->length() != 1) {
    cerr << "No active messages found for a user" << endl;
    exit(1);
  }
  return away_list[0].item_id;
}

void delete_away_message( Domain_Repository::Repository_Item_Id away_item_id) {
  ABng_Core::Away::Pattern patt;
  Domain_Repository::User::Pattern user_pattern;

  patt.is_any= 0;
  patt.item_id_pattern.is_any= 0;
  patt.item_id_pattern.value= away_item_id;
  patt.type_specific_object_pattern.is_any= 1;
  patt.start_time_pattern.is_any= 1;
  patt.stop_time_pattern.is_any= 1;
  patt.cancel_from_time_pattern.is_any= 1;
  patt.message_pattern.is_any= 1;
  patt.contact_pattern.is_any= 1;
  patt.cancel_by_badge_pattern.is_any= 1;
  patt.active_pattern.is_any= 1;

  ABng_Core::Aways_var aways;
  ABng_Core_Management::Away_Rep_Manager_var away_rep_man= 
    get_away_rep_manager();
  ABng_Core::Away_Rep_var away_rep= get_away_rep();
  try {
    aways= away_rep->find( patt);
  }
  catch (Domain_Repository::Destination_Unreachable &ex) {
    cerr << "Repository unreachable " << ex.server_name << endl;
    exit(1);
  }
  catch (CORBA::Exception &ex) {
    cerr << ex << endl;
    exit(1);
  }
  if (aways->length() != 1) {
    cerr << "Requested away message not found" << endl;
    exit(1);
  }
  try {
    away_rep_man->remove( aways[0]);
  }
  catch (CORBA::Exception &ex) {
    cerr << ex << endl;
    exit(1);
  } 
}

void list_away_messages( const char *user_id,
			 int verbose_mode) {
  ABng_Core::Away::Value_Descriptions_var away_list;
  ABng_Core::Away::Pattern patt;
  Domain_Repository::User::Pattern user_pattern;
  if (user_id) {
    patt.is_any= 0;
    patt.item_id_pattern.is_any= 1;

    user_pattern.is_any = 0;
    user_pattern.item_id_pattern.is_any = 1;
    user_pattern.uid_pattern.is_any = 0;
    user_pattern.uid_pattern.value= CORBA::string_dup( user_id);
    user_pattern.forename_pattern.is_any = 1;
    user_pattern.surname_pattern.is_any = 1;
    user_pattern.position_pattern.is_any = 1;
    user_pattern.email_pattern.is_any = 1;
    user_pattern.phone_pattern.is_any = 1;
    patt.type_specific_object_pattern.is_any= 0;
    patt.start_time_pattern.is_any= 1;
    patt.stop_time_pattern.is_any= 1;
    patt.cancel_from_time_pattern.is_any= 1;
    patt.message_pattern.is_any= 1;
    patt.contact_pattern.is_any= 1;
    patt.cancel_by_badge_pattern.is_any= 1;
    patt.active_pattern.is_any= 1;
  }
  else patt.is_any= 1;

  patt.type_specific_object_pattern.object_pattern.user_obj_pattern(user_pattern);
  ABng_Core::Away_Rep_var away_rep= get_away_rep();
  try {
    away_list= away_rep->find_values( patt);
  }
  catch (Domain_Repository::Destination_Unreachable &ex) {
    cerr << "Repository unreachable " << ex.server_name << endl;
    exit(1);
  }
  catch (CORBA::Exception &ex) {
    cerr << ex << endl;
    exit(1);
  }
  for (int i=0; i<away_list->length(); i++) {
    ABng_Core::Away::Value_Description &desc= away_list[i];
    
    if (desc.type_specific_object_value._d() !=
	ABng_Core::LOCATABLE_USER) continue;

    Domain_Repository::User::Value_Description &user_descr=
	desc.type_specific_object_value.user_description();
    switch (verbose_mode) {
    case 0:
      cout << setw(6) << desc.item_id << ' '
	   << *(const char *) user_descr.forename << ' '
	   << setw(12) << user_descr.surname << " (" << setw(8) << user_descr.uid << ") : "
	   << desc.start_time << " - " << desc.stop_time << endl
	   << '`' << setw(30) << desc.message 
	   << '\'' << setw(30) << desc.contact << (desc.active ? "<Active>" : "") << endl;
      break;
    case 1:
      cout << setw(6) << desc.item_id << ' '
	   << setw(12) << (const char *) user_descr.forename << ' '
	   << setw(12) << user_descr.surname << " (" << setw(8) << user_descr.uid << ") : " << endl
	   << desc.start_time << " - " << desc.stop_time << ' ';
      if (desc.cancel_by_badge) 
	cout << "(cancel by badge from) " << desc.cancel_from_time;
      cout << endl << '`' << setw(30) << desc.message 
	   << '\'' << setw(30) << desc.contact << (desc.active ? "<Active>" : "") << endl;

    }
  }
}

void usage( const char *prog_name) {
  cout << "Usage: " << prog_name << endl
       << "\t-u user_id\t\tuse this user id" << endl
       << "\t-l \t\t\tlist away messages" << endl
       << "\t-a \t\t\tlist all away messages" << endl
       << "\t-v \t\t\tmore verbose listing" << endl
       << "\t-d away_id\t\tremove an away message" << endl
       << "\t-D \t\t\tdelete current away message" << endl
       << "\t-h -?\t\t\tdisplay this help screen" << endl;
  exit(0);
}

int main( int argc, char **argv) {
  CORBA::ORB_ptr orb_ptr= CORBA::ORB_init( argc, argv, ORB_IDENTIFIER);
  CORBA::BOA_ptr boa_ptr= orb_ptr->BOA_init( argc, argv, BOA_IDENTIFIER);

  try {
    Bootstrap::init( orb_ptr);
  }
  catch ( CORBA::Exception &ex) {
    cerr << "Error initializing bootstrap module " << ex;
    return 1;
  } 

  int c;
  const char *user_id= getpwuid( getuid())->pw_name;
  enum Action {
    AC_ADD,
    AC_DEFAULT= AC_ADD,
    AC_LIST,
    AC_LIST_ALL,
    AC_DELETE,
    AC_DELETE_ACTIVE
  } ac( AC_DEFAULT);
  int verbose_mode= 0;
  Domain_Repository::Repository_Item_Id away_item_id= 0;

  while (( c = getopt( argc, argv, "u:lavid:Dh?")) != -1) {
    switch (c) {
    case 'u':
      user_id= optarg;
      break;
    case 'l':
      ac= AC_LIST;
      break;
    case 'a':
      ac= AC_LIST_ALL;
      break;
    case 'v':
      verbose_mode= 1;
      break;
    case 'i':
      verbose_mode= 2;
      break;
    case 'd':
      ac= AC_DELETE;
      away_item_id= atoi( optarg);
      break;
    case 'D':
      ac= AC_DELETE_ACTIVE;
      break;
    case 'h':
    case '?':
      usage( *argv);
      break;
    }
  }
  switch (ac) {
  case AC_ADD:
    add_away_message( user_id);
    break;
  case AC_LIST:
    list_away_messages( user_id, verbose_mode);
    break;
  case AC_LIST_ALL:
    list_away_messages( NULL, verbose_mode);
    break;
  case AC_DELETE:
    delete_away_message( away_item_id);
    break;
  case AC_DELETE_ACTIVE:
    delete_away_message( get_active_message( user_id));
    break;
  }
  return 0;
}







