//
// $Id: visitor_cl.cc,v 1.1.1.1 1998/07/29 12:43:57 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/clients/abngvisitor/visitor_cl.cc,v $
//
// $Log: visitor_cl.cc,v $
// Revision 1.1.1.1  1998/07/29 12:43:57  mencnar
// initial revision
//
//

#include <iostream.h>
#include <stdlib.h>
#include <strstream.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>


#include "domain_rep_management.hh"
#include "abng_core_management.hh"
#include "bootstrap_n.hh"
#include "compatibility.hh"

char * console_read_string( const char *default_string) {
  int c;
  int str_beg= 1;
  ostrstream ostr;

  while ( (c= getchar()) != EOF) {
    if ( c == '\n') break;
    if ( str_beg && isspace(c)) continue;
    str_beg= 0;
    ostr << (char) c;
  }
  ostr << '\0';
  char *ret= ostr.str();
  if (strlen(ret)) return ret;
  free(ret);
  if (default_string) return strdup( default_string);
  return NULL;
}



ABng_Core_Management::Badge_Holder_Rep_var get_bh_rep() {
  static ABng_Core_Management::Badge_Holder_Rep_var ar_var;

  if (CORBA::is_nil( (ABng_Core_Management::Badge_Holder_Rep_ptr) ar_var)) {
    try {
      CORBA::Object_var tmp_obj=
	Bootstrap::resolve( Bootstrap::SRV_Badge_Holder_Repository());
      ar_var= ABng_Core_Management::Badge_Holder_Rep::_narrow( tmp_obj);
    }
    catch (CORBA::Exception &ex) {
      cerr << "Error resolving Badge Holder Repository" << endl;
      cerr << ex << endl;
      exit(1);
    }
  }
  return ar_var;
}

Domain_Repository_Management::User_Rep_Manager_var get_user_manager() {
  static Domain_Repository_Management::User_Rep_Manager_var ar_var;

  if (CORBA::is_nil( (Domain_Repository_Management::User_Rep_Manager_ptr) ar_var)) {
    try {
      CORBA::Object_var tmp_obj=
	Bootstrap::resolve( Bootstrap::SRV_User_Repository_Manager());
      ar_var= Domain_Repository_Management::User_Rep_Manager::_narrow( tmp_obj);
    }
    catch (CORBA::Exception &ex) {
      cerr << "Error resolving User Repository Manager" << endl;
      cerr << ex << endl;
      exit(1);
    }
  }
  return ar_var;
}

void remove_visitor( const char *visitor_id,
		     int remove_all) {
  ABng_Core_Management::Badge_Holder_Rep_var bh_rep= get_bh_rep();

  Domain_Repository::User::Pattern user_pattern;
  user_pattern.is_any= 0;
  user_pattern.item_id_pattern.is_any= 1;
  user_pattern.uid_pattern.is_any= 0;
  user_pattern.uid_pattern.value= CORBA::string_dup( visitor_id);
  user_pattern.forename_pattern.is_any= 1;
  user_pattern.surname_pattern.is_any= 1;
  user_pattern.position_pattern.is_any= 1;
  user_pattern.email_pattern.is_any= 1;
  user_pattern.phone_pattern.is_any= 1;

  ABng_Core_System::Badge_Holder::Pattern pattern;
  pattern.is_any= 0;
  pattern.item_id_pattern.is_any= 1;
  pattern.my_badge_pattern.is_any= 1;
  pattern.current_badge_pattern.is_any= 1;
  pattern.home_sensor_pattern.is_any= 1;
  pattern.type_specific_object_pattern.is_any= remove_all;
  pattern.type_specific_object_pattern.object_pattern.user_obj_pattern(user_pattern);
  pattern.visitor_pattern.is_any= 0;
  pattern.visitor_pattern.value= 1;
  pattern.assigned_pattern.is_any= 0;
  pattern.assigned_pattern.value= 1;

  ABng_Core_System::Badge_Holder_var bh_var;

  ABng_Core_System::Badge_Holders_var vds;
  try {
    vds= bh_rep->find( pattern);

    if (!remove_all) {
      if (vds->length() == 1)
	bh_var= ABng_Core_System::Badge_Holder::_duplicate( vds[0]);
      else {
	cerr << "There is no valid visitor badge holder of this name" << endl;
	exit( 1);
      }
    }
  }
  catch (CORBA::Exception &ex) {
    cerr << "Error searching for visitors" << endl;
    cerr << ex << endl;
    exit(1);
  }    

  try {
    for (int i=0; i<vds->length(); i++) {
      bh_var= ABng_Core_System::Badge_Holder::_duplicate( vds[i]);
      ABng_Core_System::Badge_Holder::Description_var bhdesc=
	bh_var->descr();
      bhdesc->assigned= 0;
      bh_rep->update( bh_var, bhdesc);
    }
  }
  catch (CORBA::Exception &ex) {
    cerr << "Error updating badge holder repository" << endl;
    cerr << ex << endl;
    exit(1);
  }
}

void add_visitor( const char *visitor_id) {
  Domain_Repository::User::Description udesc;
  char * tmp;

  ABng_Core_Management::Badge_Holder_Rep_var bh_rep= get_bh_rep();
  Domain_Repository_Management::User_Rep_Manager_var u_rep_man= 
    get_user_manager();
  
  Domain_Repository::User::Pattern user_pattern;
  user_pattern.is_any= 0;
  user_pattern.item_id_pattern.is_any= 1;
  user_pattern.uid_pattern.is_any= 0;
  user_pattern.uid_pattern.value= CORBA::string_dup( visitor_id);
  user_pattern.forename_pattern.is_any= 1;
  user_pattern.surname_pattern.is_any= 1;
  user_pattern.position_pattern.is_any= 1;
  user_pattern.email_pattern.is_any= 1;
  user_pattern.phone_pattern.is_any= 1;

  Domain_Repository::User_var user_var;
  
  try {
    Domain_Repository::User_Rep_var u_rep= u_rep_man->rep();

    Domain_Repository::Users_var usrs= u_rep->find( user_pattern);

    if (usrs->length() == 1)
      user_var= Domain_Repository::User::_duplicate( usrs[0]);
    else {
      cerr << "Could not find a given visitor" << endl;
      exit(1);
    }
  }
  catch (CORBA::Exception &ex) {
    cerr << "Error serching for a visitor in user repository" << endl;
    cerr << ex << endl;
    exit(1);
  }

  ABng_Core_System::Badge_Holder::Pattern pattern;
  pattern.is_any= 0;
  pattern.item_id_pattern.is_any= 1;
  pattern.my_badge_pattern.is_any= 1;
  pattern.current_badge_pattern.is_any= 1;
  pattern.home_sensor_pattern.is_any= 1;
  pattern.type_specific_object_pattern.is_any= 0;
  pattern.type_specific_object_pattern.object_pattern.user_obj_pattern(user_pattern);
  pattern.visitor_pattern.is_any= 0;
  pattern.visitor_pattern.value= 1;
  pattern.assigned_pattern.is_any= 0;
  pattern.assigned_pattern.value= 0;

  ABng_Core_System::Badge_Holder_var bh_var;

  try {
    ABng_Core_System::Badge_Holders_var vds=
      bh_rep->find( pattern);
    if (vds->length() == 1)
      bh_var= ABng_Core_System::Badge_Holder::_duplicate( vds[0]);
    else {
      cerr << "There is no visitor badge holder available of this name" << endl;
      exit( 1);
    }
  }
  catch (CORBA::Exception &ex) {
    cerr << "Error searching for visitors" << endl;
    cerr << ex << endl;
    exit(1);
  }    

  udesc.uid= CORBA::string_dup( visitor_id);

  cout << "Visitor's forename\t\t? " << flush;
  tmp= console_read_string( "-");
  udesc.forename= CORBA::string_dup( tmp);
  free( tmp);

  cout << "Visitor's surname\t\t? " << flush;
  tmp= console_read_string( "-");
  udesc.surname= CORBA::string_dup( tmp);
  free(tmp);

  cout << "Position/affiliation\t\t? " << flush;
  tmp= console_read_string("");
  udesc.position= CORBA::string_dup( tmp);
  free(tmp);

  cout << "E-mail\t\t\t\t? " << flush;
  tmp= console_read_string("");
  udesc.email= CORBA::string_dup( tmp);
  free(tmp);

  cout << "Phone\t\t\t\t? " << flush;
  tmp= console_read_string("");
  udesc.phone= CORBA::string_dup( tmp);
  free(tmp);

  // Refresh user/badge holder references (just in case)
  //

  try {
    Domain_Repository::User_Rep_var u_rep= u_rep_man->rep();

    Domain_Repository::Users_var usrs= u_rep->find( user_pattern);

    if (usrs->length() == 1)
      user_var= Domain_Repository::User::_duplicate( usrs[0]);
    else {
      cerr << "Could not find a given visitor" << endl;
      exit(1);
    }
  }
  catch (CORBA::Exception &ex) {
    cerr << "Error serching for a visitor in user repository" << endl;
    cerr << ex << endl;
    exit(1);
  }

  try {
    ABng_Core_System::Badge_Holders_var vds=
      bh_rep->find( pattern);
    if (vds->length() == 1)
      bh_var= ABng_Core_System::Badge_Holder::_duplicate( vds[0]);
    else {
      cerr << "There is not badge holder available of this name" << endl;
      exit( 1);
    }
  }
  catch (CORBA::Exception &ex) {
    cerr << "Error searching for visitors" << endl;
    cerr << ex << endl;
    exit(1);
  }

  try {
    u_rep_man->update( user_var, udesc);
  }
  catch (CORBA::Exception &ex) {
    cerr << "Error updating user repository " << endl;
    cerr << ex << endl;
    exit(1);
  }

  try {
    ABng_Core_System::Badge_Holder::Description_var bhdesc=
      bh_var->descr();
    bhdesc->assigned= 1;
    bh_rep->update( bh_var, bhdesc);
  }
  catch (CORBA::Exception &ex) {
    cerr << "Error updating badge holder repository" << endl;
    cerr << ex << endl;
    exit(1);
  }
}

void list_visitors( CORBA::Boolean all_visitors, 
		    int verbose_mode,
		    int valid_visitors= 1) {

 ABng_Core_Management::Badge_Holder_Rep_var bh_rep= get_bh_rep();
 
 Domain_Repository::User::Pattern user_pattern;

 ABng_Core_System::Badge_Holder::Pattern pattern;
 pattern.is_any= 0;
 pattern.item_id_pattern.is_any= 1;
 pattern.my_badge_pattern.is_any= 1;
 pattern.current_badge_pattern.is_any= 1;
 pattern.home_sensor_pattern.is_any= 1;
 pattern.type_specific_object_pattern.is_any= 1;
 pattern.type_specific_object_pattern.object_pattern.user_obj_pattern(user_pattern);
 pattern.visitor_pattern.is_any= 0;
 pattern.visitor_pattern.value= (CORBA::Boolean) 1;
 if (all_visitors) 
   pattern.assigned_pattern.is_any= 1;
 else {
   pattern.assigned_pattern.is_any= 0;
   pattern.assigned_pattern.value= valid_visitors;
 }
 try {
   ABng_Core_System::Badge_Holder::Value_Descriptions_var vds=
     bh_rep->find_values( pattern);
   for (int i=0; i<vds->length(); i++) {
     try {
       Domain_Repository::User::Value_Description uvd=
	 vds[i].type_specific_object.user_description();
       cout << uvd.uid << ' ' << uvd.forename << ' '
	    << uvd.surname << ' ' << uvd.position << endl
	    << "\te-mail: " << uvd.email << " phone: " << uvd.phone << endl;
     }
     catch (...) {}
   }
 }
 catch (CORBA::Exception &ex) {
   cerr << "Error searching for visitors" << endl;
   cerr << ex << endl;
   exit(1);
 }    
}

void usage( const char *prog_name) {
  cout << "Usage: " << prog_name << endl
       << "\t-l \t\tlist current visitors (default)" << endl
       << "\t-a \t\tlist all visitor badges" << endl
       << "\t-b \t\tlist available visitor badges" << endl
       << "\t-n visitor_id\tadd a new visitor" << endl
       << "\t-r visitor_id\tremove a visitor" << endl
       << "\t-R \t\tremove all visitors (must by accompanied by -s)" << endl
       << "\t-s \t\tmust be specified to \"remove all\" could take effect" << endl
       << "\t-h -?\t\tdisplay this help screen" << endl;
  exit(0);
}

int main( int argc, char **argv) {
  CORBA::ORB_ptr orb_ptr= CORBA::ORB_init( argc, argv, ORB_IDENTIFIER);
  CORBA::BOA_ptr boa_ptr= orb_ptr->BOA_init( argc, argv, BOA_IDENTIFIER);

  try {
    Bootstrap::init( orb_ptr);
  }
  catch ( CORBA::Exception &ex) {
    cerr << "Error initializing bootstrap module " << ex;
    return 1;
  } 
  int dont_ask= 0;

  enum Action {
    AC_ADD,
    AC_LIST,
    AC_DEFAULT= AC_LIST,
    AC_LIST_AVAILABLE,
    AC_LIST_ALL,
    AC_REMOVE,
    AC_REMOVE_ALL
  } ac( AC_DEFAULT);
  int verbose_mode= 0;
  const char *visitor_id;

  int c;
  while (( c = getopt( argc, argv, "n:r:labRsvh?")) != -1) {
    switch (c) {
    case 'n':
      ac= AC_ADD;
      visitor_id= optarg;
      break;
    case 'r':
      ac= AC_REMOVE;
      visitor_id= optarg;
      break;
    case 'l':
      ac= AC_LIST;
      break;
    case 'b':
      ac= AC_LIST_AVAILABLE;
      break;
    case 'a':
      ac= AC_LIST_ALL;
      break;
    case 'R':
      ac= AC_REMOVE_ALL;
      break;
    case 's':
      dont_ask= 1;
      break;
    case 'v':
      verbose_mode= 1;
      break;
    case 'h':
    case '?':
      usage( *argv);
      break;
    }
  }
  switch (ac) {
  case AC_ADD:
    add_visitor( visitor_id);
    break;
  case AC_REMOVE:
    remove_visitor( visitor_id, 0);
    break;
  case AC_LIST:
    list_visitors( 0, verbose_mode);
    break;
  case AC_LIST_AVAILABLE:
    list_visitors( 0, verbose_mode, 0);
    break;
  case AC_LIST_ALL:
    list_visitors( 1, verbose_mode);
    break;
  case AC_REMOVE_ALL:
    if (!dont_ask) {
      cout << "-s option must specified to remove all visitors" << endl;
      exit(1);
    }
    remove_visitor( "", 1);
    break;
  }
  return 0;
}



