// Scrollable Visual Rooms for ABng

package jabba;

import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
	
import java.lang.reflect.*;
import java.lang.*;

public class ScrollVR extends JPanel {

	Runnable doredrawALL = new Runnable() {
		public void run() {
			redrawALL();
		}
	};

    	private JComboBox cm;
	private JButton zoomIn;
	private JButton zoomOut;
    	public Rooms visR;
    	private boolean visibleHuman=true;
    	private boolean visibleDevice=true;
    	private boolean rotated = false;

    	private JSplitPane splitp = new JSplitPane();

    	private JScrollPane pictureScrollPane;

    	private String[] zooming = { "25%", "30%", "35%", "40%", "45%",
		"50%", "55%", "60%", "65%", "70%", "75%",
"80%", "90%",
		"100%", "110%", "120%", "130%", "140%", "150%" };
    	private double[] zoomingFac = { 0.25, 0.3, 0.35, 0.4, 0.45, 0.5, 0.55,
						0.6, 0.65, 0.7, 0.75, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5 };
    	private int indexZ = 13;
    	private double zoomFac = 1;
    	private JTextPane tx;

    public ScrollVR(Rooms r) {

	visR = r;

	pictureScrollPane = new JScrollPane(visR);
        pictureScrollPane.setPreferredSize(new Dimension(400, 400));

	JPanel jp = new JPanel();
	getBackground();
	zoomIn = new JButton("ZoomIn");
	zoomOut = new JButton("ZoomOut");

	JLabel prlab = new JLabel("Properties");
	JCheckBox jb1 = new JCheckBox("People visible");
	JCheckBox jb2 = new JCheckBox("Equipment visible");

        jb1.setSelected(true);
        jb2.setSelected(true);

	cm = new JComboBox(zooming);
	cm.setSelectedIndex(indexZ);

	JCheckBox txj = new JCheckBox("Rotate 90");

	tx = new JTextPane();
	tx.setEditable(false);
	JScrollPane txps = new JScrollPane(tx);

	cm.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		JComboBox cb = (JComboBox)e.getSource();
                indexZ = (int)cb.getSelectedIndex();
		zoomFac = zoomingFac[indexZ];
		redrawALL();
		if (indexZ==zooming.length-1) zoomIn.setEnabled(false);
			else zoomIn.setEnabled(true);
		if (indexZ==0) zoomOut.setEnabled(false);
			else zoomOut.setEnabled(true);
	}});

	zoomIn.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			zoomOut.setEnabled(true);
			if (indexZ<zooming.length-1) {
				indexZ++;
				zoomFac = zoomingFac[indexZ];
				redrawALL();
				cm.setSelectedIndex(indexZ);
			} 
			if (indexZ==zooming.length) zoomIn.setEnabled(false);
	}});

	zoomOut.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			zoomIn.setEnabled(true);
			if (indexZ>0) {
				indexZ--;
				zoomFac = zoomingFac[indexZ];
				redrawALL();
				cm.setSelectedIndex(indexZ);
			} 
			if (indexZ==0) zoomOut.setEnabled(false);
	}});

	jb1.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent e) {
			boolean changed = visibleHuman;
			if (e.getStateChange() == ItemEvent.DESELECTED)	
				visibleHuman=false;
			else visibleHuman=true;
			if (changed != visibleHuman) {
			for (int i=0; i<visR.sizeR(); i++) 
                              visR.getRoomAt(i).setHumVis(visibleHuman);
			revalidate();
                        repaint();
			}
                }
        });	

	jb2.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent e) {
			boolean changed = visibleDevice;
			if (e.getStateChange() == ItemEvent.DESELECTED)	
				visibleDevice=false;
			else visibleDevice=true;
			if (changed != visibleDevice) {
			for (int i=0; i<visR.sizeR(); i++)  
			      visR.getRoomAt(i).setDevVis(visibleDevice);
			revalidate();
                        repaint();
			}
                }
        });	

	txj.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent e) {
			if (e.getStateChange() == ItemEvent.DESELECTED)	
				rotated=false;
			else rotated=true;
//			visR.setRotated(rotated);
			for (int i=0; i<visR.sizeR(); i++) 
			      visR.getRoomAt(i).setRotated(rotated);
/*			for (int i=0; i<visR.sizeD(); i++) 
			      visR.getDoorAt(i).setRotated(rotated);
*/			redrawALL();
                }
        });	

	for (int i=0; i<visR.sizeR(); i++)
		visR.getRoomAt(i).setTextPane(tx);

	jp = new JPanel();
	jp.setLayout(new BoxLayout(jp, BoxLayout.Y_AXIS));
	jp.setBorder(BorderFactory.createEtchedBorder());
	jp.setPreferredSize(new Dimension(570,55));

	JPanel first = new JPanel();
	first.setLayout(new BoxLayout(first, BoxLayout.X_AXIS));

	jb1.setAlignmentX(Component.TOP_ALIGNMENT);
	first.add(Box.createRigidArea(new Dimension (10,0)));
	first.add(jb1);
	first.add(Box.createRigidArea(new Dimension (80,0)));
	first.add(zoomIn);
	first.add(Box.createRigidArea(new Dimension (5,0)));
	first.add(zoomOut);

	first.add(Box.createRigidArea(new Dimension (20,0)));
	cm.setAlignmentY(Component.LEFT_ALIGNMENT);
	first.add(cm);
	first.add(Box.createHorizontalGlue());

	JPanel second = new JPanel();
	second.add(Box.createRigidArea(new Dimension (10,0)));
	second.setLayout(new BoxLayout(second, BoxLayout.X_AXIS));
	second.add(jb2);
	second.add(Box.createRigidArea(new Dimension (120,0)));
	second.add(txj);
	second.add(Box.createHorizontalGlue());

	jp.add(first);
	jp.add(second);

	txps.setPreferredSize(new Dimension(200, 50));
	txps.setBorder(BorderFactory.createEtchedBorder());

        // Put it in this panel
	txps.setMinimumSize(new Dimension(50,50));
        pictureScrollPane.setMinimumSize(new Dimension(50,50));
        splitp.setLeftComponent(txps);
        splitp.setRightComponent(pictureScrollPane);
        splitp.setOneTouchExpandable(true);
	splitp.setDividerLocation(150);

        splitp.setDividerSize(10);
	splitp.setPreferredSize(new Dimension(800, 450));

	GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        setLayout(gridbag);

	c.gridx = 0;
	c.gridy = 0;
	c.weightx = 1;
	c.weighty = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.BOTH;
	c.ipadx = 2;
	c.ipady = 2;
	c.anchor = GridBagConstraints.NORTH;
	gridbag.setConstraints(splitp, c);
	add(splitp);

	c.gridx = 0;
	c.gridy = 1;
	c.weightx = 1;
	c.weighty = 0.01;
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.gridheight = GridBagConstraints.RELATIVE;
	c.fill = GridBagConstraints.BOTH;
	c.anchor = GridBagConstraints.SOUTH;
	gridbag.setConstraints(jp, c);
	add(jp);

	setPreferredSize(new Dimension(800, 490));
	visR.currentRoom.createTextPane(true);
	redrawALL();
    	}

	public void redrawALL() {
		Room r;
		Human h;
		Device d;
		Door dr;
		int maxX=0, maxY=0;
		for (int i=0; i<visR.sizeR(); i++) {
			r=visR.getRoomAt(i);
			r.setZoom(zoomFac);
			int new_x=(int)(r.getOrig_x()*zoomFac);
			int new_y=(int)(r.getOrig_y()*zoomFac);
			int new_sx=(int)(r.getSize_x()*zoomFac);
			int new_sy=(int)(r.getSize_y()*zoomFac);
			r.setBounds(new_x, new_y, new_sx, new_sy);
			r.setLabelBounds(new_sx, new_sy);
			r.people();
			r.setPreferredSize(new Dimension(new_sx, new_sy));
			r.setBorder(BorderFactory.createCompoundBorder
				(r.compound,BorderFactory.createLineBorder
				(r.getColor(),new_sx)));

			if (new_x + new_sx > maxX)
                              maxX = new_x + new_sx;
                        if (new_y + new_sy > maxY)
                              maxY = new_y + new_sy;

			for (int j=0; j<r.getHumSize(); j++) {
				h=r.getHumanAt(j);	
				if (h.mask == 3) continue;
				h.setZoom(zoomFac);
				int new_hx=(int)(h.getXPos(rotated)*zoomFac);
				int new_hy=(int)(h.getYPos(rotated)*zoomFac);
				int new_hsx=(int)(h.getHWidth()*zoomFac);
				int new_hsy=(int)(h.getHHeight()*zoomFac);
				h.setBounds(new_hx, new_hy, new_hsx, new_hsy);
				h.setPreferredSize(new Dimension
							(new_hsx, new_hsy));
			}
			if (!visibleHuman) r.setHumVis(false);

			for (int j=0; j<r.getDevSize(); j++) {
				d=r.getDeviceAt(j);	
				d.setZoom(zoomFac);
				int new_dx=(int)(d.getXPos(rotated)*zoomFac);
				int new_dy=(int)(d.getYPos(rotated)*zoomFac);
				int new_dsx=(int)(d.getDWidth()*zoomFac);
				int new_dsy=(int)(d.getDHeight()*zoomFac);
				d.setBounds(new_dx, new_dy, new_dsx, new_dsy);
				d.setPreferredSize(new Dimension
							(new_dsx, new_dsy));
			}
			if (!visibleDevice) r.setDevVis(false);

		for (int j=0; j<r.getSizeD(); j++) {
			dr=r.getDoorAt(j);
			int new_drx=0;
			int new_dry=0;
			int new_drsx=0;
			int new_drsy=0;
			boolean rot=rotated;

			if (dr.getSize_x(rot) > dr.getSize_y(rot)) {
				new_drsx=(int)(dr.getSize_x(rot)*zoomFac);
				new_drsy=(int)dr.getSize_y(rot);
			} else {
				new_drsx=(int)dr.getSize_x(rot);
				new_drsy=(int)(dr.getSize_y(rot)*zoomFac);
				}

			if (dr.getOrig_y(rot) == 0) {
				new_dry= 0;
				new_drx=(int) (dr.getOrig_x(r.getSize_x(), rot)*zoomFac);
			}
			if (dr.getOrig_y(rot) == r.getSize_y()) {
				new_dry=(int) new_sy - 4;
				new_drx=(int) (dr.getOrig_x(r.getSize_x(), rot)*zoomFac);
			}
			if (dr.getOrig_x(r.getSize_x(), rot) == 0) {
				new_drx= 0;
				new_dry=(int) (dr.getOrig_y(rot)*zoomFac);
			}
			if (dr.getOrig_x(r.getSize_x(), rot) == r.getSize_x()) {
				new_drx=(int) new_sx - 4;
				new_dry=(int) (dr.getOrig_y(rot)*zoomFac);
			}


			dr.setBounds(new_drx, new_dry, new_drsx, new_drsy);
			dr.setPreferredSize(new Dimension(new_drsx, new_drsy));
			dr.setBorder(BorderFactory.createEtchedBorder());
		}

		}

		visR.setMaxX(maxX);
		visR.setMaxY(maxY);

		visR.setPreferredSize(new Dimension(visR.getMaxX(),
							visR.getMaxY()));

		revalidate();
		repaint();
	}
}
