package jabba;

import com.sun.java.swing.table.AbstractTableModel;
import com.sun.java.swing.table.TableModel;
import com.sun.java.swing.event.TableModelListener;
import com.sun.java.swing.event.TableModelEvent;

// klasa bazowa dla wszelkich mappingow (nie mylic z mypingami :) ), w szczegolnosci dla sortera
/**
 * Based on an example taken from the Swing 1.0.1 release.
 */
class TableMap extends AbstractTableModel 
implements TableModelListener {
  TableModel model = null;

  public TableModel getModel() { 
    return model;
  }

  public void setModel( TableModel model ) { 
    this.model = model;
    this.model.addTableModelListener( this );
  }

  // implementacja TableModel - delegacja do modelu, ktory jest "pod spodem"
  public Object getValueAt( int r, int c ) {
    return model.getValueAt( r,c );
  }

  public void setValueAt( Object val, int r, int c ) {
    model.setValueAt( val,r,c );
  }

  public int getRowCount() {
    return model.getRowCount();
  }

  public int getColumnCount() {
    return model.getColumnCount();
  }

  public String getColumnName(int c) {
    return model.getColumnName(c);
  }

  public Class getColumnClass(int c) {
    return model.getColumnClass(c);
  }

  public boolean isCellEditable( int r, int c ) {
    return model.isCellEditable(r,c);
  }

  // implementacja TableModelListener
  public void tableChanged( TableModelEvent ev ) {
    fireTableChanged(ev);
  }

  public TableMap() {}
  public TableMap( TableModel tm ) {
    setModel( tm );
  }
}


