package jabba;

import com.sun.java.swing.table.TableModel;

class ViewerPersonTabDataModel extends AbstractJabbaDataModel implements JabbaConstants {
  // glowny obiekt programu
  Jabba jabba;

  // magazyn danych
  Receiver receiver;

  // obslugiwana zakladka
  ViewerPersonTab personTab;

  ViewerPersonTabDataModel( Jabba jabba, ViewerPersonTab tab ) {
    super();

    this.jabba = jabba;
    receiver = jabba.receiver;
    personTab = tab;

    jabba.console.addWriter( this, "viewer person tab data model" );
  }

  public void single_user_nameChanged(int pos) {
    personTab.nameLabel.setText( receiver.getUserName(pos) );
  }

  public void single_user_surnameChanged(int pos) {
    personTab.surnameLabel.setText( receiver.getUserSurname(pos) );
  }

  public void single_user_locationChanged(int pos) {
    personTab.locationLabel.setText( receiver.getUserLocationDescription(pos) );
  }

  public void single_user_phoneChanged(int pos) {
    personTab.phoneLabel.setText( "617 "+ receiver.getUserLocationPhones(pos) );
  }

  public void single_user_qualityChanged(int pos) {
    jabba.console.messageFrom( this, "single_user_qualityChanged() called." );
    jabba.console.trace( "single_user_qualityChanged() called." );
    personTab.qualityLabel.setText( ""+ receiver.getUserSightingQuality(pos) +"%" );
  }

  public void single_user_timeChanged(int pos) {
    personTab.timeLabel.setText( receiver.getUserSightingTime(pos).toString() );
  }
  
  public void single_user_emailChanged(int pos) {
    personTab.emailLabel.setText( receiver.getUserEmail(pos) );
  }

  public void single_user_positionChanged(int pos) {
    personTab.positionLabel.setText( receiver.getUserPosition(pos) );
  }

  /**
   * @param user - index in LocationRecord list
   */
  public void single_user_personJoined(int userId) {
    TableSorter ts = (TableSorter)(personTab.peopleTable.getModel());
    SimpleTableModel model = (SimpleTableModel)(ts.getModel());

    model.addRow(userId);
  }

  /**
   * @param user - index in LocationRecord list
   */
  public void single_user_personDisjoined(int userId) {
    TableSorter ts = (TableSorter)(personTab.peopleTable.getModel());
    SimpleTableModel model = (SimpleTableModel)(ts.getModel());

    model.deleteRow(userId);
  }

}



