//
//  File:         abng_location_descr_rep_observer_i.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 16.12.97
//
// General Description:
//   Header file for the implementation class of the Observer of 
//	the Abng_Location_Descr Repositoryinterface
//

#ifndef Sensor_Observer_i_h
#define Sensor_Observer_i_h

#include <stdio.h>
#include <fstream.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include "abng_location_descr_rep_i.h"

class Sensor_Observer_I  {

  static Sensor_Observer_I* _instance;

 public:
   // ctor
  Sensor_Observer_I ();

  virtual 
   ~Sensor_Observer_I ();

  // reference of CORBA object encapsulated this C++ object
  ABng_Core_System::System_Static_Data_Observer_ptr my_corba_object;

  static Sensor_Observer_I* instance() { return _instance; }


  //
  // IDL operations of the Static_Data_Observer interface
  //                       ___________________________
            
  virtual void 
   notify (
	Domain_Repository::Repository_Item_Id id,
	const ABng_Core_System::System_Static_Data_Observer::System_Static_Data_Object& sd, 
	Domain_Repository::Change_Type change
        ENV_DECL(env)
   );

  virtual void 
   abort (
	ENV_DECL1(env)
   );

  void reference_resolved(const ABng_Server_Manager::Name &name,
			  CORBA::Object_var server_ref);

protected:

  ABng_Core_Management::Sensor_Rep_ptr sensor_rep;
};   

#ifdef ORBIX
DEF_TIE_ABng_Core_System_System_Static_Data_Observer(Sensor_Observer_I)
#elif defined OMNIORB
// DEF_TIE__tie_System_Static_Data_Observer
#endif

#endif /* Sensor_Observer_i_h */




