// -*- Mode: C++; -*-
//
// $Id: Equip_Main.java,v 1.2 1998/07/29 13:34:41 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/equipment_rep/EquipmentRep/Equip_Main.java,v $
//
// $Log: Equip_Main.java,v $
// Revision 1.2  1998/07/29 13:34:41  mencnar
// complex_query implementation,
// delayed database commit to improve performance during
//  resolution of Meta Equipment rep.
//
// Revision 1.1  1998/06/18 08:33:19  mencnar
// Initial revision
//
// Revision 1.1  1998/01/28 08:23:51  mencnar
// Initial revision
//
//

package pl.edu.agh.ics.abngcore;

public class Equip_Main {
  public static String Repository_DB = "Equipment.db";

  public static ORB_wrapper my_orb_wrapper;
  
  private static void usage() {
    System.out.println("Usage: equip [options]\nThe following options can be used:\n-s \t\t Used when server is launched for the the first time (cold start)\n-d directory \t Specify the database directory");
    System.exit( 1);
  }

  public static void main( String argv[]) {
    my_orb_wrapper= new ORB_wrapper();

    my_orb_wrapper.init_application( argv);
   
    Equip_Rep equip_rep= null;
    Bootstrap_n.init();
    boolean coldstart= false;
    String db_directory= null;

    for (int i=0; i<argv.length; i++) {
      if ( argv[ i].equals("-s")) coldstart= true;
      else if ( argv[ i].equals("-d")) {
	if ( i+1 == argv.length) usage();
	if ( db_directory == null) db_directory= argv[ i+1];
	else db_directory= argv[ i+1]+"/"+db_directory;
      }
      else usage();		    
    }
    if ( db_directory != null) Repository_DB= db_directory+"/"+Repository_DB;

    if (coldstart) System.err.println("Cold start");
    try {
      equip_rep= new Equip_Rep( Repository_DB, 
				coldstart);
      my_orb_wrapper.connect_object( equip_rep.get_repository_object());
      my_orb_wrapper.connect_object( equip_rep.get_manager_object());
      new Process_Status( "equipment_repository", null);
    }
    catch ( Exception ex) {
	System.err.println(
            "Caught exception while instantiating server object " +ex);
	ex.printStackTrace();
	System.exit( 1);
    }    
    System.err.println("Calling impl_is_ready");
    my_orb_wrapper.impl_is_ready();        
  }
}
