#ifndef __LT_REP_SERVER_H__
#define __LT_REP_SERVER_H__ 1

#include "rep_server.h"
#include "location_type_rep_i.h"

class LT_Rep_Server : public Rep_Server {

public:

  LT_Rep_Server(
#ifdef ObjectStore
    const char *db_name_p = "dbName",
    int cold_start_p = 0,
#elif FilePersistency
    const char *file_name_p = "Location_Type_Rep.db",
#endif
#ifdef ORBIX
    long timeout_p = -1,
#endif
    const char *current_directory_p = ".",
    long interval_p = 60) : Rep_Server(
#ifdef ObjectStore
    db_name_p,
#elif FilePersistency
    file_name_p,
#endif
    current_directory_p) {}

  virtual ~LT_Rep_Server() {}

  virtual void create_objects();
  virtual void delete_objects();

protected:
  Location_Type_Rep_I *my_rep_i;
};

#endif __LT_REP_SERVER_H__





