#ifndef __BASIC_AB_OBSERVER_I_H__
#define __BASIC_AB_OBSERVER_I_H__

#include "basic_sabobserver_i.h"

class  Basic_AB_Observer_I : public Basic_Simple_AB_Observer_I {

  public:

    Basic_AB_Observer_I() : Basic_Simple_AB_Observer_I() {}
    virtual ~Basic_AB_Observer_I() {}

    virtual void sighting(
	const char *network_group_name,
        ABng_Poller::AB_Poller::Network_Id network, 
	ABng_Poller::AB_Poller::Station_Id station, 
	const ABng_Poller::AB_Poller::Badge_Id& badge,
	ABng_Poller::AB_Poller::Sighting_Code code,
	const ABng_Poller::AB_Poller::Field_Id& field,
        ABng_Poller::AB_Poller::Byte click_num,
	ABng_Poller::AB_Poller::Byte attributes,
	ABng_Poller::AB_Poller::Seq_Number seq,
	const ABng_Poller::AB_Poller::Time_Stamp& ts
	ENV_DECL(env) ) {}

    virtual void challenge_reply(
	const char *network_group_name,
        ABng_Poller::AB_Poller::Network_Id network, 
	ABng_Poller::AB_Poller::Station_Id station, 
	const ABng_Poller::AB_Poller::Badge_Id& badge, 
	const ABng_Poller::AB_Poller::Octets& random, 
	ABng_Poller::AB_Poller::Seq_Number seq,
	const ABng_Poller::AB_Poller::Time_Stamp& ts
	ENV_DECL(env) ) {}

    virtual void sound_reply(
	const char *network_group_name,
        ABng_Poller::AB_Poller::Network_Id network, 
	ABng_Poller::AB_Poller::Station_Id station, 
	const ABng_Poller::AB_Poller::Badge_Id& badge,
	const ABng_Poller::AB_Poller::Tones& sound, 
	ABng_Poller::AB_Poller::Seq_Number seq,
	const ABng_Poller::AB_Poller::Time_Stamp& ts
	ENV_DECL(env) ) {}

    virtual void set_state_reply(
	const char *network_group_name,
        ABng_Poller::AB_Poller::Network_Id network, 
	ABng_Poller::AB_Poller::Station_Id station, 
	const ABng_Poller::AB_Poller::Badge_Id& badge, 
	ABng_Poller::AB_Poller::Byte status, 
	const ABng_Poller::AB_Poller::Tones& sound, 
	ABng_Poller::AB_Poller::Seq_Number seq,
	const ABng_Poller::AB_Poller::Time_Stamp& ts
	ENV_DECL(env) ) {}

    virtual void get_state_reply(
	const char *network_group_name,
        ABng_Poller::AB_Poller::Network_Id network, 
	ABng_Poller::AB_Poller::Station_Id station, 
	const ABng_Poller::AB_Poller::Badge_Id& badge,
	ABng_Poller::AB_Poller::Byte major_version,
	ABng_Poller::AB_Poller::Byte minor_version,
	ABng_Poller::AB_Poller::Byte status, 
	ABng_Poller::AB_Poller::Seq_Number seq,
	const ABng_Poller::AB_Poller::Time_Stamp& ts
	ENV_DECL(env) ) {}

    virtual void set_home_reply(
	const char *network_group_name,
        ABng_Poller::AB_Poller::Network_Id network, 
	ABng_Poller::AB_Poller::Station_Id station, 
	const ABng_Poller::AB_Poller::Badge_Id& badge, 
	const ABng_Poller::AB_Poller::Address address, 
	ABng_Poller::AB_Poller::Seq_Number seq,
	const ABng_Poller::AB_Poller::Time_Stamp& ts
	ENV_DECL(env) ) {}

    virtual void get_home_reply(
	const char *network_group_name,
        ABng_Poller::AB_Poller::Network_Id network, 
	ABng_Poller::AB_Poller::Station_Id station, 
	const ABng_Poller::AB_Poller::Badge_Id& badge,
	const ABng_Poller::AB_Poller::Address address, 
	ABng_Poller::AB_Poller::Seq_Number seq,
	const ABng_Poller::AB_Poller::Time_Stamp& ts
	ENV_DECL(env) ) {}

    virtual void get_station_state_reply(
	const char *network_group_name,
        ABng_Poller::AB_Poller::Network_Id network, 
	ABng_Poller::AB_Poller::Station_Id station,
        ABng_Poller::AB_Poller::Byte major_version,
	ABng_Poller::AB_Poller::Byte minor_version,
	ABng_Poller::AB_Poller::Byte status1,
	ABng_Poller::AB_Poller::Byte status2, 
	const ABng_Poller::AB_Poller::Time_Stamp& ts
	ENV_DECL(env) ) {}

    virtual void null_message(
	const char *network_group_name,
        ABng_Poller::AB_Poller::Network_Id network, 
	ABng_Poller::AB_Poller::Station_Id station,
	const ABng_Poller::AB_Poller::Time_Stamp& ts
	ENV_DECL(env) ) {}

};

#endif /* __BASIC_AB_OBSERVER_I_H__ */
