// $Id: comparable_sensor_id.cc,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/comparable_sensor_id.cc,v $
//
// $Log: comparable_sensor_id.cc,v $
// Revision 1.1.1.1  1998/06/18 13:37:37  mencnar
//
// Revision 1.1  1998/03/06 13:24:17  jasz
// Initial revision
//
//
// File:          comparable_sensor_id.h
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  26.01.98
//
// General Description:
//  Definition the Comparable_Sensor_Id class. It encapsulates sensor id
//  and provides an equality testing operator.

#include <string.h>
#include "comparable_sensor_id.h"

unsigned Comparable_Sensor_Id::hash(const Comparable_Sensor_Id& sid) {

  unsigned res = 0;
  int len = strlen(sid.group_name);
  for(unsigned i = 0; i < len; i++) {
    res = (res << 8) | sid.group_name[i];
  }
  res = (res << 8) | sid.sensor_num;
  res = (res << 8) | sid.network_num;
  return res;
}

int Comparable_Sensor_Id::operator==(const Comparable_Sensor_Id& sid) {

  if(sensor_num == sid.sensor_num &&
     network_num == sid.network_num &&
     strcmp(group_name, sid.group_name) == 0) {
    return 1;
  }
  return 0;
}
