// -*- Mode: C++; -*-
//
//  File:         user_rep_server.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 17.02.98
//
// General Description:
//   Header file of the User_Rep_Server class
//

#ifndef user_rep_server_i_h
#define user_rep_server_i_h 1

#include "rep_server.h"
#include "user_rep_i.h"

class User_Rep_Server : public Rep_Server {

public:
   User_Rep_Server(
#ifdef ObjectStore
    	const char *db_name_p = "dbName",
#elif FilePersistency
    	const char *file_name_p = "User_Rep.db",
#endif
    	const char *current_directory_p = "."

   ) : Rep_Server(
#ifdef ObjectStore
    		db_name_p,
#elif FilePersistency
   		 file_name_p,
#endif
    		current_directory_p
	) {}

  virtual 
    ~User_Rep_Server() {}

  virtual void 
    create_objects();

  virtual void 
    delete_objects();

protected:
   User_Rep_I *my_rep_i;
};

#endif /* user_rep_server_i_h */





