#include "abng_loc_descr_client.h"

#include <stdlib.h>

ABng_Loc_Descr_Rep_Client::Operations 
 Rep_Client<ABng_Location_Description_Types>::operations = 
{{"remove_sensor", {"item ID | item IOR", "sensor ID | sensor IOR"}}, {"add_sensor", {"item ID | item IOR", "sensor ID | sensor IOR"}}};

char* Rep_Client<ABng_Location_Description_Types>::description = 
"\"location_descr_[ID|IOR] sensor_number sensor_[ID|IOR] sensor_[ID|IOR] ... \"";

ABng_Core_System::ABng_Location_Description::Description 
 ABng_Loc_Descr_Rep_Client::init_data(char* data) {
  
  ld_rep->init_rep_ptr();
  sensor_rep->init_rep_ptr();
  ABng_Core_System::ABng_Location_Description::Description d;

  char* name = read_id(data);
  d.loc_descr = ld_rep->init_item_ptr(name);
  delete name;

  d.sensor_list.length(read_long(data));

  for(int i = 0; i < d.sensor_list.length(); i ++) {
    name = read_id(data);
    d.sensor_list[i] = sensor_rep->init_item_ptr(name);
    delete name;

  }
  return d;
}



void ABng_Loc_Descr_Rep_Client::other_operations() {

  sensor_rep->init_rep_ptr();

  ABng_Core_System::ABng_Location_Description_ptr a = 
    Basic_Client<ABng_Location_Description_Types>::init_item_ptr(
      my_argv[my_argc-2]
    );
  ABng_Core_System::Sensor_ptr s = 
     sensor_rep->init_item_ptr(my_argv[my_argc-1]);
  try {
     if(!strcmp(operation, "add_sensor")) {
        a->add(s);
     }
     else if(!strcmp(operation, "remove_sensor")) {
             a->remove(s);
          }
  } catch(Domain_Repository::Unknown_Object_Ref) {
         cerr << "Exception: Domain_Repository::Unknown_Object_Ref" << endl;
         exit(1);
  } catch(Domain_Repository::Duplicate_Data_Record) {
         cerr << "Exception: Domain_Repository::Duplicate_Data_Record" 
              << endl;
         exit(1);
  } catch(CORBA::SystemException ex) {
         cerr << "Exception: CORBA::SystemException " << ex << endl;
         exit(1);
  } catch(...) {
         cerr << "Exception: Unknown" << endl;
         exit(1);
  }
}




