//
//  File:         badge_holder_rep_client.cc
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 26.05.98
//
// General Description:
//   Implementation file for the class of a client of the Badge_Holder 
//	 Repository interface
//

#include "badge_holder_rep_client.h"
#include <stdlib.h>

extern "C"      int isalpha(int c);
extern "C"      int isdigit(int c);

Badge_Holder_Rep_Client::Operations Rep_Client<Badge_Holder_Types>::operations = 
  {{0, {0}}};

char* Rep_Client<Badge_Holder_Types>::description = 
"\"my_badge_[ID|IOR] current_badge_[ID|IOR] home_sensor_[ID|IOR] kind_of_description_object_[U|E] description_object_[ID|IOR] is_assigned is_visitor\"";


ABng_Core_System::Badge_Holder::Description 
   Badge_Holder_Rep_Client::init_data (
	char* data
   ) 
{	
	ABng_Core_System::Badge_Holder::Description d;
	badge_rep->init_rep_ptr();
	sensor_rep->init_rep_ptr();
	user_rep->init_rep_ptr();
	equipment_rep->init_rep_ptr();

  	char* name;

	name = read_id(data);
  	d.my_badge = badge_rep->init_item_ptr(name);
  	delete name;

	name = read_id(data);
  	d.current_badge = badge_rep->init_item_ptr(name);
  	delete name;

	name = read_id(data);
  	d.home_sensor = sensor_rep->init_item_ptr(name);
  	delete name;
	
	name = read_id(data);
	if (!strcmp(name, "U")) {
		delete name;
		name = read_id(data);
  		d.type_specific_object.user_obj(user_rep->init_item_ptr(name));
  		delete name;
	}
	else 
	if (!strcmp(name, "E")) {
		delete name;
		name = read_id(data);
  		d.type_specific_object.equipment_obj(equipment_rep->init_item_ptr(name));
  		delete name;
	}
	else {
		cerr << "Unknown kind of description object "<< name;
		cerr << " Stopped at: " << data << endl << endl;
		print_info();
		exit(1);
	}

	d.assigned= read_boolean(data);
	d.visitor= read_boolean(data);

	return d;
}







