// $Id: badge_rep_cl.cc,v 1.1 1998/06/18 14:11:10 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/utils/badge_rep_util/badge_rep_cl.cc,v $
//
// $Log: badge_rep_cl.cc,v $
//
// Revision 1.1  1998/01/13 12:12:16  mencnar
// Initial revision
//
//
// File:          badge_rep_cl.cc
// Author:        Daniel Mencnarowski (mencnar@ics.agh.edu.pl)
// Date Created:  07.01.98
//
// General Description:
//   Implementation file for the Badge_Rep client
//

#define USE_IIOP
#define USE_IR

#include "CORBA.h"
#include "abng_core_management.hh"
#include "omnithread.h"
#include <iostream.h>
#include <stdio.h>
#include <fstream.h>
#include <stdlib.h>
#include <unistd.h>
#include <rw/tvdlist.h>


#include <fstream.h>

#define Badge_Rep_IOR_File "./Badge_Rep_iiop.ref"
#define Badge_Data_File    "./badges.dat"

ostream & operator << ( ostream &str, const _IDL_SEQUENCE_octet &seq) {
  str << "<";
  for (int i=0; i<seq.length(); i++) {
    if (i>0) str << " ";
    str << hex << (int) seq[i];
  }
  str << ">";
  return str;
}

istream & operator >> ( istream &istr, _IDL_SEQUENCE_octet &seq) {
  char c;
  istr >> ws;
  if (istr.peek() != '<') {
    istr.clear( iostream::failbit|istr.rdstate());
    return istr;
  }
  istr >> c;
  if (!istr) return istr;

  istr >> hex;
  RWTValDlist<CORBA::Octet> seq_list;
  do {
    int val;
    istr >> val;
    if (istr) seq_list.append( (CORBA::Octet) val);
  } while (istr);
  istr.clear( iostream::goodbit);
  istr >> ws;
  istr >> c;
  //  cout << "c== " << (int) c << "  " << c << endl;
  if (c != '>') {
    istr.clear( iostream::failbit|istr.rdstate());
    return istr;
  }
  int size= seq_list.entries();
  seq.length( size);

  for (int i=0; i<size; i++)
    seq[i]= seq_list[i];

  istr >> dec;
  return istr;
}

class NullBadgeHolder : public ABng_Core_System::Badge_HolderBOAImpl {
public:
   virtual ABng_Core_System::System_Static_Data_Observed_E::System_Static_Data_Observers*
   system_static_data_observer_list (
        CORBA::Environment &IT_env=CORBA::default_environment
   ) 
     throw (CORBA::SystemException) { return NULL; }

  virtual void 
   attach_system_static_data_observer (
        ABng_Core_System::System_Static_Data_Observer_ptr obs,  
        CORBA::Environment &IT_env=CORBA::default_environment
   )
    throw (CORBA::SystemException) { return; }

  virtual void 
   dettach_system_static_data_observer (
        ABng_Core_System::System_Static_Data_Observer_ptr obs, 
        CORBA::Environment &IT_env=CORBA::default_environment
   ) 
                throw (CORBA::SystemException, 
    Domain_Repository::Unknown_Observer) { return; }

  virtual ABng_Core_System::Badge_Holder::Description* 
   descr (
        CORBA::Environment &IT_env=CORBA::default_environment
   ) 
    throw (CORBA::SystemException) { return NULL; }

  virtual Domain_Repository::Repository_Item_Id 
   item_id (
        CORBA::Environment &IT_env=CORBA::default_environment
   ) 
    throw (CORBA::SystemException) { return 13; }

  virtual ABng_Core_System::Badge_ptr my_badge (
CORBA::Environment &IT_env=CORBA::default_environment) { return NULL; }

  virtual ABng_Core_System::Badge_ptr current_badge (
CORBA::Environment &IT_env=CORBA::default_environment) { return NULL; }

  virtual ABng_Core_System::Sensor_ptr home_sensor (
CORBA::Environment &IT_env=CORBA::default_environment) { return NULL; }

  virtual ABng_Core::Locatable_Type_Specific_Object* type_specific_object (
CORBA::Environment &IT_env=CORBA::default_environment) { return NULL; }
 
  
};

static void register_impl( void *arg) {
  CORBA::BOA_ptr boa_ptr= (CORBA::BOA_ptr) arg;
  try {
#ifdef ORBIX
    boa_ptr->processEvents( CORBA::ORB::INFINITE_TIMEOUT);
#else
    boa_ptr->impl_is_ready();
#endif
  }
  catch ( CORBA::SystemException &ex) {
    cout << "Caught system exception " << ex
         << " -- impl_is_ready" << endl;
    return;
  }
}



int main (void) {
	CORBA::Object_ptr obj_ptr;   
	Badge_Rep_ptr my_badge_rep_ptr;
	NullBadgeHolder bholder;


	char ref_str[500];

	ifstream strm(Badge_Rep_IOR_File);

	// Initialise the Badge_Rep from the file
	ifstream strm_badge_data(Badge_Data_File);
	int badge_number;
	ABng_Core_System::Badge::Description badge_data_record;
	char pom[100];
	int i, j;

  omni_thread *reg_thread= new omni_thread( register_impl, & CORBA::Orbix);
  reg_thread->start();
  cout << "reg_thread started" << endl;
 
	if (!strm){
		cerr << "Badge_Rep client error: Unable to open file - ";
		cerr << Badge_Rep_IOR_File << endl;
		return 0;
	}
	strm >> ref_str;
	strm.close();

	// get the obj referance
	try {
		obj_ptr = CORBA::Orbix.string_to_object(ref_str);
	} catch (CORBA::SystemException& se) {
		cerr << "Badge_Rep client error: Exception! - " << &se << endl;
		exit(1);
	}
	cerr << "Badge_Rep client: got Badge_Rep object reference" << endl;

	// check if its nil
	if (CORBA::is_nil(obj_ptr)){     
		cerr << "Badge_Rep client error: ";
		cerr << "Badge_Rep object reference is nill!" << endl;
		exit(-1);
	}

	// attempt to narrow
	try {
		my_badge_rep_ptr = ABng_Core_Management::Badge_Rep::_narrow(obj_ptr);
	} catch (CORBA::SystemException& se){
		cerr << "Badge_Rep client error: ";
		cerr << "exception when trying to _narrow! " << &se << endl;
	}

	// check if my_badge_rep_ptr is nil
	if (CORBA::is_nil(my_badge_rep_ptr)){
		cerr << "Badge_Rep client error: ";
		cerr << "failed to narrow object reference!" << endl;
		exit(-1);
	}
	
	// Contact with Badge_Rep established

	if (!strm_badge_data){
		cerr << "Badge_Rep client error: Unable to open file - ";
		cerr << Badge_Data_File << endl;
		exit(-1);
	}

	badge_data_record.item_id = 1;
	cerr << CORBA::Orbix.object_to_string( &bholder) << "#" << endl;
	//      	badge_data_record.holder= ABng_Core_System::Badge_Holder::_duplicate( &bholder);
	char * stringObj;

	// read data from file
	j = 0;
	strm_badge_data >> badge_number;
	ABng_Core_System::Badge_ptr new_badge_ptr;

	for(i = 0; i < badge_number; i++){
	  
		cerr << "Badge_Rep client: adding " << i << " badge to the repository" << endl;

		strm_badge_data >> badge_data_record.id;
		cerr << badge_data_record.id << endl;
		

		try {
			// try to add this badge
    			new_badge_ptr = 
				my_badge_rep_ptr->add(badge_data_record);
		} catch (Domain_Repository::Duplicate_Data_Record &ex) {
			cerr << "Badge_Rep client error: ";
			cerr << "call to add failed, duplicated record"<< endl << endl;
			continue;
		} catch (CORBA::SystemException &sysEx) {
			cerr << "Badge_Rep client error: ";
			cerr << "call to add failed, unexpected system exception: " << &sysEx << endl;
			exit(1);
		} 

		try {
			stringObj = my_badge_rep_ptr->
				_object_to_string(CORBA::IT_INTEROPERABLE_OR_KIND);
  		}
 		catch(CORBA::SystemException &sysEx) {
			cerr << "Unexpected system exception: " << &sysEx << endl; 
		}
			
		cout << "Badge IOR: " << endl << stringObj << endl << endl;
		CORBA::string_free(stringObj);

		try {
			// try to get item id of this badge
    			cerr << "Badge_Rep client: badge Item id = " << new_badge_ptr->item_id() << endl;
		} catch (CORBA::SystemException &sysEx) {
			cerr << "Badge_Rep client error: ";
			cerr << "call to get item_id failed, unexpected system exception: " << &sysEx << endl;
			exit(1);
		}

		ABng_Core_System::Badge_Id bid( badge_data_record.id);
		bid.length( bid.length()+1);
		bid[ bid.length()-1]= 99;

		badge_data_record.id = bid;

		try {
			// try to update this badge
	       		  my_badge_rep_ptr->update(new_badge_ptr, badge_data_record);
		} catch (Domain_Repository::Duplicate_Data_Record &ex) {
			cerr << "Badge_Rep client error: ";
			cerr << "call to update failed, duplicated record"<< endl << endl;
			continue;
		} catch (Domain_Repository::Unknown_Object_Ref &ex) {
			cerr << "Badge_Rep client error: ";
			cerr << "call to update failed, unknown object ref"<< endl << endl;
			continue;
		} catch (CORBA::SystemException &sysEx) {
			cerr << "Badge_Rep client error: ";
			cerr << "call to remove failed, unexpected system exception: " << &sysEx << endl;
			exit(1);
		}

		cerr << "Badge_Rep client: " << dec << i << " badge updated" << endl;
		sleep(1);
		try {
			// try to remove this badge
			my_badge_rep_ptr->remove(new_badge_ptr);
		} catch (Domain_Repository::Unknown_Object_Ref &ex) {
			cerr << "Badge_Rep client error: ";
			cerr << "call to remove failed, unknown object ref"<< endl << endl;
			exit(1);
			continue;
		} catch (CORBA::SystemException &sysEx) {
			cerr << "Badge_Rep client error: ";
			cerr << "call to remove failed, unexpected system exception: " << &sysEx << endl;
			exit(1);
		}
		cerr << "Badge_Rep client: " << i << " badge removed" << endl << endl;
	}


  	// no problem seting all the badges
 
  	// tidy up
  	// CORBA::release(my_badge_rep_ptr);
  	cout << endl << "exiting.. Everything OK!!" << endl << endl;
  
	return 0;
}

