#include <stdlib.h>
#include "equipment_client.h"

extern "C"      int isalpha(int c);
extern "C"      int isdigit(int c);




Equipment_Client::Operations Rep_Client<Equipment_Types_Mgr>::operations = {{0, {0}}};

char* Rep_Client<Equipment_Types_Mgr>::description = "\"meta_equipment_[ID(long)|IOR(string)] name(string) last_command(string) property_value(appropriate type) property_value(appropriate type) ...\"";

Domain_Repository::Equipment::Description 
  Equipment_Client::init_data(char* data) {

  meta_equipment_rep->init_rep_ptr();

  Domain_Repository::Equipment::Description descr;

  char* str = read_string(data);
  descr.meta_data = meta_equipment_rep->init_item_ptr(str);
  delete str;

  descr.name = read_id(data);
  descr.last_command = read_string(data);

  try {
    Domain_Repository::Property_Descriptions *pdescrs = 
       descr.meta_data->specific_property_description_list();
    descr.property_list.length(pdescrs->length());
    for(int i = 0; i < pdescrs->length(); i ++) {
      descr.property_list[i].name = CORBA::string_dup((*pdescrs)[i].name);
      cout <<  descr.property_list[i].name << " "
#ifdef ORBIX
           << *(*pdescrs)[i].type << " " << (int) ((*pdescrs)[i].type->kind())
#elif defined OMNIORB 
#endif
	   << endl;
      void * value = read_void((*pdescrs)[i].type, data);
      descr.property_list[i].value.replace((*pdescrs)[i].type, value);
    }
  } catch(...) {
    cerr << "Exception has been thrown" << endl;
    exit(1);
  }
  return descr;
}






