#ifdef ORBIX
#include <CORBA.h>
#elif defined OMNIORB
#include <omniORB2/CORBA.h>
#endif

#include <iostream.h>
#include <stdlib.h>
#include "compatibility.hh"

int main(int argc, char **argv) {
  CORBA::ORB_ptr orb_ptr= CORBA::ORB_init( argc, argv, ORB_IDENTIFIER);
  CORBA::BOA_ptr boa_ptr= orb_ptr->BOA_init( argc, argv, BOA_IDENTIFIER);

  char buf[2048];
  cin >> buf;
  CORBA::Object_ptr obj;
  try {
    obj= orb_ptr->string_to_object( buf);
  }
  catch (CORBA::Exception &ex) {
    cerr << "Exception " << ex << " (string_to_object)" << endl;
    exit(-1);
  }
  try {
    int dead= obj->_non_existent();
    cerr << "NON_EXISTENT " << dead << " == " << (dead ? "DEAD" : "ALIVE") << endl;
  }
  catch (CORBA::Exception &ex) {
    cerr << "Exception " << ex << " (_non_existent)" << endl;
    exit(-1);
  }
  cout << orb_ptr->object_to_string( obj);
  return 0;
}
