
#ifndef tevent_hh
#define tevent_hh

#define CALL_SPEC 
#include <CORBA.h>

#include <string.h>


#include <domain_rep.hh>


#include <abng_core.hh>


#include "tevent_data_observed_e.hh"

class TEvent;

#ifndef TEventPtr
#define TEventPtr
typedef TEvent* TEvent_ptr;
typedef TEvent* TEventRef;
#endif

#ifndef TEvent_ptrTypedefs
#define TEvent_ptrTypedefs
typedef const TEvent* TEvent_cptr;
#endif


#ifndef TEventForwH
#define TEventForwH
CORBA::ObjectRef CALL_SPEC TEvent_getBase (void *);
void CALL_SPEC TEvent_release (TEvent *, CORBA::Environment &IT_env);
void CALL_SPEC TEvent_release (TEvent_ptr);
TEvent* CALL_SPEC TEvent_duplicate (TEvent_ptr, CORBA::Environment &IT_env);
TEvent* CALL_SPEC TEvent_duplicate (TEvent_ptr );
TEvent_ptr CALL_SPEC TEvent_nil (CORBA::Environment &IT_env);
TEvent_ptr CALL_SPEC TEvent_nil ();
#endif
#ifndef TEventMgrH
#define TEventMgrH

class TEvent_var;

class TEvent_SeqElem;

#ifndef TEvent_ptrTypedefs
#define TEvent_ptrTypedefs
typedef const TEvent* TEvent_cptr;
#endif

class TEvent_mgr : public CORBA::_mgr
{
    public:

    TEvent_mgr ();
    TEvent_mgr (const TEvent_mgr &IT_s);
    TEvent_mgr (TEvent_var IT_s);
    TEvent_mgr (const TEvent_SeqElem &IT_s);
    TEvent_mgr &operator= (TEvent_ptr IT_p);
    TEvent_mgr &operator= (const TEvent_mgr &IT_s);
    TEvent_mgr &operator= (TEvent_var IT_s);
    TEvent_mgr &operator= (const TEvent_SeqElem &IT_s);
    ~TEvent_mgr ();
    TEvent_ptr operator-> () const;
    operator ! () const;
    operator TEvent_ptr& () ;
    operator const TEvent_ptr& () const;
    TEvent_ptr _ptr;

    operator CORBA::Object_ptr () const;
    TEvent_ptr in () const;
    TEvent_ptr& inOut ();
    TEvent_ptr& out ();
    TEvent_ptr ret () const;
};

#endif

#ifndef TEventSeqElemH
#define TEventSeqElemH

class TEvent_SeqElem : public CORBA::_SeqElem
{
    public:

    TEvent_SeqElem (TEvent_ptr* IT_p, unsigned char rel);
    TEvent_SeqElem &operator= (TEvent_ptr IT_p);
    TEvent_SeqElem &operator= (const TEvent_SeqElem &IT_s);
    TEvent_SeqElem &operator= (const TEvent_mgr &IT_s);
    TEvent_SeqElem &operator= (TEvent_var IT_s);
    operator ! () const;
    operator const TEvent_ptr& () const;
    operator CORBA::Object_ptr () const;
    TEvent_ptr in () const;
    TEvent_ptr& inOut ();
    TEvent_ptr& out ();
    TEvent_ptr ret () const;
    TEvent_ptr operator->() const;

    protected:
    TEvent_ptr *_ptr;
    unsigned char _release;
};

#endif

#define TEvent_IMPL "TEvent"


#ifndef _IDL_SEQUENCE_TEvent_defined
#define _IDL_SEQUENCE_TEvent_defined

class  _IDL_SEQUENCE_TEvent {
    CORBA::ULong _maximum;
    CORBA::ULong _length;
    TEvent_ptr* _buffer;
    unsigned char _release;

    public:
    _IDL_SEQUENCE_TEvent& operator= (const _IDL_SEQUENCE_TEvent&);
    _IDL_SEQUENCE_TEvent (const _IDL_SEQUENCE_TEvent&);

    _IDL_SEQUENCE_TEvent (CORBA::ULong max);
    _IDL_SEQUENCE_TEvent (CORBA::ULong max, CORBA::ULong length, TEvent_ptr* data, CORBA::Boolean release = 0);
    _IDL_SEQUENCE_TEvent ();

    ~_IDL_SEQUENCE_TEvent ();

    static TEvent_ptr* CALL_SPEC allocbuf(CORBA::ULong nelems);
    static void CALL_SPEC freebuf(TEvent_ptr* data);

    CORBA::ULong maximum() const;
    CORBA::ULong length() const;
    void length (CORBA::ULong len);

    TEvent_SeqElem operator [] (CORBA::ULong IT_i);

    const TEvent_SeqElem operator [] (CORBA::ULong IT_i) const;

    void assignbuf (CORBA::ULong max, CORBA::ULong length, TEvent_ptr* data, CORBA::Boolean release = 0);
    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);
};

#ifndef _IDL_SEQUENCE_TEventVarH
#define _IDL_SEQUENCE_TEventVarH

#ifndef _IDL_SEQUENCE_TEvent_ptrTypedefsNC
#define _IDL_SEQUENCE_TEvent_ptrTypedefsNC
typedef _IDL_SEQUENCE_TEvent* _IDL_SEQUENCE_TEvent_ptr;
#endif

#ifndef _IDL_SEQUENCE_TEvent_ptrTypedefs
#define _IDL_SEQUENCE_TEvent_ptrTypedefs
typedef const _IDL_SEQUENCE_TEvent* _IDL_SEQUENCE_TEvent_cptr;
#endif

class _IDL_SEQUENCE_TEvent_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const _IDL_SEQUENCE_TEvent_var &IT_s);

    public:

    _IDL_SEQUENCE_TEvent_var (const _IDL_SEQUENCE_TEvent_var &IT_s);
    _IDL_SEQUENCE_TEvent_var ();
    _IDL_SEQUENCE_TEvent_var (_IDL_SEQUENCE_TEvent_ptr IT_p);
    _IDL_SEQUENCE_TEvent_var &operator= (_IDL_SEQUENCE_TEvent_ptr IT_p);
    _IDL_SEQUENCE_TEvent_var &operator= (const _IDL_SEQUENCE_TEvent_var &IT_s);
    ~_IDL_SEQUENCE_TEvent_var ();
    _IDL_SEQUENCE_TEvent_ptr operator-> () const;
    operator ! () const;
    operator _IDL_SEQUENCE_TEvent_ptr& () ;
    operator const _IDL_SEQUENCE_TEvent_cptr& () const;
    operator _IDL_SEQUENCE_TEvent& () const;

    const _IDL_SEQUENCE_TEvent in () const;
    _IDL_SEQUENCE_TEvent& inOut ();
    _IDL_SEQUENCE_TEvent*& out ();
    _IDL_SEQUENCE_TEvent* ret () const;
    const TEvent_SeqElem operator[] (CORBA::ULong index) const;

    TEvent_SeqElem operator[] (CORBA::ULong index);

    protected:
    _IDL_SEQUENCE_TEvent_ptr* _indPtr;
    _IDL_SEQUENCE_TEvent_ptr& _ptr;
    private:
    static _IDL_SEQUENCE_TEvent_ptr* _newPtr ();
    _IDL_SEQUENCE_TEvent_var &operator= (const CORBA::_var &IT_s);
    _IDL_SEQUENCE_TEvent_var (const CORBA::_var &IT_s);
};

#endif


#endif

typedef _IDL_SEQUENCE_TEvent TEvents;

typedef const _IDL_SEQUENCE_TEvent TEvents_IT_const;

typedef _IDL_SEQUENCE_TEvent_var TEvents_var;


#ifndef _TEvent_defined
#define _TEvent_defined
class TEvent_dispatch : public virtual TEvent_Data_Observed_E_dispatch {
public:

      TEvent_dispatch (void *IT_p, CORBA::Object* IT_o, const char *IT_m, 
        CORBA::LoaderClass *IT_l, char *IT_i, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_l,IT_i,IT_im) {}


   TEvent_dispatch (char *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_dispatch () {}

   TEvent_dispatch (ObjectReferenceImpl *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_dispatch (void *IT_p, CORBA::Object *IT_o, const char *IT_m, 
        char *IT_i, CORBA::Object* IT_ob, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_i,IT_ob,IT_im) {}


   virtual unsigned char dispatch (CORBA::Request &IT_r, 
        unsigned char IT_isTarget, void* IT_pp=NULL);


};

class TEvent;

#ifndef TEventPtr
#define TEventPtr
typedef TEvent* TEvent_ptr;
typedef TEvent* TEventRef;
#endif

#ifndef TEvent_ptrTypedefs
#define TEvent_ptrTypedefs
typedef const TEvent* TEvent_cptr;
#endif


#ifndef TEventForwH
#define TEventForwH
CORBA::ObjectRef CALL_SPEC TEvent_getBase (void *);
void CALL_SPEC TEvent_release (TEvent *, CORBA::Environment &IT_env);
void CALL_SPEC TEvent_release (TEvent_ptr);
TEvent* CALL_SPEC TEvent_duplicate (TEvent_ptr, CORBA::Environment &IT_env);
TEvent* CALL_SPEC TEvent_duplicate (TEvent_ptr );
TEvent_ptr CALL_SPEC TEvent_nil (CORBA::Environment &IT_env);
TEvent_ptr CALL_SPEC TEvent_nil ();
#endif
#ifndef TEventMgrH
#define TEventMgrH

class TEvent_var;

class TEvent_SeqElem;

#ifndef TEvent_ptrTypedefs
#define TEvent_ptrTypedefs
typedef const TEvent* TEvent_cptr;
#endif

class TEvent_mgr : public CORBA::_mgr
{
    public:

    TEvent_mgr ();
    TEvent_mgr (const TEvent_mgr &IT_s);
    TEvent_mgr (TEvent_var IT_s);
    TEvent_mgr (const TEvent_SeqElem &IT_s);
    TEvent_mgr &operator= (TEvent_ptr IT_p);
    TEvent_mgr &operator= (const TEvent_mgr &IT_s);
    TEvent_mgr &operator= (TEvent_var IT_s);
    TEvent_mgr &operator= (const TEvent_SeqElem &IT_s);
    ~TEvent_mgr ();
    TEvent_ptr operator-> () const;
    operator ! () const;
    operator TEvent_ptr& () ;
    operator const TEvent_ptr& () const;
    TEvent_ptr _ptr;

    operator CORBA::Object_ptr () const;
    TEvent_ptr in () const;
    TEvent_ptr& inOut ();
    TEvent_ptr& out ();
    TEvent_ptr ret () const;
};

#endif

#ifndef TEventSeqElemH
#define TEventSeqElemH

class TEvent_SeqElem : public CORBA::_SeqElem
{
    public:

    TEvent_SeqElem (TEvent_ptr* IT_p, unsigned char rel);
    TEvent_SeqElem &operator= (TEvent_ptr IT_p);
    TEvent_SeqElem &operator= (const TEvent_SeqElem &IT_s);
    TEvent_SeqElem &operator= (const TEvent_mgr &IT_s);
    TEvent_SeqElem &operator= (TEvent_var IT_s);
    operator ! () const;
    operator const TEvent_ptr& () const;
    operator CORBA::Object_ptr () const;
    TEvent_ptr in () const;
    TEvent_ptr& inOut ();
    TEvent_ptr& out ();
    TEvent_ptr ret () const;
    TEvent_ptr operator->() const;

    protected:
    TEvent_ptr *_ptr;
    unsigned char _release;
};

#endif

#define TEvent_IMPL "TEvent"


class TEvent;

typedef TEvent TEventProxy;
#define TEvent_IR "TEvent"
#define TEvent_IMPL "TEvent"

#ifndef TEventPtr
#define TEventPtr
typedef TEvent* TEvent_ptr;
typedef TEvent* TEventRef;
#endif

#ifndef TEvent_ptrTypedefs
#define TEvent_ptrTypedefs
typedef const TEvent* TEvent_cptr;
#endif

class TEvent: public virtual TEvent_Data_Observed_E {
public:
        TEvent (char *IT_OR);
    TEvent (ObjectReferenceImpl *IT_OR);
    TEvent () : CORBA::Object  (1) {}
protected:
    TEvent_ptr __duplicate(
            CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) {
       CORBA::Object::__duplicate (IT_env);
       return this;
    }
public:
    static TEvent_ptr CALL_SPEC _duplicate(
            TEvent_ptr, 
            CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ());
public:
   static TEvent* CALL_SPEC _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
   static TEvent* CALL_SPEC _bind (CORBA::Environment &IT_env);
   static TEvent* CALL_SPEC _bind (const char* IT_markerServer=NULL, const char* host=NULL,
                 CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
    static TEvent* CALL_SPEC _narrow (CORBA::Object* , CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
private:
    static const void* IT_impl;
public:
    static TEvent_ptr CALL_SPEC  _nil (CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ()) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        return (TEvent_ptr) CORBA::OBJECT_NIL;}
typedef char * TEventContext;
typedef const char * TEventContext_IT_const;

typedef CORBA::String_var TEventContext_var;

typedef Domain_Repository::String_Pattern TEventContextPattern;
typedef const Domain_Repository::String_Pattern TEventContextPattern_IT_const;

typedef Domain_Repository::String_Pattern_var TEventContextPattern_var;

typedef CORBA::Boolean TEventState;
typedef const CORBA::Boolean TEventState_IT_const;


typedef Domain_Repository::Boolean_Pattern TEventStatePattern;
typedef const Domain_Repository::Boolean_Pattern TEventStatePattern_IT_const;

typedef Domain_Repository::Boolean_Pattern_var TEventStatePattern_var;

enum StateMsg {StateChange,StateInitial,StateUpdate, IT__ENUM_TEvent_StateMsg=CORBA_ULONG_MAX};

#ifndef TEvent_Description_defined
#define TEvent_Description_defined

struct Description {
    CORBA::ULong item_id;
    CORBA::String_mgr formula;
    CORBA::Boolean state;

    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);
    Description(const Description &);
    Description();
    ~Description();
    Description& operator= (const Description&);
};

#ifndef TEvent_DescriptionVarH
#define TEvent_DescriptionVarH

#ifndef TEvent_Description_ptrTypedefsNC
#define TEvent_Description_ptrTypedefsNC
typedef Description* Description_ptr;
#endif

#ifndef TEvent_Description_ptrTypedefs
#define TEvent_Description_ptrTypedefs
typedef const Description* Description_cptr;
#endif

class Description_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const Description_var &IT_s);

    public:

    Description_var (const Description_var &IT_s);
    Description_var ();
    Description_var (Description_ptr IT_p);
    Description_var &operator= (Description_ptr IT_p);
    Description_var &operator= (const Description_var &IT_s);
    ~Description_var ();
    Description_ptr operator-> () const;
    operator ! () const;
    operator Description_ptr& () ;
    operator const Description_cptr& () const;
    operator Description& () const;

    const Description in () const;
    Description& inOut ();
    Description*& out ();
    Description* ret () const;
    protected:
    Description_ptr* _indPtr;
    Description_ptr& _ptr;
    private:
    static Description_ptr* _newPtr ();
    Description_var &operator= (const CORBA::_var &IT_s);
    Description_var (const CORBA::_var &IT_s);
};

#endif


#endif


#ifndef TEvent__IDL_SEQUENCE_TEvent_Description_defined
#define TEvent__IDL_SEQUENCE_TEvent_Description_defined

class  _IDL_SEQUENCE_TEvent_Description {
    CORBA::ULong _maximum;
    CORBA::ULong _length;
    Description* _buffer;
    unsigned char _release;

    public:
    _IDL_SEQUENCE_TEvent_Description& operator= (const _IDL_SEQUENCE_TEvent_Description&);
    _IDL_SEQUENCE_TEvent_Description (const _IDL_SEQUENCE_TEvent_Description&);

    _IDL_SEQUENCE_TEvent_Description (CORBA::ULong max);
    _IDL_SEQUENCE_TEvent_Description (CORBA::ULong max, CORBA::ULong length, Description* data, CORBA::Boolean release = 0);
    _IDL_SEQUENCE_TEvent_Description ();

    ~_IDL_SEQUENCE_TEvent_Description ();

    static Description* CALL_SPEC allocbuf(CORBA::ULong nelems);
    static void CALL_SPEC freebuf(Description* data);

    CORBA::ULong maximum() const;
    CORBA::ULong length() const;
    void length (CORBA::ULong len);

    Description& operator [] (CORBA::ULong IT_i);

    const Description& operator [] (CORBA::ULong IT_i) const;

    void assignbuf (CORBA::ULong max, CORBA::ULong length, Description* data, CORBA::Boolean release = 0);
    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);
};

#ifndef TEvent__IDL_SEQUENCE_TEvent_DescriptionVarH
#define TEvent__IDL_SEQUENCE_TEvent_DescriptionVarH

#ifndef TEvent__IDL_SEQUENCE_TEvent_Description_ptrTypedefsNC
#define TEvent__IDL_SEQUENCE_TEvent_Description_ptrTypedefsNC
typedef _IDL_SEQUENCE_TEvent_Description* _IDL_SEQUENCE_TEvent_Description_ptr;
#endif

#ifndef TEvent__IDL_SEQUENCE_TEvent_Description_ptrTypedefs
#define TEvent__IDL_SEQUENCE_TEvent_Description_ptrTypedefs
typedef const _IDL_SEQUENCE_TEvent_Description* _IDL_SEQUENCE_TEvent_Description_cptr;
#endif

class _IDL_SEQUENCE_TEvent_Description_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const _IDL_SEQUENCE_TEvent_Description_var &IT_s);

    public:

    _IDL_SEQUENCE_TEvent_Description_var (const _IDL_SEQUENCE_TEvent_Description_var &IT_s);
    _IDL_SEQUENCE_TEvent_Description_var ();
    _IDL_SEQUENCE_TEvent_Description_var (_IDL_SEQUENCE_TEvent_Description_ptr IT_p);
    _IDL_SEQUENCE_TEvent_Description_var &operator= (_IDL_SEQUENCE_TEvent_Description_ptr IT_p);
    _IDL_SEQUENCE_TEvent_Description_var &operator= (const _IDL_SEQUENCE_TEvent_Description_var &IT_s);
    ~_IDL_SEQUENCE_TEvent_Description_var ();
    _IDL_SEQUENCE_TEvent_Description_ptr operator-> () const;
    operator ! () const;
    operator _IDL_SEQUENCE_TEvent_Description_ptr& () ;
    operator const _IDL_SEQUENCE_TEvent_Description_cptr& () const;
    operator _IDL_SEQUENCE_TEvent_Description& () const;

    const _IDL_SEQUENCE_TEvent_Description in () const;
    _IDL_SEQUENCE_TEvent_Description& inOut ();
    _IDL_SEQUENCE_TEvent_Description*& out ();
    _IDL_SEQUENCE_TEvent_Description* ret () const;
    const Description& operator[] (CORBA::ULong index) const;

    Description& operator[] (CORBA::ULong index);

    protected:
    _IDL_SEQUENCE_TEvent_Description_ptr* _indPtr;
    _IDL_SEQUENCE_TEvent_Description_ptr& _ptr;
    private:
    static _IDL_SEQUENCE_TEvent_Description_ptr* _newPtr ();
    _IDL_SEQUENCE_TEvent_Description_var &operator= (const CORBA::_var &IT_s);
    _IDL_SEQUENCE_TEvent_Description_var (const CORBA::_var &IT_s);
};

#endif


#endif

typedef _IDL_SEQUENCE_TEvent_Description Descriptions;
typedef const _IDL_SEQUENCE_TEvent_Description Descriptions_IT_const;

typedef _IDL_SEQUENCE_TEvent_Description_var Descriptions_var;


#ifndef TEvent_Value_Description_defined
#define TEvent_Value_Description_defined

struct Value_Description {
    CORBA::ULong item_id;
    CORBA::String_mgr formula;
    CORBA::Boolean state;

    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);
    Value_Description(const Value_Description &);
    Value_Description();
    ~Value_Description();
    Value_Description& operator= (const Value_Description&);
};

#ifndef TEvent_Value_DescriptionVarH
#define TEvent_Value_DescriptionVarH

#ifndef TEvent_Value_Description_ptrTypedefsNC
#define TEvent_Value_Description_ptrTypedefsNC
typedef Value_Description* Value_Description_ptr;
#endif

#ifndef TEvent_Value_Description_ptrTypedefs
#define TEvent_Value_Description_ptrTypedefs
typedef const Value_Description* Value_Description_cptr;
#endif

class Value_Description_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const Value_Description_var &IT_s);

    public:

    Value_Description_var (const Value_Description_var &IT_s);
    Value_Description_var ();
    Value_Description_var (Value_Description_ptr IT_p);
    Value_Description_var &operator= (Value_Description_ptr IT_p);
    Value_Description_var &operator= (const Value_Description_var &IT_s);
    ~Value_Description_var ();
    Value_Description_ptr operator-> () const;
    operator ! () const;
    operator Value_Description_ptr& () ;
    operator const Value_Description_cptr& () const;
    operator Value_Description& () const;

    const Value_Description in () const;
    Value_Description& inOut ();
    Value_Description*& out ();
    Value_Description* ret () const;
    protected:
    Value_Description_ptr* _indPtr;
    Value_Description_ptr& _ptr;
    private:
    static Value_Description_ptr* _newPtr ();
    Value_Description_var &operator= (const CORBA::_var &IT_s);
    Value_Description_var (const CORBA::_var &IT_s);
};

#endif


#endif


#ifndef TEvent__IDL_SEQUENCE_TEvent_Value_Description_defined
#define TEvent__IDL_SEQUENCE_TEvent_Value_Description_defined

class  _IDL_SEQUENCE_TEvent_Value_Description {
    CORBA::ULong _maximum;
    CORBA::ULong _length;
    Value_Description* _buffer;
    unsigned char _release;

    public:
    _IDL_SEQUENCE_TEvent_Value_Description& operator= (const _IDL_SEQUENCE_TEvent_Value_Description&);
    _IDL_SEQUENCE_TEvent_Value_Description (const _IDL_SEQUENCE_TEvent_Value_Description&);

    _IDL_SEQUENCE_TEvent_Value_Description (CORBA::ULong max);
    _IDL_SEQUENCE_TEvent_Value_Description (CORBA::ULong max, CORBA::ULong length, Value_Description* data, CORBA::Boolean release = 0);
    _IDL_SEQUENCE_TEvent_Value_Description ();

    ~_IDL_SEQUENCE_TEvent_Value_Description ();

    static Value_Description* CALL_SPEC allocbuf(CORBA::ULong nelems);
    static void CALL_SPEC freebuf(Value_Description* data);

    CORBA::ULong maximum() const;
    CORBA::ULong length() const;
    void length (CORBA::ULong len);

    Value_Description& operator [] (CORBA::ULong IT_i);

    const Value_Description& operator [] (CORBA::ULong IT_i) const;

    void assignbuf (CORBA::ULong max, CORBA::ULong length, Value_Description* data, CORBA::Boolean release = 0);
    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);
};

#ifndef TEvent__IDL_SEQUENCE_TEvent_Value_DescriptionVarH
#define TEvent__IDL_SEQUENCE_TEvent_Value_DescriptionVarH

#ifndef TEvent__IDL_SEQUENCE_TEvent_Value_Description_ptrTypedefsNC
#define TEvent__IDL_SEQUENCE_TEvent_Value_Description_ptrTypedefsNC
typedef _IDL_SEQUENCE_TEvent_Value_Description* _IDL_SEQUENCE_TEvent_Value_Description_ptr;
#endif

#ifndef TEvent__IDL_SEQUENCE_TEvent_Value_Description_ptrTypedefs
#define TEvent__IDL_SEQUENCE_TEvent_Value_Description_ptrTypedefs
typedef const _IDL_SEQUENCE_TEvent_Value_Description* _IDL_SEQUENCE_TEvent_Value_Description_cptr;
#endif

class _IDL_SEQUENCE_TEvent_Value_Description_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const _IDL_SEQUENCE_TEvent_Value_Description_var &IT_s);

    public:

    _IDL_SEQUENCE_TEvent_Value_Description_var (const _IDL_SEQUENCE_TEvent_Value_Description_var &IT_s);
    _IDL_SEQUENCE_TEvent_Value_Description_var ();
    _IDL_SEQUENCE_TEvent_Value_Description_var (_IDL_SEQUENCE_TEvent_Value_Description_ptr IT_p);
    _IDL_SEQUENCE_TEvent_Value_Description_var &operator= (_IDL_SEQUENCE_TEvent_Value_Description_ptr IT_p);
    _IDL_SEQUENCE_TEvent_Value_Description_var &operator= (const _IDL_SEQUENCE_TEvent_Value_Description_var &IT_s);
    ~_IDL_SEQUENCE_TEvent_Value_Description_var ();
    _IDL_SEQUENCE_TEvent_Value_Description_ptr operator-> () const;
    operator ! () const;
    operator _IDL_SEQUENCE_TEvent_Value_Description_ptr& () ;
    operator const _IDL_SEQUENCE_TEvent_Value_Description_cptr& () const;
    operator _IDL_SEQUENCE_TEvent_Value_Description& () const;

    const _IDL_SEQUENCE_TEvent_Value_Description in () const;
    _IDL_SEQUENCE_TEvent_Value_Description& inOut ();
    _IDL_SEQUENCE_TEvent_Value_Description*& out ();
    _IDL_SEQUENCE_TEvent_Value_Description* ret () const;
    const Value_Description& operator[] (CORBA::ULong index) const;

    Value_Description& operator[] (CORBA::ULong index);

    protected:
    _IDL_SEQUENCE_TEvent_Value_Description_ptr* _indPtr;
    _IDL_SEQUENCE_TEvent_Value_Description_ptr& _ptr;
    private:
    static _IDL_SEQUENCE_TEvent_Value_Description_ptr* _newPtr ();
    _IDL_SEQUENCE_TEvent_Value_Description_var &operator= (const CORBA::_var &IT_s);
    _IDL_SEQUENCE_TEvent_Value_Description_var (const CORBA::_var &IT_s);
};

#endif


#endif

typedef _IDL_SEQUENCE_TEvent_Value_Description Value_Descriptions;
typedef const _IDL_SEQUENCE_TEvent_Value_Description Value_Descriptions_IT_const;

typedef _IDL_SEQUENCE_TEvent_Value_Description_var Value_Descriptions_var;


#ifndef TEvent_Pattern_defined
#define TEvent_Pattern_defined

struct Pattern {
    CORBA::Boolean is_any;
    Domain_Repository::Unsigned_Long_Pattern item_id_pattern;
    Domain_Repository::String_Pattern formula;
    Domain_Repository::Boolean_Pattern state;

    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);
    Pattern(const Pattern &);
    Pattern();
    ~Pattern();
    Pattern& operator= (const Pattern&);
};

#ifndef TEvent_PatternVarH
#define TEvent_PatternVarH

#ifndef TEvent_Pattern_ptrTypedefsNC
#define TEvent_Pattern_ptrTypedefsNC
typedef Pattern* Pattern_ptr;
#endif

#ifndef TEvent_Pattern_ptrTypedefs
#define TEvent_Pattern_ptrTypedefs
typedef const Pattern* Pattern_cptr;
#endif

class Pattern_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const Pattern_var &IT_s);

    public:

    Pattern_var (const Pattern_var &IT_s);
    Pattern_var ();
    Pattern_var (Pattern_ptr IT_p);
    Pattern_var &operator= (Pattern_ptr IT_p);
    Pattern_var &operator= (const Pattern_var &IT_s);
    ~Pattern_var ();
    Pattern_ptr operator-> () const;
    operator ! () const;
    operator Pattern_ptr& () ;
    operator const Pattern_cptr& () const;
    operator Pattern& () const;

    const Pattern in () const;
    Pattern& inOut ();
    Pattern*& out ();
    Pattern* ret () const;
    protected:
    Pattern_ptr* _indPtr;
    Pattern_ptr& _ptr;
    private:
    static Pattern_ptr* _newPtr ();
    Pattern_var &operator= (const CORBA::_var &IT_s);
    Pattern_var (const CORBA::_var &IT_s);
};

#endif


#endif


#ifndef TEvent_Entity_Set_defined
#define TEvent_Entity_Set_defined

struct Entity_Set {
    private:

    Domain_Repository::Entity_Set_Criteria __d;
    union {
        Pattern * _s_pattern_;
        Domain_Repository::Repository_Item_Ids * _s_ids_;
        TEvents * _s_refs_;
    };

    public:

    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);

    private:

    unsigned char isSet;

    public:

    Domain_Repository::Entity_Set_Criteria _d () const { return __d; }

    Pattern& s_pattern () {
        return (*_s_pattern_);
    }

    const Pattern& s_pattern () const {
        return (*_s_pattern_);
    }

    void s_pattern (const Pattern& IT_member) {
        if (isSet && (__d != ::Domain_Repository::ESC_Pattern))
        {
            this-> Entity_Set::~Entity_Set();
            memset(this, 0, sizeof(*this));
        }

        __d = ::Domain_Repository::ESC_Pattern;

        if (!isSet) {
            _s_pattern_ = new Pattern;
            isSet = 1;
        }
        *(_s_pattern_) = IT_member;
    }

    Domain_Repository::Repository_Item_Ids& s_ids () {
        return (*_s_ids_);
    }

    const Domain_Repository::Repository_Item_Ids& s_ids () const {
        return (*_s_ids_);
    }

    void s_ids (Domain_Repository::Repository_Item_Ids IT_member) {
        if (isSet && (__d != ::Domain_Repository::ESC_Ids))
        {
            this-> Entity_Set::~Entity_Set();
            memset(this, 0, sizeof(*this));
        }

        __d = ::Domain_Repository::ESC_Ids;

        if (!isSet) {
            _s_ids_ = new Domain_Repository::Repository_Item_Ids;
            isSet = 1;
        }
        *(_s_ids_) = IT_member;
    }

    TEvents& s_refs () {
        return (*_s_refs_);
    }

    const TEvents& s_refs () const {
        return (*_s_refs_);
    }

    void s_refs (TEvents IT_member) {
        if (isSet && (__d != ::Domain_Repository::ESC_Refs))
        {
            this-> Entity_Set::~Entity_Set();
            memset(this, 0, sizeof(*this));
        }

        __d = ::Domain_Repository::ESC_Refs;

        if (!isSet) {
            _s_refs_ = new TEvents;
            isSet = 1;
        }
        *(_s_refs_) = IT_member;
    }

    Entity_Set(const Domain_Repository::Entity_Set_Criteria);

    Entity_Set();
    Entity_Set(const Entity_Set &);
    ~Entity_Set();
    Entity_Set& operator= (const Entity_Set&);
};

#ifndef TEvent_Entity_SetVarH
#define TEvent_Entity_SetVarH

#ifndef TEvent_Entity_Set_ptrTypedefsNC
#define TEvent_Entity_Set_ptrTypedefsNC
typedef Entity_Set* Entity_Set_ptr;
#endif

#ifndef TEvent_Entity_Set_ptrTypedefs
#define TEvent_Entity_Set_ptrTypedefs
typedef const Entity_Set* Entity_Set_cptr;
#endif

class Entity_Set_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const Entity_Set_var &IT_s);

    public:

    Entity_Set_var (const Entity_Set_var &IT_s);
    Entity_Set_var ();
    Entity_Set_var (Entity_Set_ptr IT_p);
    Entity_Set_var &operator= (Entity_Set_ptr IT_p);
    Entity_Set_var &operator= (const Entity_Set_var &IT_s);
    ~Entity_Set_var ();
    Entity_Set_ptr operator-> () const;
    operator ! () const;
    operator Entity_Set_ptr& () ;
    operator const Entity_Set_cptr& () const;
    operator Entity_Set& () const;

    const Entity_Set in () const;
    Entity_Set& inOut ();
    Entity_Set*& out ();
    Entity_Set* ret () const;
    protected:
    Entity_Set_ptr* _indPtr;
    Entity_Set_ptr& _ptr;
    private:
    static Entity_Set_ptr* _newPtr ();
    Entity_Set_var &operator= (const CORBA::_var &IT_s);
    Entity_Set_var (const CORBA::_var &IT_s);
};

#endif


#endif

#ifndef TEvent_Query_Results_defined
#define TEvent_Query_Results_defined

struct Query_Results {
    TEvents r_references;
    Descriptions r_descriptions;
    Value_Descriptions r_value_descriptions;
    Domain_Repository::Booleans r_attach_results;
    Domain_Repository::Booleans r_detach_results;
    Domain_Repository::Booleans r_valid_descriptions;
    Domain_Repository::Booleans r_valid_value_descriptions;

    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);
    Query_Results(const Query_Results &);
    Query_Results();
    ~Query_Results();
    Query_Results& operator= (const Query_Results&);
};

#ifndef TEvent_Query_ResultsVarH
#define TEvent_Query_ResultsVarH

#ifndef TEvent_Query_Results_ptrTypedefsNC
#define TEvent_Query_Results_ptrTypedefsNC
typedef Query_Results* Query_Results_ptr;
#endif

#ifndef TEvent_Query_Results_ptrTypedefs
#define TEvent_Query_Results_ptrTypedefs
typedef const Query_Results* Query_Results_cptr;
#endif

class Query_Results_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const Query_Results_var &IT_s);

    public:

    Query_Results_var (const Query_Results_var &IT_s);
    Query_Results_var ();
    Query_Results_var (Query_Results_ptr IT_p);
    Query_Results_var &operator= (Query_Results_ptr IT_p);
    Query_Results_var &operator= (const Query_Results_var &IT_s);
    ~Query_Results_var ();
    Query_Results_ptr operator-> () const;
    operator ! () const;
    operator Query_Results_ptr& () ;
    operator const Query_Results_cptr& () const;
    operator Query_Results& () const;

    const Query_Results in () const;
    Query_Results& inOut ();
    Query_Results*& out ();
    Query_Results* ret () const;
    protected:
    Query_Results_ptr* _indPtr;
    Query_Results_ptr& _ptr;
    private:
    static Query_Results_ptr* _newPtr ();
    Query_Results_var &operator= (const CORBA::_var &IT_s);
    Query_Results_var (const CORBA::_var &IT_s);
};

#endif


#endif

    virtual Description* descr (CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
        virtual Value_Description* value_descr (CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException, Domain_Repository::Destination_Unreachable);
    virtual Domain_Repository::Repository_Item_Id item_id (CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
    virtual TEventContext formula (CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
    virtual CORBA::Boolean state (CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
};

#ifndef TEventVarH
#define TEventVarH

#ifndef TEvent_ptrTypedefs
#define TEvent_ptrTypedefs
typedef const TEvent* TEvent_cptr;
#endif

class TEvent_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const TEvent_var &IT_s);
    unsigned char copyHelper (const TEvent_mgr &IT_s);
    unsigned char copyHelper (const TEvent_SeqElem &IT_s);

    public:

    TEvent_var (const TEvent_var &IT_s);
    TEvent_var (const TEvent_mgr &IT_s);
    TEvent_var (const TEvent_SeqElem &IT_s);
    TEvent_var ();
    TEvent_var (TEvent_ptr IT_p);
    TEvent_var &operator= (TEvent_ptr IT_p);
    TEvent_var &operator= (const TEvent_var &IT_s);
    TEvent_var &operator= (const TEvent_mgr &IT_s);
    TEvent_var &operator= (const TEvent_SeqElem &IT_s);
    ~TEvent_var ();
    TEvent_ptr operator-> () const;
    operator ! () const;
    operator TEvent_ptr& () ;
    operator const TEvent_cptr& () const;

    operator CORBA::Object_ptr () const;
    TEvent_ptr in () const;
    TEvent_ptr& inOut ();
    TEvent_ptr& out ();
    TEvent_ptr ret () const;
    protected:
    TEvent_ptr* _indPtr;
    TEvent_ptr& _ptr;
    private:
    static TEvent_ptr* _newPtr ();
    TEvent_var &operator= (const CORBA::_var &IT_s);
    TEvent_var (const CORBA::_var &IT_s);
};

#endif



#define TIE_TEvent(X) TEvent##X

#define DEF_TIE_TEvent(X) \
	class TEvent##X : public virtual TEvent {		\
	  X* m_obj;						\
	public:							\
								\
								\
	   TEvent##X  (X *objp, const char* m="", CORBA::LoaderClass *l=0)\
		: TEvent(), m_obj(objp) {	\
		m_pptr = new TEvent_dispatch		\
			(( TEvent*)this,(CORBA::Object*)this,m,l,TEvent_IR,m_obj);	\
	   }								\
	   TEvent##X  (CORBA::Object *IT_p, const char* IT_m="", void *IT_q=0)\
		: TEvent() {	\
		m_pptr = new TEvent_dispatch		\
			(( TEvent*)this,(CORBA::Object*)this,IT_m,TEvent_IR,IT_p,IT_q);	\
		m_obj = (X*)(m_pptr->getImplObj ());			\
	   }								\
								\
	   virtual ~TEvent##X  () {				\
		if (_okToDeleteImpl ()) delete m_obj; }					\
	   virtual void* _deref () {					\
		return m_obj; }					\
								\
virtual TEvent_Data_Observed_E::TEvent_Data_Observers* tevent_data_observer_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->tevent_data_observer_list(IT_env); \
}\
	\
virtual void attach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->attach_tevent_data_observer (  obs,IT_env);\
}\
	\
virtual void detach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Observer){\
m_obj->detach_tevent_data_observer (  obs,IT_env);\
}\
virtual TEvent::Description* descr (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->descr(IT_env); \
}\
	\
virtual TEvent::Value_Description* value_descr (CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Destination_Unreachable){\
return m_obj->value_descr (IT_env);\
}\
	\
virtual Domain_Repository::Repository_Item_Id item_id (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->item_id(IT_env); \
}\
	\
virtual TEvent::TEventContext formula (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->formula(IT_env); \
}\
	\
virtual CORBA::Boolean state (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->state(IT_env); \
}\
								\
	};						\


#define QUALS_TEvent	\
virtual TEvent_Data_Observed_E::TEvent_Data_Observers* tevent_data_observer_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->tevent_data_observer_list(IT_env); \
}\
	\
virtual void attach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->attach_tevent_data_observer (  obs,IT_env);\
}\
	\
virtual void detach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Observer){\
m_obj->detach_tevent_data_observer (  obs,IT_env);\
}\
virtual TEvent::Description* descr (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->descr(IT_env); \
}\
	\
virtual TEvent::Value_Description* value_descr (CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Destination_Unreachable){\
return m_obj->value_descr (IT_env);\
}\
	\
virtual Domain_Repository::Repository_Item_Id item_id (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->item_id(IT_env); \
}\
	\
virtual TEvent::TEventContext formula (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->formula(IT_env); \
}\
	\
virtual CORBA::Boolean state (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->state(IT_env); \
}\




class TEventProxyFactoryClass : public virtual TEvent_Data_Observed_EProxyFactoryClass {
public:
   TEventProxyFactoryClass (unsigned char IT_p=0)
		: CORBA::ProxyFactory (TEvent_IR, IT_p) {}

    virtual void* New (char *IT_OR, CORBA::Environment&);

    virtual void* New (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual void* New2 (); 

    virtual CORBA::Object* NewObject (char *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* New2Object (); 

    virtual void* IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());

    virtual CORBA::PPTR* pptr (void *IT_p);

    virtual void baseInterfaces (_IDL_SEQUENCE_string&);


};

extern TEventProxyFactoryClass TEventProxyFactory;

#endif


#endif
