

#include "tevent_data_observed_r.hh"


#define TEvent_Data_Observed_R_dispatch_impl

unsigned char TEvent_Data_Observed_R_dispatch::dispatch (CORBA::Request &IT_r, 
 unsigned char IT_isTarget, void *IT_pp) {
    if (!IT_pp)
       IT_pp = m_obj;
    const char *IT_s = IT_r.getOperation ();
    if (!strcmp (IT_s,"_get_tevent_data_observer_list")) {
        TEvent_Data_Observed_R::Observer_Entries* tevent_data_observer_list;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~_get_tevent_data_observer_list~>{S{R~TEvent_Data_Observed_R::Observer_Entry~obs{O~TEvent_Data_Observer},interest{S{ul},0}},0},N{}\
"))
            return 1;
        if (IT_f)
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                tevent_data_observer_list = ((TEvent_Data_Observed_R*)IT_pp)->tevent_data_observer_list(IT_env);
            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
S{R~TEvent_Data_Observed_R::Observer_Entry~obs{O~TEvent_Data_Observer},interest{S{ul},0}},0\
", IT_env)) return 1;
            if (!tevent_data_observer_list) {
                IT_r.makeRuntimeException6 ();
                return 1;
            }
            else

            (*tevent_data_observer_list).encodeOp (IT_r);
            delete tevent_data_observer_list;
        }
        else IT_r.makeSystemException (IT_env);

        return 1;
    }

    if (!strcmp (IT_s,"_get_add_tevent_data_observer_list")) {
        TEvent_Data_Observed_E::TEvent_Data_Observers* add_tevent_data_observer_list;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~_get_add_tevent_data_observer_list~>{S{O~TEvent_Data_Observer},0},N{}\
"))
            return 1;
        if (IT_f)
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                add_tevent_data_observer_list = ((TEvent_Data_Observed_R*)IT_pp)->add_tevent_data_observer_list(IT_env);
            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
S{O~TEvent_Data_Observer},0\
", IT_env)) return 1;
            if (!add_tevent_data_observer_list) {
                IT_r.makeRuntimeException6 ();
                return 1;
            }
            else

            (*add_tevent_data_observer_list).encodeOp (IT_r);
            delete add_tevent_data_observer_list;
        }
        else IT_r.makeSystemException (IT_env);

        return 1;
    }

    if (!strcmp(IT_s,"attach_tevent_data_observer")) {
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~attach_tevent_data_observer~>{v},N{}\
"))
            return 1;
        TEvent_Data_Observer_ptr obs;

        obs = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);

        Domain_Repository::Repository_Item_Ids observed_id_list;

        observed_id_list.decodeOp (IT_r);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                ((TEvent_Data_Observed_R*)IT_pp)->attach_tevent_data_observer (  obs,   observed_id_list, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }
        if (obs) TEvent_Data_Observer_release (obs);


        if (!IT_r.isException (IT_env)) {
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {

                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {

                    break;
                }
            }
            if (!IT_r.convertToReply ("\
v\
", IT_env)) return 1;
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Unknown_Repository_Item_Ids)) {
                ((Domain_Repository::Unknown_Repository_Item_Ids*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if (!strcmp(IT_s,"detach_tevent_data_observer")) {
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~detach_tevent_data_observer~>{v},N{}\
"))
            return 1;
        TEvent_Data_Observer_ptr obs;

        obs = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);

        Domain_Repository::Repository_Item_Ids observed_id_list;

        observed_id_list.decodeOp (IT_r);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                ((TEvent_Data_Observed_R*)IT_pp)->detach_tevent_data_observer (  obs,   observed_id_list, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }
        if (obs) TEvent_Data_Observer_release (obs);


        if (!IT_r.isException (IT_env)) {
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {

                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {

                    break;
                }
            }
            if (!IT_r.convertToReply ("\
v\
", IT_env)) return 1;
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Unknown_Repository_Item_Ids)) {
                ((Domain_Repository::Unknown_Repository_Item_Ids*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Unknown_Observer)) {
                ((Domain_Repository::Unknown_Observer*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Unmatched_Observer_Item_Ids)) {
                ((Domain_Repository::Unmatched_Observer_Item_Ids*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if (!strcmp(IT_s,"attach_add_tevent_data_observer")) {
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~attach_add_tevent_data_observer~>{v},N{}\
"))
            return 1;
        TEvent_Data_Observer_ptr obs;

        obs = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                ((TEvent_Data_Observed_R*)IT_pp)->attach_add_tevent_data_observer (  obs, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }
        if (obs) TEvent_Data_Observer_release (obs);
        IT_r.replyNoResults (IT_env);
        return 1;
    }

    if (!strcmp(IT_s,"detach_add_tevent_data_observer")) {
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~detach_add_tevent_data_observer~>{v},N{}\
"))
            return 1;
        TEvent_Data_Observer_ptr obs;

        obs = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                ((TEvent_Data_Observed_R*)IT_pp)->detach_add_tevent_data_observer (  obs, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }
        if (obs) TEvent_Data_Observer_release (obs);

        if (!IT_r.isException (IT_env)) {
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {
                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {
                    break;
                }
            }
            if (!IT_r.convertToReply ("\
v\
", IT_env)) return 1;
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Unknown_Observer)) {
                ((Domain_Repository::Unknown_Observer*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if (IT_isTarget)
        IT_r.makeRuntimeException2 ();

    return 0;
}

#include "tevent_data_observed_rC.cc"

