

#include "tevent_rep.hh"


#define TEvent_Rep_dispatch_impl

unsigned char TEvent_Rep_dispatch::dispatch (CORBA::Request &IT_r, 
 unsigned char IT_isTarget, void *IT_pp) {
    if (!IT_pp)
       IT_pp = m_obj;
    const char *IT_s = IT_r.getOperation ();
    if (!strcmp(IT_s,"find")) {
        TEvents* IT_result;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~find~>{S{O~TEvent},0},N{}\
"))
            return 1;
        TEvent::Pattern data_record_pattern;

        data_record_pattern.decodeOp (IT_r);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                	IT_result = ((TEvent_Rep*)IT_pp)->find (  data_record_pattern, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
S{O~TEvent},0\
", IT_env)) return 1;
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {
                    (*(IT_result)).encodeOp (IT_r);
                    delete IT_result;
                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {
                    (*(IT_result)).encodeOp (IT_r);
                    delete IT_result;
                    break;
                }
            }
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Search_Not_Implemented)) {
                ((Domain_Repository::Search_Not_Implemented*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Destination_Unreachable)) {
                ((Domain_Repository::Destination_Unreachable*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if (!strcmp(IT_s,"find_values")) {
        TEvent::Value_Descriptions* IT_result;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~find_values~>{S{R~TEvent::Value_Description~item_id{ul},formula{0},state{b}},0},N{}\
"))
            return 1;
        TEvent::Pattern data_record_pattern;

        data_record_pattern.decodeOp (IT_r);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                	IT_result = ((TEvent_Rep*)IT_pp)->find_values (  data_record_pattern, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
S{R~TEvent::Value_Description~item_id{ul},formula{0},state{b}},0\
", IT_env)) return 1;
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {
                    (*(IT_result)).encodeOp (IT_r);
                    delete IT_result;
                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {
                    (*(IT_result)).encodeOp (IT_r);
                    delete IT_result;
                    break;
                }
            }
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Search_Not_Implemented)) {
                ((Domain_Repository::Search_Not_Implemented*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Destination_Unreachable)) {
                ((Domain_Repository::Destination_Unreachable*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if (!strcmp(IT_s,"complex_query")) {
        TEvent::Query_Results* IT_result;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        IT_r.tcPreAssert (
"\
Ro~complex_query~>{R~TEvent::Query_Results~r_references{S{O~TEvent},0},r_descriptions{S{R~TEvent::Description~item_id{ul},formula{0},state{b}},0},r_value_descriptions{S{R~TEvent::Value_Description~item_id{ul},formula{0},state{b}},0},r_attach_results{S{b}\
");
        if (!IT_r.tcAssert ("\
,0},r_detach_results{S{b},0},r_valid_descriptions{S{b},0},r_valid_value_descriptions{S{b},0}},N{}\
"))
            return 1;
        TEvent::Entity_Set es;

        es.decodeOp (IT_r);

        Domain_Repository::Query_Options qo;

        qo.decodeOp (IT_r);

        TEvent_Data_Observer_ptr obs;

        obs = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                	IT_result = ((TEvent_Rep*)IT_pp)->complex_query (  es,   qo,   obs, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }


        if (obs) TEvent_Data_Observer_release (obs);

        if (!IT_r.isException (IT_env)) {
            IT_r.preConvertToReply (
"\
R~TEvent::Query_Results~r_references{S{O~TEvent},0},r_descriptions{S{R~TEvent::Description~item_id{ul},formula{0},state{b}},0},r_value_descriptions{S{R~TEvent::Value_Description~item_id{ul},formula{0},state{b}},0},r_attach_results{S{b},0},r_detach_result\
");
            if (!IT_r.convertToReply ("\
s{S{b},0},r_valid_descriptions{S{b},0},r_valid_value_descriptions{S{b},0}\
", IT_env)) return 1;
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {
                    (*(IT_result)).encodeOp (IT_r);
                    delete IT_result;


                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {


                    (*(IT_result)).encodeOp (IT_r);
                    delete IT_result;
                    break;
                }
            }
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Search_Not_Implemented)) {
                ((Domain_Repository::Search_Not_Implemented*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Destination_Unreachable)) {
                ((Domain_Repository::Destination_Unreachable*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if  (
        TEvent_Data_Observed_R_dispatch::dispatch
                (
                IT_r,
                0,
                (TEvent_Data_Observed_R*)((TEvent_Rep*)IT_pp)
                )
        )
    {
        return 1;
    }

    if (IT_isTarget)
        IT_r.makeRuntimeException2 ();

    return 0;
}

#include "tevent_repC.cc"

